<?php

/*
 * Plugin: Records Eyepiece
 * ~~~~~~~~~~~~~~~~~~~~~~~~
 * Based upon the idea and functionality of FuFi.Widgets (0.80b) with some extra
 * features, speed-ups and a nicer look and feel. It replaces the Fufi.Widgets completely,
 * so if you install this Plugin, make sure you disable the Fufi.Widgets!
 * For details see Install.txt
 *
 * NOTE:
 *  - Works only with XASECO/1.12!
 *  - Works only with TMF!
 *  - Comes WITHOUT integrated Karma-Feature, just use the tm-karma.com Plugin instead.
 * ----------------------------------------------------------------------------------
 * Author:	undef.de
 * Version:	0.9.5
 * Date:	2011-01-02
 * Copyright:	2009 - 2010 by undef.de
 * Home:	http://www.undef.de/Trackmania/Plugins/
 * System:	xaseco/1.12 and up
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 *
 * Dependencies:
 *  - plugins/plugin.localdatabase.php		Required, for Datasbase access and Local-Records-Widget
 *  - plugins/plugin.tmxinfo.php		Required, for Challenge-Widget, TMX-Track-Info-Window and <placement>-Placeholder
 *  - plugins/plugin.rasp_jukebox.php		Required, for TracklistWindow
 *  - plugins/plugin.dedimania.php		Required, only if you want the Dedimania-Widget
 *  - plugins/plugin.gerymania.php		Required, only if you want the Gerymania-Widget (only for Gamemode 'Stunts'. Get it here: http://www.tm-forum.com/viewtopic.php?f=127&t=27398)
 *  - plugins/plugin.donate.php			Required, only if you want the TopDonators
 *  - plugins/plugin.musicserver.php		Required, only if you want the Music-Widget
 *  - plugins/plugin.nouse.betting.php		Required, only if you want the Betwins-Widget at Score. Get it here: http://www.tm-forum.com/viewtopic.php?t=23511
 *  - plugins/plugin.tm-karma-dot-com.php	Recommended, useful if you want to have the Karma-Widget
 *  - plugins/plugin.alternate_scoretable.php	Recommended, useful for Live-Rankings. Get it here: http://www.tm-forum.com/viewtopic.php?f=127&t=26138
 */

/* The following manialink id's are used in this plugin (the 918 part of id can be changed on trouble):
 *
 * ManialinkID's
 * ~~~~~~~~~~
 * 91800			id for manialink Window(s)
 * 91801			id for manialink ActionKeys (F7)
 * 91802			id for manialink PlacementWidget ('race')
 * 91803			id for manialink PlacementWidget ('score')
 * 91804			id for manialink PlacementWidget ('always')
 * 91805			id for manialink ChallengeWidget
 * 91806			id for manialink ClockWidget
 * 91807			id for manialink GamemodeWidget
 * 91808			id for manialink VisitorsWidget
 * 91809			id for manialink TrackcountWidget
 * 91810			id for manialink ToplistWidget
 * 91811			id for manialink DedimaniaRecordsWidget (at all Gamemodes, except 'Stunts')
 * 91812			id for manialink LocalRecordsWidget (at all Gamemodes)
 * 91813			id for manialink LiveRankingsWidget (at all Gamemodes, but not at Score)
 * 91814			id for manialink GerymaniaRcordsWidget (only at Gamemode 'Stunts' then it replace Dedimania)
 * 91815			id for manialink DedimaniaRecordsWidget (at Score, except 'Stunts')
 * 91816			id for manialink LocalRecordsWidget (at Score)
 * 91817			id for manialink GerymaniaRecordsWidget (at Score, only at Gamemode 'Stunts' then it replace Dedimania)
 * 91818			id for manialink TopRankings (at Score)
 * 91819			id for manialink TopWinners (at Score)
 * 91820			id for manialink MostRecords (at Score)
 * 91821			id for manialink MostFinished (at Score)
 * 91822			id for manialink TopPlaytime (at Score)
 * 91823			id for manialink TopDonators (at Score)
 * 91824			id for manialink TopNations (at Score)
 * 91825			id for manialink TopTracks (at Score)
 * 91826			id for manialink TopVoters (at Score)
 * 91827			id for manialink TopBetwins (at Score)
 * 91830			id for manialink MusicWidget
 * 918100 to 918120		id for manialink ImagePreload
 *
 * ActionID's
 * ~~~~~~~~~~
 *  382009003			id for action pressed Key F7 to toggle Widget (same ManialinkId as plugin.fufi.widgets.php for compatibility with other Plugins)
 *  91800			id for action close Window
 *  91801			id for action for ChallengeWidget maximize
 *  91802			id for action for ChallengeWidget minimize (default)
 *  91803			id for action for show ClockDetailsWindow
 *  91804			id for action for show DedimaniaRecordsWindow
 *  91805			id for action for show LocalRecordsWindow
 *  91806			id for action for show LiveRankingsWindow
 *  91807			id for action for show GerymaniaRecordsWindow
 *  91808			id for action for show TMXChallengeInfoWindow
 *  91809			id for action for show TopNationsWindow
 *  91810			id for action for show TopRankingsWindow
 *  91811			id for action for show TopWinnersWindow
 *  91812			id for action for show MostRecordsWindow
 *  91813			id for action for show MostFinishedWindow
 *  91814			id for action for show TopPlaytimeWindow
 *  91815			id for action for show TopDonatorsWindow
 *  91816			id for action for show TopTracksWindow
 *  91817			id for action for show TopVotersWindow
 *  91818			id for action for show MusiclistWindow
 *  91819			id for action drop current juke´d song (MusiclistWindow)
 *  91820			id for action for show TracklistWindow
 *  91821			id for action for show TracklistFilterWindow
 *  91822			id for action for filter only 'Stadium' Tracks
 *  91823			id for action for filter only 'Bay' Tracks
 *  91824			id for action for filter only 'Coast' Tracks
 *  91825			id for action for filter only 'Desert'/'Speed' Tracks
 *  91826			id for action for filter only 'Island' Tracks
 *  91827			id for action for filter only 'Rally' Tracks
 *  91828			id for action for filter only 'Alpine'/'Snow' Tracks
 *  91829  to 91838		UNUSED BUT RESERVED (for Filteroptions)
 *  91839			id for action for no filtering, display all Tracks (without getting the local records again)
 *  91840			id for action for filter only jukeboxed Tracks
 *  91841			id for action for filter only no recent Tracks
 *  91842			id for action for filter only recent Tracks
 *  91843			id for action for filter only Tracks without a rank
 *  91844			id for action for filter only Tracks with a rank
 *  91845			id for action for filter only Tracks no gold time
 *  91846			id for action for filter only Tracks no author time
 *  91847			id for action for filter only Tracks with mood sunrise
 *  91848			id for action for filter only Tracks with mood day
 *  91849			id for action for filter only Tracks with mood sunset
 *  91850			id for action for filter only Tracks with mood night
 *  91851			id for action for filter only multilap Tracks
 *  91852			id for action for filter only no multilap Tracks
 *  91853			id for action for filter only Tracks no silver time
 *  91854			id for action for filter only Tracks no bronze time
 *  91855			id for action for filter (unimplemented right now)
 *  91856			id for action for show the TrackauthorlistWindow
 *  91857  to  91899		UNUSED BUT RESERVED (for Filteroptions)
 * -918100 to -918149		id for action LocalRecordsWindow previous page in Table (max. 50 pages a 100 entries = 5000 total)
 *  918100 to  918149		id for action LocalRecordsWindow next page in Table (max. 50 pages a 100 entries = 5000 total)
 * -918150 to -918152		id for action LiveRankingsWindow previous page in Table (max. 3 pages a 100 entries = 300 total)
 *  918150 to  918152		id for action LiveRankingsWindow next page in Table (max. 3 pages a 100 entries = 300 total)
 *  918153			id for action for show ToplistWindow
 *  918154			id for action for show TopBetwinsWindow
 * -918160			id for action HelpWindow previous page in Table (max. 2 pages)
 *  918160			id for action HelpWindow next page in Table (max. 2 pages)
 *  918161 to  918199		UNUSED BUT RESERVED
 * -918200 to -918294		id for action MusiclistWindow previous page in Table (max. 95 pages a 20 entries = 1900 total)
 *  918200 to  918294		id for action MusiclistWindow next page in Table (max. 95 pages a 20 entries = 1900 total)
 *  918300 to  918349		id for action of selection of a timezone-group (same order as in $re_config['Timezones'] declared below = 50 total)
 *  918350 to  918999		id for action of selection of a timezone (same order as in $re_config['Timezones'] declared below = 650 total)
 * -9181000 to -9181249		id for action TracklistWindow previous page in Table (max. 250 pages a 20 entries = 5000 total)
 *  9181000 to  9181249		id for action TracklistWindow next page in Table (max. 250 pages a 20 entries = 5000 total)
 *  9182000 to  9186999		id for action add a Track from the TracklistWindow to the Jukebox (max. 5000 Tracks total)
 * -9187000 to -9187249		id for action TrackauthorlistWindow previous page in Table (max. 250 pages a 20 entries = 5000 total)
 *  9187000 to  9187249		id for action TrackauthorlistWindow next page in Table (max. 250 pages a 20 entries = 5000 total)
 * -9188000 to -91812999	id for action select an Author from the TrackauthorlistWindow to filter (max. 5000 Authors total)
 */

Aseco::registerEvent('onSync',				're_onSync');
Aseco::registerEvent('onPlayerConnect',			're_onPlayerConnect');
Aseco::registerEvent('onPlayerDisconnect',		're_onPlayerDisconnect');		// throw 'player disconnects' event
Aseco::registerEvent('onPlayerFinish',			're_onPlayerFinish');
Aseco::registerEvent('onPlayerWins',			're_onPlayerWins');			// throw 'player wins' event
Aseco::registerEvent('onPlayerManialinkPageAnswer',	're_onPlayerManialinkPageAnswer');
Aseco::registerEvent('onDedimaniaRecord',		're_onDedimaniaRecord');		// throw dedimania record event
Aseco::registerEvent('onGerymaniaRecord',		're_onGerymaniaRecord');		// throw gerymania record event
Aseco::registerEvent('onLocalRecord',			're_onLocalRecord');			// throw local record event
Aseco::registerEvent('onStatusChangeTo3',		're_onStatusChangeTo3');
Aseco::registerEvent('onBeginRound',			're_onBeginRound');
Aseco::registerEvent('onEndRound',			're_onEndRound');
Aseco::registerEvent('onNewChallenge',			're_onNewChallenge');			// throw main 'begin challenge' event
Aseco::registerEvent('onNewChallenge2',			're_onNewChallenge2');			// throw additional 'begin challenge' event
Aseco::registerEvent('onRestartChallenge2',		're_onRestartChallenge2');		// throw postfix 'restart challenge' event (refresh GameInfo)
Aseco::registerEvent('onEndRace1',			're_onEndRace1');			// throw pre event for chat-based votes
Aseco::registerEvent('onEverySecond',			're_onEverySecond');
Aseco::registerEvent('onKarmaChange',			're_onKarmaChange');
Aseco::registerEvent('onDonation',			're_onDonation');
Aseco::registerEvent('onJukeboxChanged',		're_onJukeboxChanged');
Aseco::registerEvent('onMusicboxReloaded',		're_onMusicboxReloaded');

Aseco::addChatCommand('togglewidgets',			'Toggle the display of the Records-Eyepiece widgets (see: /eyepiece)');
Aseco::addChatCommand('eyepiece',			'Displays the help for the Records-Eyepiece widgets (see: /eyepiece)');
Aseco::addChatCommand('elist',				'Lists tracks currently on the server (see: /eyepiece)');
Aseco::addChatCommand('emusic',				'Lists musics currently on the server (see: /eyepiece)');

Aseco::addChatCommand('eyeset',				'Adjust some setting for the Records-Eyepiece plugin (see: /eyepiece)', true);

global $re_config, $re_scores, $re_cache;

/* Just a note for my editor -> utf-8 äöüß */

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onSync
function re_onSync ($aseco) {
	global $re_config, $re_scores, $re_cache;


	// Check for the right XASECO-Version
	$xaseco_min_version = 1.12;
	if ( defined('XASECO_VERSION') ) {
		if ( version_compare(XASECO_VERSION, $xaseco_min_version, '<') ) {
			trigger_error('[plugin.plugin.records_eyepiece.php] Not supported xaseco version ('. XASECO_VERSION .')! Please update to min. version '. $xaseco_min_version .'!', E_USER_ERROR);
		}
	}
	else {
		trigger_error('[plugin.plugin.records_eyepiece.php] Can not identify the System, "XASECO_VERSION" is unset! This plugin runs only with XASECO/'. $xaseco_min_version .' and up.', E_USER_ERROR);
	}

	if ($aseco->server->getGame() != 'TMF') {
		trigger_error('[plugin.plugin.records_eyepiece.php] This plugin supports only TMF, can not start with a "'. $aseco->server->getGame() .'" Dedicated-Server!', E_USER_ERROR);
	}


	// Read Configuration
	if (!$re_config = $aseco->xml_parser->parseXML('records_eyepiece.xml')) {
		trigger_error('[plugin.records_eyepiece.php] Could not read/parse config file "records_eyepiece.xml"!', E_USER_ERROR);
	}
	$re_config = $re_config['RECORDS_EYEPIECE'];


	// Static settings
	$re_config['ManialinkId'] = '918';
	$re_config['Version'] = '0.9.5';
	$re_config['LineHeight'] = 1.8;


	// Transform 'TRUE' or 'FALSE' from string to boolean
	$re_config['CHALLENGE_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['CHALLENGE_WIDGET'][0]['ENABLED'][0]) == 'TRUE')			? true : false);
	$re_config['WELCOME_WINDOW'][0]['ENABLED'][0]				= ((strtoupper($re_config['WELCOME_WINDOW'][0]['ENABLED'][0]) == 'TRUE')				? true : false);
	$re_config['CLOCK_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['CLOCK_WIDGET'][0]['ENABLED'][0]) == 'TRUE')				? true : false);
	$re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0]) == 'TRUE')			? true : false);
	$re_config['VISITORS_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['VISITORS_WIDGET'][0]['ENABLED'][0]) == 'TRUE')			? true : false);
	$re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0]			= ((strtoupper($re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0]) == 'TRUE')			? true : false);
	$re_config['MUSIC_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['MUSIC_WIDGET'][0]['ENABLED'][0]) == 'TRUE')				? true : false);
	$re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0]				= ((strtoupper($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0]) == 'TRUE')			? true : false);
	$re_config['NICEMODE'][0]['ENABLED'][0]					= ((strtoupper($re_config['NICEMODE'][0]['ENABLED'][0]) == 'TRUE')				? true : false);
	$re_config['NICEMODE'][0]['FORCE'][0]					= ((strtoupper($re_config['NICEMODE'][0]['FORCE'][0]) == 'TRUE')				? true : false);
	$re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0]		= ((strtoupper($re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0]) == 'TRUE')		? true : false);
	$re_config['FEATURES'][0]['SORT_SONGLIST'][0]				= ((strtoupper($re_config['FEATURES'][0]['SORT_SONGLIST'][0]) == 'TRUE')			? true : false);
	$re_config['FEATURES'][0]['SORT_TRACKLIST'][0]				= ((strtoupper($re_config['FEATURES'][0]['SORT_TRACKLIST'][0]) == 'TRUE')			? true : false);
	$re_config['WINDOW_STYLE'][0]['LIGHTBOX'][0]['ENABLED'][0]		= ((strtoupper($re_config['WINDOW_STYLE'][0]['LIGHTBOX'][0]['ENABLED'][0]) == 'TRUE')		? true : false);
	$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['DISPLAY'][0]	= ((strtoupper($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['DISPLAY'][0]) == 'AVERAGE')	? true : false);

	$widgets = array('DEDIMANIA_RECORDS', 'GERYMANIA_RECORDS', 'LOCAL_RECORDS', 'LIVE_RANKINGS');
	$gamemodes = array(
		'ROUNDS'	=> 0,
		'TIME_ATTACK'	=> 1,
		'TEAM'		=> 2,
		'LAPS'		=> 3,
		'STUNTS'	=> 4,
		'CUP'		=> 5,
	);

	// RecordWidgets like Dedimania, Gerymania...
	foreach ($gamemodes as $gamemode => &$id) {
		foreach ($widgets as &$widget) {
			if ( isset($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0]) ) {
				$re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] = ((strtoupper($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0]) == 'TRUE') ? true : false);

				// Topcount are required to be lower then entries
				if ( (isset($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0])) && (isset($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0])) ) {
					if ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0] >= $re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]) {
						$re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0] = $re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0] - 1;
					}
				}
			}
			else {
				// Auto disable this
				$re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] = false;
			}
		}
	}

	// Special checks for <rounds>
	if ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['ROUNDS'][0]['ENABLED'][0] == true) {
		$re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['ROUNDS'][0]['DISABLE_ROUND_SCORES'][0]	= ((strtoupper($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['ROUNDS'][0]['DISABLE_ROUND_SCORES'][0]) == 'TRUE')	? true : false);
		$re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['ROUNDS'][0]['DISPLAY_TYPE'][0]		= ((strtoupper($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['ROUNDS'][0]['DISPLAY_TYPE'][0]) == 'TIME')		? true : false);
		$re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['LAPS'][0]['DISPLAY_TYPE'][0]		= ((strtoupper($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0]['LAPS'][0]['DISPLAY_TYPE'][0]) == 'TIME')			? true : false);
	}

	// NiceMode and all records Scoretable-Lists
	foreach ($widgets as &$widget) {
		if ( isset($re_config['NICEMODE'][0]['ALLOW'][0][$widget][0]) ) {
			$re_config['NICEMODE'][0]['ALLOW'][0][$widget][0] = ((strtoupper($re_config['NICEMODE'][0]['ALLOW'][0][$widget][0]) == 'TRUE') ? true : false);
		}
		if ( isset($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0]) ) {
			$re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0] = ((strtoupper($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0]) == 'TRUE') ? true : false);
		}
	}

	// All other Scoretable-Lists
	$scorelists = array('TOP_RANKINGS', 'TOP_WINNERS', 'MOST_RECORDS', 'MOST_FINISHED', 'TOP_PLAYTIME', 'TOP_DONATORS', 'TOP_NATIONS', 'TOP_TRACKS', 'TOP_VOTERS', 'TOP_BETWINS');
	foreach ($scorelists as &$widget) {
		if ( isset($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0]) ) {
			$re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0] = ((strtoupper($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0]) == 'TRUE') ? true : false);
		}
		else {
			// Auto disable this
			$re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0] = false;
		}
	}
	unset($scorelists);


	// Check the required Plugins and if one is not installed, trigger_error()
	$dedimania = false;
	$gerymania = false;
	foreach ($gamemodes as $gamemode => &$id) {
		foreach ($widgets as &$widget) {
			if ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) {
				if ($widget == 'DEDIMANIA_RECORDS') {
					$dedimania = true;
				}
				else if ($widget == 'GERYMANIA_RECORDS') {
					$gerymania = true;
				}
			}
			// Check at Scoretable-Lists
			if ( (isset($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0])) && ($re_config['SCORETABLE_LISTS'][0][$widget][0]['ENABLED'][0] == true) ) {
				if ($widget == 'DEDIMANIA_RECORDS') {
					$dedimania = true;
				}
				else if ($widget == 'GERYMANIA_RECORDS') {
					$gerymania = true;
				}
			}
		}
	}
	$required = array(
		'plugin.localdatabase.php'	=> array('status' => true, 'position' => 0),
		'plugin.tmxinfo.php'		=> array('status' => true, 'position' => 0),
		'plugin.rasp_jukebox.php'	=> array('status' => true, 'position' => 0),
		'plugin.musicserver.php'	=> array('status' => $re_config['MUSIC_WIDGET'][0]['ENABLED'][0], 'position' => 0),
		'plugin.donate.php'		=> array('status' => $re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENABLED'][0], 'position' => 0),
		'plugin.nouse.betting.php'	=> array('status' => $re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ENABLED'][0], 'position' => 0),
		'plugin.dedimania.php'		=> array('status' => $dedimania, 'position' => 0),
		'plugin.gerymania.php'		=> array('status' => $gerymania, 'position' => 0)
	);
	foreach ($required as $plugin => &$state) {
		if ($state['status'] == false) {
			// Not required, skip check
			continue;
		}
		foreach ($aseco->plugins as &$installed_plugin) {
			if ($plugin == $installed_plugin) {
				// Found, skip to next plugin
				continue 2;
			}
			$state['position'] ++;
		}
		trigger_error('[plugin.records_eyepiece.php] Unmet requirements! With your current configuration you need to activate "'. $plugin .'" in your "plugins.xml" to run this Plugin!', E_USER_ERROR);
	}

	// Check the right order of the required Plugins, this required to be the last entry in plugins.xml
	$eyepiece_position = 0;
	foreach ($aseco->plugins as &$plugin) {
		if ($plugin == 'plugin.records_eyepiece.php') {
			break;
		}
		$eyepiece_position ++;
	}
	foreach ($required as $plugin => &$state) {
		if ($state['status'] == false) {
			// Not required, skip check
			continue;
		}
		if ($state['position'] > $eyepiece_position) {
			trigger_error('[plugin.records_eyepiece.php] This Plugin must placed behind "'. $plugin .'", otherwise you can see mysterious results!', E_USER_ERROR);
		}
	}
	unset($dedimania, $gerymania, $required, $eyepiece_position);
	// If we reached this point, all requirements are fulfilled


	// Translate e.g. 'rounds' to id '0', 'time_attack' to id '1'...
	foreach ($widgets as &$widget) {
		foreach ($gamemodes as $gamemode => &$id) {
			if ( isset($re_config[$widget][0]['GAMEMODE'][0][$gamemode]) ) {
				$re_config[$widget][0]['GAMEMODE'][0][$id] = $re_config[$widget][0]['GAMEMODE'][0][$gamemode];
				unset($re_config[$widget][0]['GAMEMODE'][0][$gamemode]);
			}
		}
	}
	unset($gamemodes, $widgets);


	// Load the templates
	$re_config['Templates'] = re_loadTemplates();


	// Check the Widget width's
	if ( ($re_config['MUSIC_WIDGET'][0]['WIDTH'][0] < 15.5) || (!$re_config['MUSIC_WIDGET'][0]['WIDTH'][0]) ) {
		$re_config['MUSIC_WIDGET'][0]['WIDTH'][0] = 15.5;
	}
	if ( ($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] < 15.5) || (!$re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0]) ) {
		$re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] = 15.5;
	}
	if ( ($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] < 15.5) || (!$re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0]) ) {
		$re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] = 15.5;
	}
	if ( ($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] < 15.5) || (!$re_config['LOCAL_RECORDS'][0]['WIDTH'][0]) ) {
		$re_config['LOCAL_RECORDS'][0]['WIDTH'][0] = 15.5;
	}
	if ( ($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] < 15.5) || (!$re_config['LIVE_RANKINGS'][0]['WIDTH'][0]) ) {
		$re_config['LIVE_RANKINGS'][0]['WIDTH'][0] = 15.5;
	}

	if (!$re_config['WELCOME_WINDOW'][0]['AUTOHIDE'][0]) {
		$re_config['WELCOME_WINDOW'][0]['AUTOHIDE'][0] = 0;
	}


	// Initialise States
	$re_config['States']['DedimaniaRecords']['NeedUpdate']		= true;			// Interact with onDedimaniaRecord
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['DedimaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['DedimaniaRecords']['TryCount']		= 0;
	$re_config['States']['LocalRecords']['NeedUpdate']		= true;			// Interact with onLocalRecord
	$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
	$re_config['States']['LocalRecords']['NoRecordsFound']		= false;
	$re_config['States']['LiveRankings']['NeedUpdate']		= true;			// Interact with onPlayerFinish
	$re_config['States']['LiveRankings']['UpdateDisplay']		= true;
	$re_config['States']['LiveRankings']['NoRecordsFound']		= false;
	$re_config['States']['GerymaniaRecords']['NeedUpdate']		= true;			// Interact with onGerymaniaRecord
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['GerymaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['GerymaniaRecords']['TryCount']		= 0;
	$re_config['States']['TopTracks']['NeedUpdate']			= true;			// Interact with onKarmaChange
	$re_config['States']['TopVoters']['NeedUpdate']			= true;			// Interact with onKarmaChange
	$re_config['States']['TopWinners']['NeedUpdate']		= true;			// Interact with onPlayerWins
	$re_config['States']['TopDonators']['NeedUpdate']		= true;			// Interact with onDonation
	$re_config['States']['NiceMode']				= false;
	$re_config['States']['RefreshTimestampRecordWidgets']		= -1000;		// Update now :D
	$re_config['States']['RefreshTimestampMinute']			= -1000;		// The ClockWidget are need to display (if enabled)
	$re_config['States']['RefreshTimestampScorelists']		= (time() + $re_config['SCORETABLE_LISTS'][0]['REFRESH_INTERVAL'][0]);

	// Preset the Placeholder which can be used in <placement>, filled later when info loaded by xaseco
	$re_config['PlacementPlaceholders']->track_tmx_prefix	= false;
	$re_config['PlacementPlaceholders']->track_tmx_id	= false;
	$re_config['PlacementPlaceholders']->track_tmx_pageurl	= false;
	$re_config['PlacementPlaceholders']->track_name		= false;
	$re_config['PlacementPlaceholders']->track_uid		= false;


	// Definitions of Icon- and Title-Positions for the RecordWidgets
	$re_config['Positions'] = array(
		'left'	=> array(
			'icon'		=> array(
				'x'		=> 0.6,
				'y'		=> 0
			),
			'title'		=> array(
				'x'		=> 3.2,
				'y'		=> -0.55,
				'halign'	=> 'left'
			),
			'image_open'	=> array(
				'x'		=> -0.3,
				'image'		=> $re_config['IMAGES'][0]['WIDGET_OPEN_LEFT'][0]
			)
		),
		'right'	=> array(
			'icon'		=> array(
				'x'		=> 12.5,
				'y'		=> 0
			),
			'title'		=> array(
				'x'		=> 12.4,
				'y'		=> -0.55,
				'halign'	=> 'right'
			),
			'image_open'	=> array(
				'x'		=> 12.2,
				'image'		=> $re_config['IMAGES'][0]['WIDGET_OPEN_RIGHT'][0]
			)
		)
	);


	// Initialise DataArrays
	$re_scores['DedimaniaRecords']			= array();
	$re_scores['LocalRecords']			= array();
	$re_scores['LiveRankings']			= array();
	$re_scores['GerymaniaRecords']			= array();
	$re_scores['TopRankings']			= array();
	$re_scores['TopWinners']			= array();
	$re_scores['MostRecords']			= array();
	$re_scores['MostFinished']			= array();
	$re_scores['TopPlaytime']			= array();
	$re_scores['TopDonators']			= array();
	$re_scores['TopNations']			= array();
	$re_scores['TopTracks']				= array();
	$re_scores['TopBetwins']			= array();
	$re_scores['DedimaniaRecordsChkSum']		= false;
	$re_scores['LocalRecordsChkSum']		= false;
	$re_scores['GerymaniaRecordsChkSum']		= false;
	$re_cache['MusicWidget']			= false;
	$re_cache['ToplistWidget']			= false;
	$re_cache['GamemodeWidget']			= false;
	$re_cache['VisitorsWidget']			= false;
	$re_cache['TrackcountWidget']			= false;
	$re_cache['TopRankings']			= false;
	$re_cache['TopWinners']				= false;
	$re_cache['MostRecords']			= false;
	$re_cache['MostFinished']			= false;
	$re_cache['TopPlaytime']			= false;
	$re_cache['TopDonators']			= false;
	$re_cache['TopNations']				= false;
	$re_cache['TopTracks']				= false;
	$re_cache['TopVoters']				= false;
	$re_cache['TopBetwins']				= false;
	$re_cache['ManialinkActionKeys']		= re_buildManialinkActionKeys();
	$re_cache['ChallengeWidget']['Default']		= false;
	$re_cache['ChallengeWidget']['Maximized']	= false;
	$re_cache['ChallengeWidget']['Score']		= false;
	$re_cache['PlayerStates']			= array();
	$re_cache['MusicServerPlaylist']		= array();
	$re_cache['Tracklist']				= array();
	$re_cache['TrackAuthors']			= array();


	// Setup the RecordWidgets and prebuild all enabled Gamemodes
	$re_cache['DedimaniaRecords']['NiceMode']	= false;
	$re_cache['LocalRecords']['NiceMode']		= false;
	$re_cache['LiveRankings']['NiceMode']		= false;
	$re_cache['GerymaniaRecords']['NiceMode']	= false;
	$widgets = array('DEDIMANIA_RECORDS', 'GERYMANIA_RECORDS', 'LOCAL_RECORDS', 'LIVE_RANKINGS');
	foreach ($widgets as &$widget) {
		for ($gamemode=0 ; $gamemode<=5 ; $gamemode++) {
			if ( ($widget == 'DEDIMANIA_RECORDS') && ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) ) {
				$build = re_buildDedimaniaRecordsWidgetBody($gamemode);
				$re_cache['DedimaniaRecords'][$gamemode]['WidgetHeader'] = $build->header;
				$re_cache['DedimaniaRecords'][$gamemode]['WidgetFooter'] = $build->footer;
			}
			if ( ($widget == 'GERYMANIA_RECORDS') && ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) ) {
				$build = re_buildGerymaniaRecordsWidgetBody($gamemode);
				$re_cache['GerymaniaRecords'][$gamemode]['WidgetHeader'] = $build->header;
				$re_cache['GerymaniaRecords'][$gamemode]['WidgetFooter'] = $build->footer;
			}
			if ( ($widget == 'LOCAL_RECORDS') && ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) ) {
				$build = re_buildLocalRecordsWidgetBody($gamemode);
				$re_cache['LocalRecords'][$gamemode]['WidgetHeader'] = $build->header;
				$re_cache['LocalRecords'][$gamemode]['WidgetFooter'] = $build->footer;
			}
			if ( ($widget == 'LIVE_RANKINGS') && ($re_config[$widget][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) ) {
				$build = re_buildLiveRankingsWidgetBody($gamemode);
				$re_cache['LiveRankings'][$gamemode]['WidgetHeader'] = $build->header;
				$re_cache['LiveRankings'][$gamemode]['WidgetFooter'] = $build->footer;
			}
		}
	}
	unset($widgets);


	// Make sure refresh´s are set, otherwise set default
	$re_config['REFRESH_INTERVAL'][0]				= ((isset($re_config['REFRESH_INTERVAL'][0])) ? (int)$re_config['REFRESH_INTERVAL'][0] : 10);
	$re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0]		= ((isset($re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0])) ? (int)$re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0] : 10);
	$re_config['SCORETABLE_LISTS'][0]['REFRESH_INTERVAL'][0]	= ((isset($re_config['SCORETABLE_LISTS'][0]['REFRESH_INTERVAL'][0])) ? (int)$re_config['SCORETABLE_LISTS'][0]['REFRESH_INTERVAL'][0] : 900);

	// Save the default refresh interval, in NiceMode the $re_config['REFRESH_INTERVAL'][0] are replaced
	$re_config['REFRESH_INTERVAL_DEFAULT'][0] = $re_config['REFRESH_INTERVAL'][0];

	// Set current GameState, can be 'race' or 'score', need this to identify what TM currently displays
	$re_config['States']['GameState'] = 'race';

	// Stores onNewChallenge2 the ListMethod GetGameInfos()
	$re_config['CurrentGameInfos'] = array();

	// Stores onNewChallenge the ListMethod GetForcedMusic()
	$re_config['CurrentMusicInfos'] = array(
		'Artist'	=> 'unknown',
		'Title'		=> 'unknown',
	);

	// Stores the Last-, Current-, Next-Challenge and the next Challenge in the $jukebox from plugin.rasp_jukebox.php
	$re_config['Challenge']['Last']		= re_getEmptyChallengeInfo();
	$re_config['Challenge']['Current']	= re_getEmptyChallengeInfo();
	$re_config['Challenge']['Next']		= re_getEmptyChallengeInfo();
	$re_config['Challenge']['Jukebox']	= false;

	// Remove Seconds/Microseconds from TimeFormat
	$re_config['CLOCK_WIDGET'][0]['TIMEFORMAT'][0] = str_replace(array('s','u','B'), array('','',''), $re_config['CLOCK_WIDGET'][0]['TIMEFORMAT'][0]);

	// Store the Name and associated Icons if Widget is enabled
	if ($re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0] == true) {
		// Need for Gamemode-Widget
		$re_config['Gamemodes'] = array(
			0 => array('name' => 'ROUNDS',		'icon' => 'RT_Rounds'),
			1 => array('name' => 'TIME ATTACK',	'icon' => 'RT_TimeAttack'),
			2 => array('name' => 'TEAM',		'icon' => 'RT_Team'),
			3 => array('name' => 'LAPS',		'icon' => 'RT_Laps'),
			4 => array('name' => 'STUNTS',		'icon' => 'RT_Stunts'),
			5 => array('name' => 'CUP',		'icon' => 'RT_Cup'),
		);
	}


	// List stolen from function mapCountry() at basic.inc.php (XASECO/1.11) and switched for reverse mapping at TopNations-Widget and NationsWindow
	$re_config['IocNations'] = array(
		'AFG'	=> 'Afghanistan'		,
		'ALB'	=> 'Albania'			,
		'ALG'	=> 'Algeria'			,
		'AND'	=> 'Andorra'			,
		'ANG'	=> 'Angola'			,
		'ARG'	=> 'Argentina'		        ,
		'ARM'	=> 'Armenia'			,
		'ARU'	=> 'Aruba'			,
		'AUS'	=> 'Australia'		        ,
		'AUT'	=> 'Austria'			,
		'AZE'	=> 'Azerbaijan'		        ,
		'BAH'	=> 'Bahamas'			,
		'BRN'	=> 'Bahrain'			,
		'BAN'	=> 'Bangladesh'		        ,
		'BAR'	=> 'Barbados'			,
		'BLR'	=> 'Belarus'			,
		'BEL'	=> 'Belgium'			,
		'BIZ'	=> 'Belize'			,
		'BEN'	=> 'Benin'			,
		'BER'	=> 'Bermuda'			,
		'BHU'	=> 'Bhutan'			,
		'BOL'	=> 'Bolivia'			,
		'BIH'	=> 'Bosnia & Herzegovina'	,  // add space before and after &
		'BOT'	=> 'Botswana'			,
		'BRA'	=> 'Brazil'			,
		'BRU'	=> 'Brunei'			,
		'BUL'	=> 'Bulgaria'			,
		'BUR'	=> 'Burkina Faso'		,
		'BDI'	=> 'Burundi'			,
		'CAM'	=> 'Cambodia'			,
		'CMR'	=> 'Cameroon'			,  // was CAR
		'CAN'	=> 'Canada'			,
		'CPV'	=> 'Cape Verde'		        ,
		'CAF'	=> 'Central African Republic'	,
		'CHA'	=> 'Chad'			,
		'CHI'	=> 'Chile'			,
		'CHN'	=> 'China'			,
		'TPE'	=> 'Chinese Taipei'		,
		'COL'	=> 'Colombia'			,
		'CGO'	=> 'Congo'			,
		'CRC'	=> 'Costa Rica'		        ,
		'CRO'	=> 'Croatia'			,
		'CUB'	=> 'Cuba'			,
		'CYP'	=> 'Cyprus'			,
		'CZE'	=> 'Czech Republic'		,  // Czech republic removed
		'COD'	=> 'DR Congo'			,
		'DEN'	=> 'Denmark'			,
		'DJI'	=> 'Djibouti'			,
		'DMA'	=> 'Dominica'			,
		'DOM'	=> 'Dominican Republic'	        ,
		'ECU'	=> 'Ecuador'			,
		'EGY'	=> 'Egypt'			,
		'ESA'	=> 'El Salvador'		,
		'ERI'	=> 'Eritrea'			,
		'EST'	=> 'Estonia'			,
		'ETH'	=> 'Ethiopia'			,
		'FIJ'	=> 'Fiji'			,
		'FIN'	=> 'Finland'			,
		'FRA'	=> 'France'			,
		'GAB'	=> 'Gabon'			,
		'GAM'	=> 'Gambia'			,
		'GEO'	=> 'Georgia'			,
		'GER'	=> 'Germany'			,
		'GHA'	=> 'Ghana'			,
		'GRE'	=> 'Greece'			,
		'GRN'	=> 'Grenada'			,
		'GUM'	=> 'Guam'			,
		'GUA'	=> 'Guatemala'		        ,
		'GUI'	=> 'Guinea'			,
		'GBS'	=> 'Guinea-Bissau'		,
		'GUY'	=> 'Guyana'			,
		'HAI'	=> 'Haiti'			,
		'HON'	=> 'Honduras'			,
		'HKG'	=> 'Hong Kong'		        ,
		'HUN'	=> 'Hungary'			,
		'ISL'	=> 'Iceland'			,
		'IND'	=> 'India'			,
		'INA'	=> 'Indonesia'		        ,
		'IRI'	=> 'Iran'			,
		'IRQ'	=> 'Iraq'			,
		'IRL'	=> 'Ireland'			,
		'ISR'	=> 'Israel'			,
		'ITA'	=> 'Italy'			,
		'CIV'	=> 'Ivory Coast'		,
		'JAM'	=> 'Jamaica'			,
		'JPN'	=> 'Japan'			,
		'JOR'	=> 'Jordan'			,
		'KAZ'	=> 'Kazakhstan'		        ,
		'KEN'	=> 'Kenya'			,
		'KIR'	=> 'Kiribati'			,
		'KOR'	=> 'Korea'			,
		'KUW'	=> 'Kuwait'			,
		'KGZ'	=> 'Kyrgyzstan'		        ,
		'LAO'	=> 'Laos'			,
		'LAT'	=> 'Latvia'			,
		'LIB'	=> 'Lebanon'			,
		'LES'	=> 'Lesotho'			,
		'LBR'	=> 'Liberia'			,
		'LBA'	=> 'Libya'			,
		'LIE'	=> 'Liechtenstein'		,
		'LTU'	=> 'Lithuania'		        ,
		'LUX'	=> 'Luxembourg'		        ,
		'MKD'	=> 'Macedonia'		        ,
		'MAW'	=> 'Malawi'			,
		'MAS'	=> 'Malaysia'			,
		'MLI'	=> 'Mali'			,
		'MLT'	=> 'Malta'			,
		'MTN'	=> 'Mauritania'		        ,
		'MRI'	=> 'Mauritius'		        ,
		'MEX'	=> 'Mexico'			,
		'MDA'	=> 'Moldova'			,
		'MON'	=> 'Monaco'			,
		'MGL'	=> 'Mongolia'			,
		'MNE'	=> 'Montenegro'		        ,
		'MAR'	=> 'Morocco'			,
		'MOZ'	=> 'Mozambique'		        ,
		'MYA'	=> 'Myanmar'			,
		'NAM'	=> 'Namibia'			,
		'NRU'	=> 'Nauru'			,
		'NEP'	=> 'Nepal'			,
		'NED'	=> 'Netherlands'		,
		'NZL'	=> 'New Zealand'		,
		'NCA'	=> 'Nicaragua'		        ,
		'NIG'	=> 'Niger'			,
		'NGR'	=> 'Nigeria'			,
		'NOR'	=> 'Norway'			,
		'OMA'	=> 'Oman'			,
		'OTH'	=> 'Other Countries'		,
		'PAK'	=> 'Pakistan'			,
		'PLW'	=> 'Palau'			,
		'PLE'	=> 'Palestine'		        ,
		'PAN'	=> 'Panama'			,
		'PAR'	=> 'Paraguay'			,
		'PER'	=> 'Peru'			,
		'PHI'	=> 'Philippines'		,
		'POL'	=> 'Poland'			,
		'POR'	=> 'Portugal'			,
		'PUR'	=> 'Puerto Rico'		,
		'QAT'	=> 'Qatar'			,
		'ROU'	=> 'Romania'			,  // was ROM
		'RUS'	=> 'Russia'			,
		'RWA'	=> 'Rwanda'			,
		'SAM'	=> 'Samoa'			,
		'SMR'	=> 'San Marino'		        ,
		'KSA'	=> 'Saudi Arabia'		,
		'SEN'	=> 'Senegal'			,
		'SRB'	=> 'Serbia'			,  // was SCG
		'SLE'	=> 'Sierra Leone'		,
		'SIN'	=> 'Singapore'		        ,
		'SVK'	=> 'Slovakia'			,
		'SLO'	=> 'Slovenia'			,
		'SOM'	=> 'Somalia'			,
		'RSA'	=> 'South Africa'		,
		'ESP'	=> 'Spain'			,
		'SRI'	=> 'Sri Lanka'		        ,
		'SUD'	=> 'Sudan'			,
		'SUR'	=> 'Suriname'			,
		'SWZ'	=> 'Swaziland'		        ,
		'SWE'	=> 'Sweden'			,
		'SUI'	=> 'Switzerland'		,
		'SYR'	=> 'Syria'			,
		'TWN'	=> 'Taiwan'			,
		'TJK'	=> 'Tajikistan'		        ,
		'TAN'	=> 'Tanzania'			,
		'THA'	=> 'Thailand'			,
		'TOG'	=> 'Togo'			,
		'TGA'	=> 'Tonga'			,
		'TRI'	=> 'Trinidad and Tobago'	,
		'TUN'	=> 'Tunisia'			,
		'TUR'	=> 'Turkey'			,
		'TKM'	=> 'Turkmenistan'		,
		'TUV'	=> 'Tuvalu'			,
		'UGA'	=> 'Uganda'			,
		'UKR'	=> 'Ukraine'			,
		'UAE'	=> 'United Arab Emirates'	,
		'GBR'	=> 'United Kingdom'		,
		'USA'	=> 'United States of America'	,
		'URU'	=> 'Uruguay'			,
		'UZB'	=> 'Uzbekistan'		        ,
		'VAN'	=> 'Vanuatu'			,
		'VEN'	=> 'Venezuela'		        ,
		'VIE'	=> 'Vietnam'			,
		'YEM'	=> 'Yemen'			,
		'ZAM'	=> 'Zambia'			,
		'ZIM'	=> 'Zimbabwe'			,
	);

	// List of Supported Timezones: http://us.php.net/manual/en/timezones.php (version 2010.2)
	// Sorted by hand (a lot of work) into logical regions for the re_buildClockDetailsWindow()
	$re_config['Timezones'] = array(
		'Africa'				=> array(
			'Algeria/Algiers'			=> 'Africa/Algiers',
			'Angola/Luanda'				=> 'Africa/Luanda',
			'Benin/Porto-Novo'			=> 'Africa/Porto-Novo',
			'Bissau-Guinea/Bissau'			=> 'Africa/Bissau',
			'Botsuana/Gaborone'			=> 'Africa/Gaborone',
			'Burkina Faso/Ouagadougou'		=> 'Africa/Ouagadougou',
			'Burundi/Bujumbura'			=> 'Africa/Bujumbura',
			'Central African Republic/Bangui'	=> 'Africa/Bangui',
			'Chad/Ndjamena'				=> 'Africa/Ndjamena',
			'Congo/Brazzaville'			=> 'Africa/Brazzaville',
			'Congo/Kinshasa'			=> 'Africa/Kinshasa',
			'Cóte d&apos;Ivoire/Abidjan'		=> 'Africa/Abidjan',
			'Djibouti/Djibouti'			=> 'Africa/Djibouti',
			'Egypt/Cairo'				=> 'Africa/Cairo',
			'Equatorial Guinea/Malabo'		=> 'Africa/Malabo',
			'Eritrea/Asmara'			=> 'Africa/Asmara',
			'Eritrea/Asmera'			=> 'Africa/Asmera',
			'Ethiopia/Addis Ababa'			=> 'Africa/Addis_Ababa',
			'Gabun/Libreville'			=> 'Africa/Libreville',
			'Gambia/Banjul'				=> 'Africa/Banjul',
			'Ghana/Accra'				=> 'Africa/Accra',
			'Guinea/Conakry'			=> 'Africa/Conakry',
			'Kamerun/Douala'			=> 'Africa/Douala',
			'Kenia/Nairobi'				=> 'Africa/Nairobi',
			'Lesotho/Maseru'			=> 'Africa/Maseru',
			'Liberia/Monrovia'			=> 'Africa/Monrovia',
			'Libya/Tripoli'				=> 'Africa/Tripoli',
			'Malawi/Blantyre'			=> 'Africa/Blantyre',
			'Mali/Bamako'				=> 'Africa/Bamako',
			'Mali/Timbuktu'				=> 'Africa/Timbuktu',
			'Marokko/Casablanca'			=> 'Africa/Casablanca',
			'Marokko/El Aaiun'			=> 'Africa/El_Aaiun',
			'Mauritania/Nouakchott'			=> 'Africa/Nouakchott',
			'Mosambik/Maputo'			=> 'Africa/Maputo',
			'Namibia/Windhoek'			=> 'Africa/Windhoek',
			'Niger/Niamey'				=> 'Africa/Niamey',
			'Nigeria/Lagos'				=> 'Africa/Lagos',
			'Rwanda/Kigali'				=> 'Africa/Kigali',
			'Sambia/Lubumbashi'			=> 'Africa/Lubumbashi',
			'Sambia/Lusaka'				=> 'Africa/Lusaka',
			'Sao Tome und Principe/Sao Tome'	=> 'Africa/Sao_Tome',
			'Senegal/Dakar'				=> 'Africa/Dakar',
			'Sierra Leone/Freetown'			=> 'Africa/Freetown',
			'Simbabwe/Harare'			=> 'Africa/Harare',
			'Somalia/Mogadishu'			=> 'Africa/Mogadishu',
			'South Africa/Johannesburg'		=> 'Africa/Johannesburg',
			'Spain/Ceuta'				=> 'Africa/Ceuta',
			'Sudan/Khartoum'			=> 'Africa/Khartoum',
			'Swasiland/Mbabane'			=> 'Africa/Mbabane',
			'Tanzania/Dar es Salaam'		=> 'Africa/Dar_es_Salaam',
			'Togo/Lome'				=> 'Africa/Lome',
			'Tunisia/Tunis'				=> 'Africa/Tunis',
			'Uganda/Kampala'			=> 'Africa/Kampala',
		),

		'Argentina'					=> array(
			'Argentina/Buenos Aires'		=> 'America/Argentina/Buenos_Aires',
			'Argentina/Catamarca'			=> 'America/Argentina/Catamarca',
			'Argentina/Comodoro Rivadavia'		=> 'America/Argentina/ComodRivadavia',
			'Argentina/Cordoba'			=> 'America/Argentina/Cordoba',
			'Argentina/Jujuy'			=> 'America/Argentina/Jujuy',
			'Argentina/La Rioja'			=> 'America/Argentina/La_Rioja',
			'Argentina/Mendoza'			=> 'America/Argentina/Mendoza',
			'Argentina/Rio Gallegos'		=> 'America/Argentina/Rio_Gallegos',
			'Argentina/Rosario'			=> 'America/Rosario',
			'Argentina/Salta'			=> 'America/Argentina/Salta',
			'Argentina/San Juan'			=> 'America/Argentina/San_Juan',
			'Argentina/San Luis'			=> 'America/Argentina/San_Luis',
			'Argentina/Tucuman'			=> 'America/Argentina/Tucuman',
			'Argentina/Ushuaia'			=> 'America/Argentina/Ushuaia',
		),

		'Asia'					=> array(
			'Afghanistan/Kabul'			=> 'Asia/Kabul',
			'Armenia/Yerevan'			=> 'Asia/Yerevan',
			'Azerbaijan/Baku'			=> 'Asia/Baku',
			'Bangladesh/Dacca'			=> 'Asia/Dacca',
			'Bangladesh/Dhaka'			=> 'Asia/Dhaka',
			'Bhutan/Thimbu'				=> 'Asia/Thimbu',
			'Brunei/Bandar Seri Begawan'		=> 'Asia/Brunei',
			'Chukotka/Anadyr'			=> 'Asia/Anadyr',
			'Cyprus/Nicosia'			=> 'Asia/Nicosia',
			'Gaza Strip/Gaza'			=> 'Asia/Gaza',
			'Georgia/Tbilisi'			=> 'Asia/Tbilisi',
			'India/Calcutta'			=> 'Asia/Calcutta',
			'India/Kolkata'				=> 'Asia/Kolkata',
			'Iran/Tehran'				=> 'Asia/Tehran',
			'Israel/Jerusalem'			=> 'Asia/Jerusalem',
			'Israel/Tel Aviv'			=> 'Asia/Tel_Aviv',
			'Iraq/Baghdad'				=> 'Asia/Baghdad',
			'Japan/Tokyo'				=> 'Asia/Tokyo',
			'Jordan/Amman'				=> 'Asia/Amman',
			'Kuwait/Al Kuwayt'			=> 'Asia/Kuwait',
			'Kyrgyzstan/Bishkek'			=> 'Asia/Bishkek',
			'Laos/Vientiane'			=> 'Asia/Vientiane',
			'Lebanon/Bahrain'			=> 'Asia/Bahrain',
			'Lebanon/Beirut'			=> 'Asia/Beirut',
			'Malaysia/Kuala Lumpur'			=> 'Asia/Kuala_Lumpur',
			'Malaysia/Kuching'			=> 'Asia/Kuching',
			'Myanmar/Rangoon'			=> 'Asia/Rangoon',
			'Nepal/Kathmandu'			=> 'Asia/Kathmandu',
			'North Korea/Pyongyang'			=> 'Asia/Pyongyang',
			'Oman/Muscat'				=> 'Asia/Muscat',
			'Pakistan/Karachi'			=> 'Asia/Karachi',
			'Philippines/Manila'			=> 'Asia/Manila',
			'Saudi Arabia/Riyadh'			=> 'Asia/Riyadh',
			'Singapore/Singapore'			=> 'Asia/Singapore',
			'South Korea/Seoul'			=> 'Asia/Seoul',
			'Sri Lanka/Colombo'			=> 'Asia/Colombo',
			'Syria/Damascus'			=> 'Asia/Damascus',
			'Tajikistan/Dushanbe'			=> 'Asia/Dushanbe',
			'Taiwan/Taipei'				=> 'Asia/Taipei',
			'Thailand/Bangkok'			=> 'Asia/Bangkok',
			'Turkey/Aden'				=> 'Asia/Aden',
			'Turkey/Istanbul'			=> 'Asia/Istanbul',
			'Turkmenistan/Ashgabat'			=> 'Asia/Ashgabat',
			'Turkmenistan/Ashkhabad'		=> 'Asia/Ashkhabad',
			'Timor-Leste/Dili'			=> 'Asia/Dili',
			'United Arab Emirates/Dubai'		=> 'Asia/Dubai',
			'United Arab Emirates/Qatar'		=> 'Asia/Qatar',
			'Uzbekistan/Samarkand'			=> 'Asia/Samarkand',
			'Uzbekistan/Tashkent'			=> 'Asia/Tashkent',
			'Vietnam/Ho Chi Minh'			=> 'Asia/Ho_Chi_Minh',
			'Vietnam/Saigon'			=> 'Asia/Saigon',
			'Cambodia/Phnom Penh'			=> 'Asia/Phnom_Penh',
		),

		'Australia'				=> array(
			'Australia/ACT'				=> 'Australia/ACT',
			'Australia/Adelaide'			=> 'Australia/Adelaide',
			'Australia/Brisbane'			=> 'Australia/Brisbane',
			'Australia/Broken Hill'			=> 'Australia/Broken_Hill',
			'Australia/Canberra'			=> 'Australia/Canberra',
			'Australia/Currie'			=> 'Australia/Currie',
			'Australia/Darwin'			=> 'Australia/Darwin',
			'Australia/Eucla'			=> 'Australia/Eucla',
			'Australia/Hobart'			=> 'Australia/Hobart',
			'Australia/LHI'				=> 'Australia/LHI',
			'Australia/Lindeman'			=> 'Australia/Lindeman',
			'Australia/Lord Howe'			=> 'Australia/Lord_Howe',
			'Australia/Melbourne'			=> 'Australia/Melbourne',
			'Australia/North'			=> 'Australia/North',
			'Australia/NSW'				=> 'Australia/NSW',
			'Australia/Perth'			=> 'Australia/Perth',
			'Australia/Queensland'			=> 'Australia/Queensland',
			'Australia/South'			=> 'Australia/South',
			'Australia/Sydney'			=> 'Australia/Sydney',
			'Australia/Tasmania'			=> 'Australia/Tasmania',
			'Australia/Victoria'			=> 'Australia/Victoria',
			'Australia/West'			=> 'Australia/West',
			'Australia/Yancowinna'			=> 'Australia/Yancowinna',
		),

		'Brasil'					=> array(
			'Brazil/Acre'				=> 'Brazil/Acre',
			'Brasil/Araguaina'			=> 'America/Araguaina',
			'Brasil/Bahia'				=> 'America/Bahia',
			'Brasil/Belem'				=> 'America/Belem',
			'Brasil/Boa Vista'			=> 'America/Boa_Vista',
			'Brasil/Campo Grande'			=> 'America/Campo_Grande',
			'Brasil/Cuiaba'				=> 'America/Cuiaba',
			'Brasil/Eirunepe'			=> 'America/Eirunepe',
			'Brasil/Fortaleza'			=> 'America/Fortaleza',
			'Brasil/Maceio'				=> 'America/Maceio',
			'Brasil/Manaus'				=> 'America/Manaus',
			'Brasil/Noronha'			=> 'America/Noronha',
			'Brasil/Porto Acre'			=> 'America/Porto_Acre',
			'Brasil/Porto Velho'			=> 'America/Porto_Velho',
			'Brasil/Rio Branco'			=> 'America/Rio_Branco',
			'Brasil/Recife'				=> 'America/Recife',
			'Brasil/Santa Isabel'			=> 'America/Santa_Isabel',
			'Brasil/Santarem'			=> 'America/Santarem',
			'Brasil/Sao Paulo'			=> 'America/Sao_Paulo',
		),

		'Canada'				=> array(
			'Canada/Atikokan'			=> 'America/Atikokan',
			'Canada/Blanc-Sablon'			=> 'America/Blanc-Sablon',
			'Canada/Cambridge Bay'			=> 'America/Cambridge_Bay',
			'Canada/Coral Harbour'			=> 'America/Coral_Harbour',
			'Canada/Dawson Creek'			=> 'America/Dawson_Creek',
			'Canada/East-Saskatchewan'		=> 'Canada/East-Saskatchewan',
			'Canada/Edmonton'			=> 'America/Edmonton',
			'Canada/Glace Bay'			=> 'America/Glace_Bay',
			'Canada/Goose Bay'			=> 'America/Goose_Bay',
			'Canada/Halifax'			=> 'America/Halifax',
			'Canada/Inuvik'				=> 'America/Inuvik',
			'Canada/Iqaluit'			=> 'America/Iqaluit',
			'Canada/Moncton'			=> 'America/Moncton',
			'Canada/Montreal'			=> 'America/Montreal',
			'Canada/Newfoundland'			=> 'Canada/Newfoundland',
			'Canada/Nipigon'			=> 'America/Nipigon',
			'Canada/Pangnirtung'			=> 'America/Pangnirtung',
			'Canada/Rainy River'			=> 'America/Rainy_River',
			'Canada/Rankin Inlet'			=> 'America/Rankin_Inlet',
			'Canada/Regina'				=> 'America/Regina',
			'Canada/Resolute'			=> 'America/Resolute',
			'Canada/Saskatchewan'			=> 'Canada/Saskatchewan',
			'Canada/Swift Current'			=> 'America/Swift_Current',
			'Canada/Thunder Bay'			=> 'America/Thunder_Bay',
			'Canada/Vancouver'			=> 'America/Vancouver',
			'Canada/Winnipeg'			=> 'America/Winnipeg',
			'Canada/Whitehorse'			=> 'America/Whitehorse',
			'Canada/Yellowknife'			=> 'America/Yellowknife',
			'Canada/Yukon'				=> 'Canada/Yukon',
		),

		'Central America'			=> array(
			'Bahamas/Nassau'			=> 'America/Nassau',
			'British Virgin Islands/Tortola'	=> 'America/Tortola',
			'Cayman Islands/Savannah'		=> 'America/Cayman',
			'Costa Rica/Santo Domingo'		=> 'America/Costa_Rica',
			'Cuba/Havana'				=> 'America/Havana',
			'Dominica Republic/Santo Domingo'	=> 'America/Dominica',
			'Guadeloupe/Marigot'			=> 'America/Marigot',
			'Guadeloupe/Montserrat'			=> 'America/Guadeloupe',
			'Guadeloupe/St. Barthelemy'		=> 'America/St_Barthelemy',
			'Guatemala/Guatemala City'		=> 'America/Guatemala',
			'Haiti/Port-au-Prince'			=> 'America/Port-au-Prince',
			'Honduras/Tegucigalpa'			=> 'America/Tegucigalpa',
			'Jamaica/Jamaica'			=> 'America/Jamaica',
			'Montserrat/Plymouth'			=> 'America/Montserrat',
			'Nicaragua/Managua'			=> 'America/Managua',
			'Panama/Panama'				=> 'America/Panama',
			'Puerto Rico/San Juan'			=> 'America/Puerto_Rico',
			'St. Kitts and Nevis/St. Kitts'		=> 'America/St_Kitts',
			'Martinique/Fort de France'		=> 'America/Martinique',
		),

		'China'					=> array(
			'China/Chongqing'			=> 'Asia/Chongqing',
			'China/Chungking'			=> 'Asia/Chungking',
			'China/Harbin'				=> 'Asia/Harbin',
			'China/Hong Kong'			=> 'Asia/Hong_Kong',
			'China/Kashgar'				=> 'Asia/Kashgar',
			'China/Macao'				=> 'Asia/Macao',
			'China/Macau'				=> 'Asia/Macau',
			'China/Shanghai'			=> 'Asia/Shanghai',
			'China/Urumqi'				=> 'Asia/Urumqi',
		),

		'Europe'				=> array(
			'Europe/Amsterdam'			=> 'Europe/Amsterdam',
			'Europe/Andorra'			=> 'Europe/Andorra',
			'Europe/Athens'				=> 'Europe/Athens',
			'Europe/Belfast'			=> 'Europe/Belfast',
			'Europe/Belgrade'			=> 'Europe/Belgrade',
			'Europe/Berlin'				=> 'Europe/Berlin',
			'Europe/Bratislava'			=> 'Europe/Bratislava',
			'Europe/Brussels'			=> 'Europe/Brussels',
			'Europe/Bucharest'			=> 'Europe/Bucharest',
			'Europe/Budapest'			=> 'Europe/Budapest',
			'Europe/Chisinau'			=> 'Europe/Chisinau',
			'Europe/Copenhagen'			=> 'Europe/Copenhagen',
			'Europe/Dublin'				=> 'Europe/Dublin',
			'Europe/Gibraltar'			=> 'Europe/Gibraltar',
			'Europe/Guernsey'			=> 'Europe/Guernsey',
			'Europe/Helsinki'			=> 'Europe/Helsinki',
			'Europe/Isle of Man'			=> 'Europe/Isle_of_Man',
			'Europe/Istanbul'			=> 'Europe/Istanbul',
			'Europe/Jersey'				=> 'Europe/Jersey',
			'Europe/Kaliningrad'			=> 'Europe/Kaliningrad',
			'Europe/Kiev'				=> 'Europe/Kiev',
			'Europe/Lisbon'				=> 'Europe/Lisbon',
			'Europe/Ljubljana'			=> 'Europe/Ljubljana',
			'Europe/London'				=> 'Europe/London',
			'Europe/Luxembourg'			=> 'Europe/Luxembourg',
			'Europe/Madrid'				=> 'Europe/Madrid',
			'Europe/Malta'				=> 'Europe/Malta',
			'Europe/Mariehamn'			=> 'Europe/Mariehamn',
			'Europe/Minsk'				=> 'Europe/Minsk',
			'Europe/Monaco'				=> 'Europe/Monaco',
			'Europe/Nicosia'			=> 'Europe/Nicosia',
			'Europe/Oslo'				=> 'Europe/Oslo',
			'Europe/Paris'				=> 'Europe/Paris',
			'Europe/Podgorica'			=> 'Europe/Podgorica',
			'Europe/Prague'				=> 'Europe/Prague',
			'Europe/Riga'				=> 'Europe/Riga',
			'Europe/Rome'				=> 'Europe/Rome',
			'Europe/Samara'				=> 'Europe/Samara',
			'Europe/San Marino'			=> 'Europe/San_Marino',
			'Europe/Sarajevo'			=> 'Europe/Sarajevo',
			'Europe/Simferopol'			=> 'Europe/Simferopol',
			'Europe/Skopje'				=> 'Europe/Skopje',
			'Europe/Sofia'				=> 'Europe/Sofia',
			'Europe/Stockholm'			=> 'Europe/Stockholm',
			'Europe/Tallinn'			=> 'Europe/Tallinn',
			'Europe/Tirane'				=> 'Europe/Tirane',
			'Europe/Tiraspol'			=> 'Europe/Tiraspol',
			'Europe/Uzhgorod'			=> 'Europe/Uzhgorod',
			'Europe/Vaduz'				=> 'Europe/Vaduz',
			'Europe/Vatican'			=> 'Europe/Vatican',
			'Europe/Vienna'				=> 'Europe/Vienna',
			'Europe/Vilnius'			=> 'Europe/Vilnius',
			'Europe/Warsaw'				=> 'Europe/Warsaw',
			'Europe/Zagreb'				=> 'Europe/Zagreb',
			'Europe/Zaporozhye'			=> 'Europe/Zaporozhye',
			'Europe/Zurich'				=> 'Europe/Zurich',
		),

		'Indonesia'				=> array(
			'Indonesia/Jakarta'			=> 'Asia/Jakarta',
			'Indonesia/Jayapura'			=> 'Asia/Jayapura',
			'Indonesia/Makassar'			=> 'Asia/Makassar',
			'Indonesia/Pontianak'			=> 'Asia/Pontianak',
			'Indonesia/Ujung Pandang'		=> 'Asia/Ujung_Pandang',
		),

		'Kazakhstan'				=> array(
			'Kazakhstan/Almaty'			=> 'Asia/Almaty',
			'Kazakhstan/Aqtau'			=> 'Asia/Aqtau',
			'Kazakhstan/Aqtobe'			=> 'Asia/Aqtobe',
			'Kazakhstan/Oral'			=> 'Asia/Oral',
			'Kazakhstan/Qyzylorda'			=> 'Asia/Qyzylorda',
		),

		'Mexico'				=> array(
			'Mexico/Cancun'				=> 'America/Cancun',
			'Mexico/Chihuahua'			=> 'America/Chihuahua',
			'Mexico/Ensenada'			=> 'America/Ensenada',
			'Mexico/Hermosillo'			=> 'America/Hermosillo',
			'Mexico/La Paz'				=> 'America/La_Paz',
			'Mexico/Matamoros'			=> 'America/Matamoros',
			'Mexico/Mazatlan'			=> 'America/Mazatlan',
			'Mexico/Merida'				=> 'America/Merida',
			'Mexico/Mexico City'			=> 'America/Mexico_City',
			'Mexico/Monterrey'			=> 'America/Monterrey',
			'Mexico/Ojinaga'			=> 'America/Ojinaga',
			'Mexico/Tijuana'			=> 'America/Tijuana',
		),

		'Mongolia'				=> array(
			'Mongolia/Choibalsan'			=> 'Asia/Choibalsan',
			'Mongolia/Hovd'				=> 'Asia/Hovd',
			'Mongolia/Ulaanbaatar'			=> 'Asia/Ulaanbaatar',
			'Mongolia/Ulan Bator'			=> 'Asia/Ulan_Bator',
		),

		'Russia'				=> array(
			'Russia/Irkutsk'			=> 'Asia/Irkutsk',
			'Russia/Kamchatka'			=> 'Asia/Kamchatka',
			'Russia/Krasnoyarsk'			=> 'Asia/Krasnoyarsk',
			'Russia/Magadan'			=> 'Asia/Magadan',
			'Russia/Moscow'				=> 'Europe/Moscow',
			'Russia/Novokuznetsk'			=> 'Asia/Novokuznetsk',
			'Russia/Novosibirsk'			=> 'Asia/Novosibirsk',
			'Russia/Omsk'				=> 'Asia/Omsk',
			'Russia/Sakhalin'			=> 'Asia/Sakhalin',
			'Russia/Vladivostok'			=> 'Asia/Vladivostok',
			'Russia/Volgograd'			=> 'Europe/Volgograd',
			'Russia/Yakutsk'			=> 'Asia/Yakutsk',
			'Russia/Yekaterinburg'			=> 'Asia/Yekaterinburg',
		),

		'South America'				=> array(
			'Anguilla/George Hill'			=> 'America/Anguilla',
			'Aruba/Santa Cruz'			=> 'America/Aruba',
			'Antigua and Barbuda/Antigua'		=> 'America/Antigua',
			'Barbados/Bridgetown'			=> 'America/Barbados',
			'Chile/El Salvador'			=> 'America/El_Salvador',
			'Chile/Santiago'			=> 'America/Santiago',
			'Chile/Easter Island'			=> 'Chile/EasterIsland',
			'Columbia/Bogota'			=> 'America/Bogota',
			'Ecuador/Guayaquil'			=> 'America/Guayaquil',
			'Guyana/Georgetown'			=> 'America/Guyana',
			'Guyane/Cayenne'			=> 'America/Cayenne',
			'Netherland Antilles/Curacao'		=> 'America/Curacao',
			'Paraguay/Asuncion'			=> 'America/Asuncion',
			'Peru/Lima'				=> 'America/Lima',
			'St. Lucia/Castries'			=> 'America/St_Lucia',
			'Suriname/Paramaribo'			=> 'America/Paramaribo',
			'Trinidad and Tobago/Port-of-Spain'	=> 'America/Port_of_Spain',
			'Uruguay/Montevideo'			=> 'America/Montevideo',
			'Venezuela/Caracas'			=> 'America/Caracas',
		),

		'United States of America'		=> array(
			'USA/Alaska/Adak'			=> 'America/Adak',
			'USA/Alaska/Anchorage'			=> 'America/Anchorage',
			'USA/Alaska/Atka'			=> 'America/Atka',
			'USA/Alaska/Juneau'			=> 'America/Juneau',
			'USA/Alaska/Nome'			=> 'America/Nome',
			'USA/Alaska/Yakutat'			=> 'America/Yakutat',
			'USA/Arizona/Phoenix'			=> 'America/Phoenix',
			'USA/Arizona/St. Johns'			=> 'America/St_Johns',
			'USA/California/Los Angeles'		=> 'America/Los_Angeles',
			'USA/Colorado/Denver'			=> 'America/Denver',
			'USA/Colorado/Grand Turk'		=> 'America/Grand_Turk',
			'USA/Georgia/Dawson'			=> 'America/Dawson',
			'USA/Mississippi/Grenada'		=> 'America/Grenada',
			'USA/Idaho/Boise'			=> 'America/Boise',
			'USA/Illinois/Chicago'			=> 'America/Chicago',
			'USA/Indiana/Indianapolis'		=> 'America/Indianapolis',
			'USA/Indiana/Fort Wayne'		=> 'America/Fort_Wayne',
			'USA/Indiana/Knox'			=> 'America/Indiana/Knox',
			'USA/Indiana/Marengo'			=> 'America/Indiana/Marengo',
			'USA/Indiana/Petersburg'		=> 'America/Indiana/Petersburg',
			'USA/Indiana/Tell City'			=> 'America/Indiana/Tell_City',
			'USA/Indiana/Vevay'			=> 'America/Indiana/Vevay',
			'USA/Indiana/Vincennes'			=> 'America/Indiana/Vincennes',
			'USA/Indiana/Winamac'			=> 'America/Indiana/Winamac',
			'USA/Kentucky/Louisville'		=> 'America/Kentucky/Louisville',
			'USA/Kentucky/Monticello'		=> 'America/Kentucky/Monticello',
			'USA/Michigan/Detroit'			=> 'America/Detroit',
			'USA/Michigan/Menominee'		=> 'America/Menominee',
			'USA/Miquelon Island'			=> 'America/Miquelon',
			'USA/New Mexico/Santo Domingo'		=> 'America/Santo_Domingo',
			'USA/New Mexico/Shiprock'		=> 'America/Shiprock',
			'USA/New York/New York City'		=> 'America/New_York',
			'USA/North Dakota/Center'		=> 'America/North_Dakota/Center',
			'USA/North Dakota/New Salem'		=> 'America/North_Dakota/New_Salem',
			'USA/Ohio/Toronto'			=> 'America/Toronto',
			'USA/U.S. Virgin Islands/St. Thomas'	=> 'America/St_Thomas',
			'USA/Hawaii'				=> 'US/Hawaii',
			'USA/Samoa'				=> 'US/Samoa',
		),

		'Arctic, Antarctica &amp; Greenland'	=> array(
			'Antarctica/Casey'			=> 'Antarctica/Casey',
			'Antarctica/Davis'			=> 'Antarctica/Davis',
			'Antarctica/Dumont d&apos;Urville'	=> 'Antarctica/DumontDUrville',
			'Antarctica/Macquarie'			=> 'Antarctica/Macquarie',
			'Antarctica/Mawson'			=> 'Antarctica/Mawson',
			'Antarctica/Mc. Murdo'			=> 'Antarctica/McMurdo',
			'Antarctica/Palmer'			=> 'Antarctica/Palmer',
			'Antarctica/Rothera'			=> 'Antarctica/Rothera',
			'Antarctica/South Pole'			=> 'Antarctica/South_Pole',
			'Antarctica/Syowa'			=> 'Antarctica/Syowa',
			'Antarctica/Vostok'			=> 'Antarctica/Vostok',
			'Arctic/Jan Mayen'			=> 'Atlantic/Jan_Mayen',
			'Arctic/Longyearbyen'			=> 'Arctic/Longyearbyen',
			'Greenland/Scoresbysund'		=> 'America/Scoresbysund',
		),

		'Atlantic Ocean'			=> array(
			'Atlantic/Azores'			=> 'Atlantic/Azores',
			'Atlantic/Bermuda'			=> 'Atlantic/Bermuda',
			'Atlantic/Canary'			=> 'Atlantic/Canary',
			'Atlantic/Cape Verde'			=> 'Atlantic/Cape_Verde',
			'Atlantic/Faeroe'			=> 'Atlantic/Faeroe',
			'Atlantic/Faroe'			=> 'Atlantic/Faroe',
			'Atlantic/Jan Mayen'			=> 'Atlantic/Jan_Mayen',
			'Atlantic/Madeira'			=> 'Atlantic/Madeira',
			'Atlantic/Reykjavik'			=> 'Atlantic/Reykjavik',
			'Atlantic/South Georgia'		=> 'Atlantic/South_Georgia',
			'Atlantic/St. Helena'			=> 'Atlantic/St_Helena',
			'Atlantic/Stanley'			=> 'Atlantic/Stanley',
		),

		'Pacific Ocean'				=> array(
			'Pacific/Apia'				=> 'Pacific/Apia',
			'Pacific/Auckland'			=> 'Pacific/Auckland',
			'Pacific/Chatham'			=> 'Pacific/Chatham',
			'Pacific/Easter'			=> 'Pacific/Easter',
			'Pacific/Efate'				=> 'Pacific/Efate',
			'Pacific/Enderbury'			=> 'Pacific/Enderbury',
			'Pacific/Fakaofo'			=> 'Pacific/Fakaofo',
			'Pacific/Fiji'				=> 'Pacific/Fiji',
			'Pacific/Funafuti'			=> 'Pacific/Funafuti',
			'Pacific/Galapagos'			=> 'Pacific/Galapagos',
			'Pacific/Gambier'			=> 'Pacific/Gambier',
			'Pacific/Guadalcanal'			=> 'Pacific/Guadalcanal',
			'Pacific/Guam'				=> 'Pacific/Guam',
			'Pacific/Honolulu'			=> 'Pacific/Honolulu',
			'Pacific/Hawaii'			=> 'US/Hawaii',
			'Pacific/Johnston'			=> 'Pacific/Johnston',
			'Pacific/Kiritimati'			=> 'Pacific/Kiritimati',
			'Pacific/Kosrae'			=> 'Pacific/Kosrae',
			'Pacific/Kwajalein'			=> 'Pacific/Kwajalein',
			'Pacific/Majuro'			=> 'Pacific/Majuro',
			'Pacific/Marquesas'			=> 'Pacific/Marquesas',
			'Pacific/Midway'			=> 'Pacific/Midway',
			'Pacific/Nauru'				=> 'Pacific/Nauru',
			'Pacific/Niue'				=> 'Pacific/Niue',
			'Pacific/Norfolk'			=> 'Pacific/Norfolk',
			'Pacific/Noumea'			=> 'Pacific/Noumea',
			'Pacific/Pago Pago'			=> 'Pacific/Pago_Pago',
			'Pacific/Palau'				=> 'Pacific/Palau',
			'Pacific/Pitcairn'			=> 'Pacific/Pitcairn',
			'Pacific/Ponape'			=> 'Pacific/Ponape',
			'Pacific/Port Moresby'			=> 'Pacific/Port_Moresby',
			'Pacific/Rarotonga'			=> 'Pacific/Rarotonga',
			'Pacific/Saipan'			=> 'Pacific/Saipan',
			'Pacific/Samoa'				=> 'Pacific/Samoa',
			'Pacific/Tahiti'			=> 'Pacific/Tahiti',
			'Pacific/Tarawa'			=> 'Pacific/Tarawa',
			'Pacific/Tongatapu'			=> 'Pacific/Tongatapu',
			'Pacific/Truk'				=> 'Pacific/Truk',
			'Pacific/Wake'				=> 'Pacific/Wake',
			'Pacific/Wallis'			=> 'Pacific/Wallis',
			'Pacific/Yap'				=> 'Pacific/Yap',
		),

		'Indian Ocean'				=> array(
			'Indian/Antananarivo'			=> 'Indian/Antananarivo',
			'Indian/Chagos'				=> 'Indian/Chagos',
			'Indian/Christmas'			=> 'Indian/Christmas',
			'Indian/Cocos'				=> 'Indian/Cocos',
			'Indian/Comoro'				=> 'Indian/Comoro',
			'Indian/Kerguelen'			=> 'Indian/Kerguelen',
			'Indian/Mahe'				=> 'Indian/Mahe',
			'Indian/Maldives'			=> 'Indian/Maldives',
			'Indian/Mauritius'			=> 'Indian/Mauritius',
			'Indian/Mayotte'			=> 'Indian/Mayotte',
			'Indian/Reunion'			=> 'Indian/Reunion',
		),
	);



	// Check the Database-Table for existing `timezone` and `displaywidgets` column (needed to store the player-preference for the Clock-Widget and display preferences)
	$fields = array();
	$bugfix = false;
	$result = mysql_query('SHOW COLUMNS FROM `players_extra`;');
	if ($result) {
		while ($row = mysql_fetch_row($result)) {
			$fields[] = $row[0];

			// Bugfix at NT-Systems from 0.9.2 release
			if ($row[0] == 'timezone') {
				$bugfix = ((strtoupper($row[2]) == 'NO') ? true : false);
			}
		}
	}
	mysql_free_result($result);


	// Add `timezone` column if not yet done
	if ( !in_array('timezone', $fields) ) {
		mysql_query('ALTER TABLE `players_extra` ADD `timezone` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL COMMENT "Added by plugin.records_eyepiece.php";');
	}
	else {
		// Bugfix at NT-Systems from 0.9.2 release
		if ($bugfix == true) {
			mysql_query('ALTER TABLE `players_extra` CHANGE `timezone` `timezone` VARCHAR(64) CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL COMMENT "Added by plugin.records_eyepiece.php";');
		}
	}

	// Add `displaywidgets` column if not yet done
	if ( !in_array('displaywidgets', $fields) ) {
		mysql_query('ALTER TABLE `players_extra` ADD `displaywidgets` ENUM("true", "false") CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT "true" COMMENT "Added by plugin.records_eyepiece.php";');
	}




	// Check the table `players_extra` for old INDEX
	$fields = array('playerID_donations' => 0);
	$result = mysql_query('SHOW INDEX FROM `players_extra`;');
	if ($result) {
		while ( $row = mysql_fetch_row($result) ) {
			if ( isset($fields[$row[2]]) ) {
				$fields[$row[2]]++;
			}
		}
	}
	mysql_free_result($result);
	if ($fields['playerID_donations'] != 0) {
		mysql_query("ALTER TABLE `players_extra` DROP KEY `playerID_donations`;");
	}



	// Check the table `players` for required INDEX
	$fields = array('Nation' => 0, 'Wins' => 0);
	$result = mysql_query('SHOW INDEX FROM `players`;');
	if ($result) {
		while ( $row = mysql_fetch_row($result) ) {
			if ( isset($fields[$row[2]]) ) {
				$fields[$row[2]]++;
			}
		}
	}
	mysql_free_result($result);
	if ($fields['Nation'] == 0) {
		mysql_query("ALTER TABLE `players` ADD INDEX `Nation` (`Nation`);");
	}
	if ($fields['Wins'] == 0) {
		mysql_query("ALTER TABLE `players` ADD INDEX `Wins` (`Wins`);");
	}



	// Check the table `rs_karma` for required INDEX
	$fields = array('Score' => 0, 'Score_ChallengeId' => 0);
	$result = mysql_query('SHOW INDEX FROM `rs_karma`;');
	if ($result) {
		while ( $row = mysql_fetch_row($result) ) {
			if ( isset($fields[$row[2]]) ) {
				$fields[$row[2]]++;
			}
		}
	}
	mysql_free_result($result);
	if ($fields['Score_ChallengeId'] != 0) {
		mysql_query("ALTER TABLE `rs_karma` DROP KEY `Score_ChallengeId`;");
	}
	if ($fields['Score'] == 0) {
		mysql_query("ALTER TABLE `rs_karma` ADD INDEX `Score` (`Score`);");
	}



	// Check the table `rs_times` for required INDEX
	$fields = array('score' => 0);
	$result = mysql_query('SHOW INDEX FROM `rs_times`;');
	if ($result) {
		while ( $row = mysql_fetch_row($result) ) {
			if ( isset($fields[$row[2]]) ) {
				$fields[$row[2]]++;
			}
		}
	}
	mysql_free_result($result);
	if ($fields['score'] == 0) {
		mysql_query("ALTER TABLE `rs_times` ADD INDEX `score` (`score`);");
	}




	// Check if is "nice"-mode been forced
	if ( ($re_config['NICEMODE'][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['FORCE'][0] == true) ) {
		// Turn nicemode on
		$re_config['States']['NiceMode'] = true;

		// Set new refresh interval
		$re_config['REFRESH_INTERVAL'][0] = $re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0];
	}


	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {

		// Remove disabled <placement> (freed mem.)
		$new_placements = array();
		foreach ($re_config['PLACEMENT_WIDGET'][0]['PLACEMENT'] as &$placement) {
			if (strtoupper($placement['ENABLED'][0]) == 'TRUE') {
				$placement['DISPLAY'][0] = strtoupper($placement['DISPLAY'][0]);

				// Remove empty and unused tags to free mem. too.
				foreach ($placement as $tag => &$value) {
					if ($value[0] == '') {
						unset($placement[$tag]);
					}
				}
				unset($placement['ENABLED']);
				unset($placement['DESCRIPTION']);

				$new_placements[] = $placement;
			}
		}
		$re_config['PLACEMENT_WIDGET'][0]['PLACEMENT'] = $new_placements;
		unset($new_placements);

		$re_cache['PlacementWidget']['Always']		= re_buildPlacementWidget('always');
		$re_cache['PlacementWidget']['Race']		= re_buildPlacementWidget('race');
		// 'Score' is build at onEndRace1
	}

	if ($re_config['CHALLENGE_WIDGET'][0]['ENABLED'][0] == true) {
		// Disable 'challenge_info' and use own ChallengeInfoWidget
		setCustomUIField('challenge_info', false);
	}


	// Setup the "no-score" Placeholder depending at the current Gamemode
	if ($aseco->server->gameinfo->mode == 4) {
		// 4 = Stunts
		$re_config['PlaceholderNoScore'] = '---';
	}
	else {
		$re_config['PlaceholderNoScore'] = '-:--.--';
	}

	// Get the current Tracklist
	re_getTracklist();

	// Build Scorelists Arrays
	re_refreshScorelists('all');

	// Build the Scoretable Widget
	$re_cache['ToplistWidget'] = re_buildToplistWidget();
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function chat_eyepiece ($aseco, $command) {
	global $re_config, $re_cache;


	if (strtoupper($command['params']) == 'HIDE') {

		// Get Player item
		$player = $aseco->server->players->getPlayer($command['author']->login);

		// Set display to hidden
		$player->data['RecordsEyepieceWidgetPreference'] = false;

		// Hide the RecordWidgets
		re_closeRaceDisplays($player->login, false);

		// Store the preferences
		mysql_query("UPDATE `players_extra` SET `displaywidgets`='false' WHERE `playerID`='". $player->data['RecordsEyepieceDatabasePlayerId'] ."';");

		// Give feedback to the Player
		$aseco->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($re_config['MESSAGES'][0]['WIDGETS_PREFERENCE_DISABLED'][0]), $player->login));

	}
	else if (strtoupper($command['params']) == 'SHOW') {

		// Get Player item
		$player = $aseco->server->players->getPlayer($command['author']->login);

		// Init
		$widgets = '';

		// Set display to displaying
		$player->data['RecordsEyepieceWidgetPreference'] = true;

		// Build the RecordWidgets and in normal mode send it to each or given Player (if refresh is required)
		$re_cache['PlayerStates'][$player->login]['DedimaniaRecords'] = -1;
		$re_cache['PlayerStates'][$player->login]['GerymaniaRecords'] = -1;
		$re_cache['PlayerStates'][$player->login]['LocalRecords'] = -1;
		$re_cache['PlayerStates'][$player->login]['LiveRankings'] = -1;
		re_buildRecordWidgets($player, array('DedimaniaRecords' => true, 'GerymaniaRecords' => true, 'LocalRecords' => true, 'LiveRankings' => true));

		if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
			// Display the Music Widget to given Player
			$widgets .= (($re_cache['MusicWidget'] != false) ? $re_cache['MusicWidget'] : '');
		}

		// Store the preferences
		mysql_query("UPDATE `players_extra` SET `displaywidgets`='true' WHERE `playerID`='". $player->data['RecordsEyepieceDatabasePlayerId'] ."';");

		// Give feedback to the Player
		$aseco->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($re_config['MESSAGES'][0]['WIDGETS_PREFERENCE_ENABLED'][0]), $player->login));


		// Send all widgets
		if ($widgets != '') {
			// Send Manialink
			re_sendManialink($widgets, $player->login);
		}

	}
	else {
		if ($re_config['States']['GameState'] != 'score') {

			// Get Player item
			$player = $aseco->server->players->getPlayer($command['author']->login);

			// Send the HelpWindow
			$widgets = re_buildHelpWindow(0, $player);

			re_sendManialink($widgets, $command['author']->login);
		}
		else {
			// Show message that the display at score is impossible
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($re_config['MESSAGES'][0]['DISALLOW_WINDOWS_AT_SCORE'][0]), $command['author']->login);
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function chat_eyeset ($aseco, $command) {
	global $re_config;


	// Bailout if Player is not an MasterAdmin
	if (!$aseco->isMasterAdmin($command['author'])) {
		return;
	}


	// Init
	$message = false;

	// Check optional parameter
	if (strtoupper($command['params']) == 'RELOAD') {
		$aseco->console('[plugin.records_eyepiece.php] MasterAdmin '. $command['author']->login .' reloads the configuration.');

		// Reload the config
		re_onSync($aseco);

		// Simulate the event 'onNewChallenge'
		re_onNewChallenge($aseco, false);

		// Simulate the event 'onNewChallenge2'
		re_onNewChallenge2($aseco, false);

		$message = '{#admin}>> Reload of the configuration "records_eyepiece.xml" done.';
	}
	else if ( preg_match("/^lfresh \d+$/i", $command['params']) ) {

		$param = preg_split("/^lfresh (\d+)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <refresh_interval> (normal mode) to "'. $param[0] .'" sec.';
		$re_config['REFRESH_INTERVAL'][0] = $param[0];

	}
	else if ( preg_match("/^hfresh \d+$/i", $command['params']) ) {

	$param = preg_split("/^hfresh (\d+)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <refresh_interval> (nice mode) to "'. $param[0] .'" sec.';
		$re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0] = $param[0];

	}
	else if ( preg_match("/^llimit \d+$/i", $command['params']) ) {

		$param = preg_split("/^llimit (\d+)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <lower_limit> (nice mode) to "'. $param[0] .'" Players.';
		$re_config['NICEMODE'][0]['LIMITS'][0]['LOWER_LIMIT'][0] = $param[0];

	}
	else if ( preg_match("/^ulimit \d+$/i", $command['params']) ) {

		$param = preg_split("/^ulimit (\d+)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <upper_limit> (nice mode) to "'. $param[0] .'" Players.';
		$re_config['NICEMODE'][0]['LIMITS'][0]['UPPER_LIMIT'][0] = $param[0];

	}
	else if ( preg_match("/^forcenice (true|false)$/i", $command['params']) ) {

		$param = preg_split("/^forcenice (true|false)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <nicemode><force> to "'. $param[0] .'".';
		$re_config['NICEMODE'][0]['FORCE'][0]	= ((strtoupper($param[0]) == 'TRUE') ? true : false);
		$re_config['States']['NiceMode']	= ((strtoupper($param[0]) == 'TRUE') ? true : false);

		if ($re_config['States']['NiceMode'] == false) {
			// Make sure that all preferences at all Players are loaded
			re_loadPlayerPreferences(false);
		}

		// Lets refresh the Widgets
		$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
		$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
		$re_config['States']['LiveRankings']['UpdateDisplay']		= true;
		$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	}
	else if ( preg_match("/^playermarker (true|false)$/i", $command['params']) ) {

		$param = preg_split("/^playermarker (true|false)$/", $command['params'], 0, PREG_SPLIT_NO_EMPTY|PREG_SPLIT_DELIM_CAPTURE);
		$message = '{#admin}>> Set <features><mark_online_player_records> to "'. $param[0] .'".';
		$re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0]	= ((strtoupper($param[0]) == 'TRUE') ? true : false);

		// Lets refresh the Widgets
		$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
		$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
		$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	}
	else {
		$message = '{#admin}>> Did not found any possible parameter to set!';
	}


	// Show message
	if ($message != false) {
		$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $command['author']->login);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// Wrapper/Chat command for opening the TracklistWindow
function chat_elist ($aseco, $command) {
	global $re_config;


	// Get Player item
	$player = $aseco->server->players->getPlayer($command['author']->login);

	// $answer = [0]=PlayerUid, [1]=Login, [2]=Answer
	$answer = array(
		$player->id,
		$player->login,
		$re_config['ManialinkId'].'20'
	);
	re_onPlayerManialinkPageAnswer($aseco, $answer);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// Wrapper/Chat command for opening the MusiclistWindow
function chat_emusic ($aseco, $command) {
	global $re_config;


	if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
		// Get Player item
		$player = $aseco->server->players->getPlayer($command['author']->login);

		// $answer = [0]=PlayerUid, [1]=Login, [2]=Answer
		$answer = array(
			$player->id,
			$player->login,
			$re_config['ManialinkId'].'18'
		);
		re_onPlayerManialinkPageAnswer($aseco, $answer);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function chat_togglewidgets ($aseco, $command) {
	global $re_config, $re_cache;


	if ($re_config['States']['GameState'] != 'score') {
		if ($re_config['States']['NiceMode'] == false) {

			// Get Player item
			$player = $aseco->server->players->getPlayer($command['author']->login);

			if ($player->data['RecordsEyepieceWidgetPreference'] == true) {

				// Set display to hidden
				$player->data['RecordsEyepieceWidgetPreference'] = false;

				// Hide the RecordWidgets
				re_closeRaceDisplays($player->login, false);

				// Give feedback to the Player
				$aseco->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($re_config['MESSAGES'][0]['WIDGETS_DISABLED'][0]), $player->login));
			}
			else {
				// Init
				$widgets = '';

				// Set display to displaying
				$player->data['RecordsEyepieceWidgetPreference'] = true;

				// Build the RecordWidgets and in normal mode send it to each or given Player (if refresh is required)
				$re_cache['PlayerStates'][$player->login]['DedimaniaRecords'] = -1;
				$re_cache['PlayerStates'][$player->login]['GerymaniaRecords'] = -1;
				$re_cache['PlayerStates'][$player->login]['LocalRecords'] = -1;
				$re_cache['PlayerStates'][$player->login]['LiveRankings'] = -1;
				re_buildRecordWidgets($player, array('DedimaniaRecords' => true, 'GerymaniaRecords' => true, 'LocalRecords' => true, 'LiveRankings' => true));

				if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
					// Display the Music Widget to given Player
					$widgets .= (($re_cache['MusicWidget'] != false) ? $re_cache['MusicWidget'] : '');
				}

				// Give feedback to the Player
				$aseco->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($re_config['MESSAGES'][0]['WIDGETS_ENABLED'][0]), $player->login));


				// Send all widgets
				if ($widgets != '') {
					// Send Manialink
					re_sendManialink($widgets, $player->login);
				}
			}
		}
		else {
			// RecordWidgets are in NiceMode and can not be hidden so give feedback to the Player
			$aseco->addCall('ChatSendServerMessageToLogin', array($aseco->formatColors($re_config['MESSAGES'][0]['TOGGLING_DISABLED'][0]), $player->login));
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onEverySecond
// $dedi_db is imported from plugin.dedimania.php
// $gery_db is imported from plugin.gerymania.php
function re_onEverySecond ($aseco) {
	global $re_config, $re_scores, $dedi_db, $gery_db;


	// Is it time for refresh the RecordWidgets?
	if (time() >= $re_config['States']['RefreshTimestampRecordWidgets']) {

		// Set next refresh timestamp
		$re_config['States']['RefreshTimestampRecordWidgets'] = (time() + $re_config['REFRESH_INTERVAL'][0]);

		// Get current Gamemode
		$gamemode = $aseco->server->gameinfo->mode;

		// Check for changed LocalRecords, e.g. on "/admin delrec 1"...
		if ($re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) {
			if (count($aseco->server->records->record_list) >= 1) {
				$localDigest = re_buildRecordDigest('locals', $aseco->server->records->record_list);
				if ($re_scores['LocalRecordsChkSum'] != $localDigest) {
					$re_config['States']['LocalRecords']['NeedUpdate'] = true;
				}
			}
		}

		// Check for changes at Dedimania
		if ($re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) {
			if ( isset($dedi_db['Challenge']['Records']) ) {
				$dedimaniaDigest = re_buildRecordDigest('dedimania', $dedi_db['Challenge']['Records']);
				if ($re_scores['DedimaniaRecordsChkSum'] != $dedimaniaDigest) {
					$re_config['States']['DedimaniaRecords']['NeedUpdate'] = true;
				}
			}
		}

		// Check for changes at Gerymania
		if ($re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) {
			if ($gery_db != false) {
				$gerymaniaDigest = re_buildRecordDigest('gerymania', $gery_db);
				if ($re_scores['GerymaniaRecordsChkSum'] != $gerymaniaDigest) {
					$re_config['States']['GerymaniaRecords']['NeedUpdate'] = true;
				}
			}
		}


		// Build the RecordWidgets and ONLY in normal mode send it to each or given Player (if refresh is required)
		re_buildRecordWidgets(false, false);

		if ($re_config['States']['NiceMode'] == true) {
			// Display the RecordWidgets to all Players (if refresh is required)
			$widgets = re_showRecordWidgets(false);

			// Send all widgets
			if ($widgets != '') {
				// Send Manialink
				re_sendManialink($widgets, false);
			}
		}

		// Just refreshed, mark as fresh
		$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= false;
		$re_config['States']['LocalRecords']['UpdateDisplay']		= false;
		$re_config['States']['LiveRankings']['UpdateDisplay']		= false;
		$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= false;
	}

	if (time() >= $re_config['States']['RefreshTimestampMinute']) {
		$re_config['States']['RefreshTimestampMinute'] = (time() + 60);
		re_onEveryMinute();
	}

	if (time() >= $re_config['States']['RefreshTimestampScorelists']) {
		$re_config['States']['RefreshTimestampScorelists'] = (time() + $re_config['SCORETABLE_LISTS'][0]['REFRESH_INTERVAL'][0]);
		if (count($aseco->server->players->player_list) > 0) {
			re_refreshScorelists('secondary');
		}
	}

	// Is it time for refresh the RecordWidgets?
	if (time() >= $re_config['States']['RefreshTimestampPreload']) {
		$re_config['States']['RefreshTimestampPreload'] = (time() + 5);

		foreach ($aseco->server->players->player_list as &$player) {
			if ( (time() >= $player->data['RecordsEyepiecePreloadTimestamp']) && ($player->data['RecordsEyepiecePreloadedPart'] != 11) ) {
				$player->data['RecordsEyepiecePreloadedPart'] += 1;
				$widgets = re_buildImagePreload($player->data['RecordsEyepiecePreloadedPart']);

				if ($widgets != '') {
					// Send Manialink
					re_sendManialink($widgets, $player->login);
				}
			}
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_onEveryMinute () {
	global $aseco, $re_config;


	// Bail out if there are no Players
	if (count($aseco->server->players->player_list) == 0) {
		return;
	}

	// Init
	$widgets = '';

	// Refresh the Clock if enabled, but not if we are at score (do not make the Clock clickable at score)
	if ( ($re_config['CLOCK_WIDGET'][0]['ENABLED'][0] == true) && ($re_config['States']['GameState'] != 'score') ) {
		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {
				// Parameter: $player->login, $timezone, $clickable
				re_buildClockWidget($player->login, $player->data['RecordsEyepiecePlayerTimezone']->realname, true);
			}
		}
		else {
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, false, false);
		}
	}


	// Send all widgets
	if ($widgets != '') {
		// Send Manialink
		re_sendManialink($widgets, false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_refreshScorelists ($refresh = false) {
	global $aseco, $re_config, $re_cache;


	// Called at the event onBeginRound ('main') or onSync ('all')
	if ( ($refresh == 'main') || ($refresh == 'all') ) {
		// Refresh the TopRankings Array
		re_getTopRankings();
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ENABLED'][0] == true) {
			$re_cache['TopRankings'] = re_buildTopRankingsForScore($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ENTRIES'][0]);
		}

		// Refresh the TopWinners Array
		re_getTopWinners();
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENABLED'][0] == true) {
			$re_cache['TopWinners'] = re_buildTopWinnersForScore($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENTRIES'][0]);
		}

		// Refresh MostRecords Array
		re_getMostRecords();
		if ($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ENABLED'][0] == true) {
			$re_cache['MostRecords'] = re_buildMostRecordsForScore($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ENTRIES'][0]);
		}

		// Refresh the MostFinished Array
		re_getMostFinished();
		if ($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ENABLED'][0] == true) {
			$re_cache['MostFinished'] = re_buildMostFinishedForScore($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ENTRIES'][0]);
		}

		// Refresh the TopDonators Array (if required)
		if ($re_config['States']['TopDonators']['NeedUpdate'] == true) {
			re_getTopDonators();
		}
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENABLED'][0] == true) {
			$re_cache['TopDonators'] = re_buildTopDonatorsForScore($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENTRIES'][0]);
		}

		// Refresh TopTracks Array (if required)
		if ($re_config['States']['TopTracks']['NeedUpdate'] == true) {
			re_getTopTracks();
		}
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ENABLED'][0] == true) {
			$re_cache['TopTracks'] = re_buildTopTracksForScore($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ENTRIES'][0]);
		}

		// Refresh TopVoters Array (if required)
		if ($re_config['States']['TopVoters']['NeedUpdate'] == true) {
			re_getTopVoters();
		}
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ENABLED'][0] == true) {
			$re_cache['TopVoters'] = re_buildTopVotersForScore($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ENTRIES'][0]);
		}

		// Refresh the TopBetwins Array
		re_getTopBetwins();
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ENABLED'][0] == true) {
			$re_cache['TopBetwins'] = re_buildTopBetwinsForScore($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ENTRIES'][0]);
		}
	}


	// Called at when the $re_config['States']['RefreshTimestampScorelists'] is getting old ('secondary') or onSync ('all')
	if ( ($refresh == 'secondary') || ($refresh == 'all') ) {
		// Refresh the TopPlaytime Array
		re_getTopPlaytime();
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ENABLED'][0] == true) {
			$re_cache['TopPlaytime'] = re_buildTopPlaytimeForScore($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ENTRIES'][0]);
		}

		// Refresh the TopNations Array
		re_getNationList();
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ENABLED'][0] == true) {
			$re_cache['TopNations'] = re_buildTopNationsForScore($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ENTRIES'][0]);
		}

		// Refresh the Visitors Array
		if ($re_config['VISITORS_WIDGET'][0]['ENABLED'][0] == true) {
			re_getVisitors();
			$re_cache['VisitorsWidget'] = re_buildVisitorsWidget();
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onPlayerConnect
function re_onPlayerConnect ($aseco, $player) {
	global $re_config, $re_scores, $re_cache;


	// Check if it is time to switch from "normal" to "nice"-mode or back
	re_checkServerLoad();

	// Init Player-Storages
	$player->data['RecordsEyepieceWindowPage'] = 0;
	$player->data['RecordsEyepieceTracklistFilter'] = false;
	$player->data['RecordsEyepieceTracksRecords'] = array();

	// Init
	$widgets = '';

	// Set Widget to displayed default (need for F7 or /togglewidgets)
	$player->data['RecordsEyepieceWidgetPreference'] = true;

	// Preset an empty RecordEntry for the RecordWidgets, required
	// for an empty entry for this Player if he/she did not has a Record yet
	$item = array();
	$item['login'] = $player->login;
	$item['nickname'] = re_handleSpecialChars($player->nickname);
	$item['self'] = 0;
	$item['rank'] = '--';
	$player->data['RecordsEyepieceWidgetEmptyEntry'] = $item;


	// Add this Player to the Hash-Compare-Process
	$re_cache['PlayerStates'][$player->login]['DedimaniaRecords']	= false;
	$re_cache['PlayerStates'][$player->login]['GerymaniaRecords']	= false;
	$re_cache['PlayerStates'][$player->login]['LocalRecords']	= false;
	$re_cache['PlayerStates'][$player->login]['LiveRankings']	= false;
	$re_cache['PlayerStates'][$player->login]['FinishScore']	= -1;


	if ($re_config['WELCOME_WINDOW'][0]['ENABLED'][0] == true) {
		if ($re_config['WELCOME_WINDOW'][0]['AUTOHIDE'][0] > 0) {
			// Send the content direct to the Player
			re_buildWelcomeWindow($player->login);
		}
		else {
			// Include the content to all other Widgets and send them together
			$widgets .= re_buildWelcomeWindow(false);
		}
	}

	if ($re_config['CLOCK_WIDGET'][0]['ENABLED'][0] == true) {
		if ($re_config['States']['NiceMode'] == false) {

			// Load the Player preferences for the Clock-Widget
			re_loadPlayerPreferences($player->login);

			// Parameter: $player->login, $timezone, $clickable
			re_buildClockWidget($player->login, $player->data['RecordsEyepiecePlayerTimezone']->realname, true);
		}
		else {
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, false, false);
		}
	}

	// Display the Scoretable Widget to connecting Player
	$widgets .= $re_cache['ToplistWidget'];

	if ($re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Gamemode Widget to connecting Player
		$widgets .= (($re_cache['GamemodeWidget'] != false) ? $re_cache['GamemodeWidget'] : '');
	}

	if ($re_config['VISITORS_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Visitors-Widget to connecting Player
		$widgets .= (($re_cache['VisitorsWidget'] != false) ? $re_cache['VisitorsWidget'] : '');
	}

	if ($re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Trackcount-Widget to connecting Player
		$widgets .= (($re_cache['TrackcountWidget'] != false) ? $re_cache['TrackcountWidget'] : '');
	}

	if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Music Widget to connecting Player
		$widgets .= (($re_cache['MusicWidget'] != false) ? $re_cache['MusicWidget'] : '');
	}

	if ($re_config['States']['NiceMode'] == true) {
		// Display the RecordWidgets to calling Player
		$widgets .= re_showRecordWidgets(true);
	}
	else {
		// Find any Records for this Player and if found, refresh the concerned Widgets
		$result = re_findPlayerRecords($player->login);
		if ( ($result['DedimaniaRecords'] == true) || ($result['LocalRecords'] == true) || ($result['GerymaniaRecords'] == true) ) {
			// New Player has one Record, need to refresh concerned Widgets (without LiveRankings) at ALL Players, but not current Player
			$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
			$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
			$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
		}

		// Now the connected Player need all Widgets to be displayed, not only that where he/she has a record
		re_buildRecordWidgets($player, array('DedimaniaRecords' => true, 'GerymaniaRecords' => true, 'LocalRecords' => true, 'LiveRankings' => true));
	}

	// Set ActionKeys
	$widgets .= (($re_cache['ManialinkActionKeys'] != false) ? $re_cache['ManialinkActionKeys'] : '');

	// Display the PlacementWidgets at state 'always'
	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['PlacementWidget']['Always'] != false) ? $re_cache['PlacementWidget']['Always'] : '');
	}

	// Display the PlacementWidgets at state 'race'
	if ( ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) && ($re_config['States']['GameState'] != 'score') ) {
		$widgets .= (($re_cache['PlacementWidget']['Race'] != false) ? $re_cache['PlacementWidget']['Race'] : '');
	}

	// Display the ChallengeWidget
	$widgets .= (($re_cache['ChallengeWidget']['Default'] != false) ? $re_cache['ChallengeWidget']['Default'] : '');

	// Mark this Player for need to preload Images
	$player->data['RecordsEyepiecePreloadTimestamp'] = (time() + 15);
	$player->data['RecordsEyepiecePreloadedPart'] = 0;

	// Send all widgets
	if ($widgets != '') {
		// Send Manialink
		re_sendManialink($widgets, $player->login);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onPlayerDisconnect
function re_onPlayerDisconnect ($aseco, $player) {
	global $re_config, $re_cache;


	// Check if it is time to switch from "normal" to "nice"-mode or back
	re_checkServerLoad();


	// Find any Records for this Player and if found, refresh the concerned Widgets
	$result = re_findPlayerRecords($player->login);
	if ( ($result['DedimaniaRecords'] == true) || ($result['LocalRecords'] == true) || ($result['GerymaniaRecords'] == true) ) {
		// Leaving Player has one Record, need to refresh concerned Widgets (without LiveRankings) at ALL Players, but not current Player
		$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
		$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
		$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	}

	// Remove this Player from the Hash-Compare-Process
	unset($re_cache['PlayerStates'][$player->login]);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onPlayerFinish
function re_onPlayerFinish ($aseco, $finish_item) {
	global $re_config, $re_scores, $re_cache;


	// If no actual finish, bail out immediately
	if ($finish_item->score == 0) {
		return;
	}

	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	// Check if the Player has a better score as before
	$refresh = false;
	if ($re_cache['PlayerStates'][$finish_item->player->login]['FinishScore'] == -1) {
		// New Score, store them
		$re_cache['PlayerStates'][$finish_item->player->login]['FinishScore'] = $finish_item->score;

		// Let the Widget refresh
		$refresh = true;
	}
	else if ( ($finish_item->score < $re_cache['PlayerStates'][$finish_item->player->login]['FinishScore']) && ($gamemode != 4) ) {
		// All Gamemodes (except Gamemode 'Stunts'): Lower = Better

		// Better Score, store them
		$re_cache['PlayerStates'][$finish_item->player->login]['FinishScore'] = $finish_item->score;

		// Let the Widget refresh
		$refresh = true;
	}
	else if ( ($finish_item->score > $re_cache['PlayerStates'][$finish_item->player->login]['FinishScore']) && ($gamemode == 4) ) {
		// Only at Gamemode 'Stunts': Higher = Better

		// Better Score, store them
		$re_cache['PlayerStates'][$finish_item->player->login]['FinishScore'] = $finish_item->score;

		// Let the Widget refresh
		$refresh = true;
	}


	// Refresh the LiveRankings-Widget only if there is a better Score
	if ($refresh == true) {

		if ($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ENABLED'][0] == true) {
			// Increase finish count for this Player if in TOP
			foreach ($re_scores['MostFinished'] as &$item) {
				if ($item['login'] == $finish_item->player->login) {
					$item['score']++;
					break;
				}
			}
		}

		// Player finished the Challenge, need to Update the 'LiveRanking',
		// but not at Gamemode 'Rounds' - that are only updated at the event 'onEndRound'!
		if ($gamemode != 0) {
			$re_config['States']['LiveRankings']['NeedUpdate'] = true;
			$re_config['States']['LiveRankings']['NoRecordsFound'] = false;
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onPlayerWins
function re_onPlayerWins ($aseco, $player) {
	global $re_config, $re_scores;


	if ($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENABLED'][0] == true) {
		// Increase winning count for this Player if in TOP
		foreach ($re_scores['TopWinners'] as &$item) {
			if ($item['login'] == $player->login) {
				// Lets refresh them at event onEndRace1
				$re_config['States']['TopWinners']['NeedUpdate'] = true;

				$item['score']++;
				break;
			}
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onPlayerManialinkPageAnswer
// $answer = [0]=PlayerUid, [1]=Login, [2]=Answer
function re_onPlayerManialinkPageAnswer ($aseco, $answer) {
	global $re_config, $re_cache, $re_placement;


	// If id = 0, bail out immediately
	if ($answer[2] == 0) {
		return;
	}

	// Init
	$widgets = '';

	// Get the Player object
	$player = $aseco->server->players->player_list[$answer[1]];

	if ($answer[2] == 382009003) {

		// Toggle RecordsWidget for calling Player (F7)
		$command['author'] = $player;
		chat_togglewidgets($aseco, $command);

	}
	else if ($answer[2] == (int)$re_config['ManialinkId'] .'00') {

		// Close Window
		$widgets .= re_closeAllWindows();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'01') {

		// Maximize the ChallengeWidget
		$widgets .= (($re_cache['ChallengeWidget']['Maximized'] != false) ? $re_cache['ChallengeWidget']['Maximized'] : '');

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'02') {

		// Minimize the ChallengeWidget
		$widgets .= (($re_cache['ChallengeWidget']['Default'] != false) ? $re_cache['ChallengeWidget']['Default'] : '');

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'03') {

		// Show the ClockDetailsWindow
		$widgets .= re_buildClockDetailsWindow($player->data['RecordsEyepiecePlayerTimezone']->realname, $player->data['RecordsEyepiecePlayerTimezone']->display, true, false);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'04') {

		// Show the DedimaniaRecordsWindow
		$widgets .= re_buildDedimaniaRecordsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'05') {

		// Show the LocalRecordsWindow
		$widgets .= re_buildLocalRecordsWindow(0);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'06') {

		// Show the LiveRankingsWindow
		if ( function_exists('ast_showScoretable') ) {
			$widgets .= re_closeAllWindows();
			ast_showScoretable($aseco, $player->login, 0, true, 0);		// $aseco, $caller, $timeout, $display_close, $page
		}
		else {
			$widgets .= re_buildLiveRankingsWindow(0);
		}

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'07') {

		// Show the GerymaniaRecordsWindow
		$widgets .= re_buildGerymaniaRecordsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'08') {

		// Show the TMXChallengeInfoWindow for this Challenge
		$widgets .= re_buildTMXChallengeInfoWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'09') {

		// Show the NationsWindow
		$widgets .= re_buildTopNationsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'10') {

		// Show the TopRankingsWindow
		$widgets .= re_buildTopRankingsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'11') {

		// Show the TopWinnersWindow
		$widgets .= re_buildTopWinnersWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'12') {

		// Show the MostRecordsWindow
		$widgets .= re_buildMostRecordsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'13') {

		// Show the MostFinishedWindow
		$widgets .= re_buildMostFinishedWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'14') {

		// Show the TopPlaytimeWindow
		$widgets .= re_buildTopPlaytimeWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'15') {

		// Show the TopDonatorsWindow
		$widgets .= re_buildTopDonatorsWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'16') {

		// Show the TopTracksWindow
		$widgets .= re_buildTopTracksWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'17') {

		// Show the TopVotersWindow
		$widgets .= re_buildTopVotersWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'18') {

		// Show the MusiclistWindow
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildMusiclistWindow(0);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'19') {

		// Drop the current juke´d song from Players Jukebox
		if ( function_exists('chat_music') ) {
			$command['author'] = $player;
			$command['params'] = 'drop';
			chat_music($aseco, $command);
		}

		$page = $player->data['RecordsEyepieceWindowPage'];
		$widgets .= re_buildMusiclistWindow($page);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'20') {

		$player->data['RecordsEyepieceTracksRecords'] = re_getPlayerLocalRecords($player->id);
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$player->data['RecordsEyepieceTracklistFilter'] = false;

		// Show the TracklistWindow
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'21') {

		// Show the re_buildTracklistFilterWindow
		$widgets .= re_buildTracklistFilterWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'22') {

		// Show the TracklistWindow (but only with 'Stadium' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'STADIUM');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'23') {

		// Show the TracklistWindow (but only with 'Bay' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'BAY');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'24') {

		// Show the TracklistWindow (but only with 'Coast' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'COAST');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'25') {

		// Show the TracklistWindow (but only with 'Desert' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'DESERT');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'26') {

		// Show the TracklistWindow (but only with 'Island' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'ISLAND');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'27') {

		// Show the TracklistWindow (but only with 'Rally' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'RALLY');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'28') {

		// Show the TracklistWindow (but only with 'Alpine' Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('env' => 'ALPINE');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'39') {

		// Show the TracklistWindow (display all Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = false;
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'40') {

		// Show the TracklistWindow (but only jukeboxed Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'JUKEBOX');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'41') {

		// Show the TracklistWindow (but only no recent Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NORECENT');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'42') {

		// Show the TracklistWindow (but only recent Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'ONLYRECENT');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'43') {

		// Show the TracklistWindow (but only Tracks without a rank)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NORANK');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'44') {

		// Show the TracklistWindow (but only Tracks with a rank)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'ONLYRANK');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'45') {

		// Show the TracklistWindow (but only Tracks no gold time)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NOGOLD');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'46') {

		// Show the TracklistWindow (but only Tracks no author time)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NOAUTHOR');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'47') {

		// Show the TracklistWindow (but only Tracks with mood sunrise)
		$player->data['RecordsEyepieceTracklistFilter'] = array('mood' => 'SUNRISE');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'48') {

		// Show the TracklistWindow (but only Tracks with mood day)
		$player->data['RecordsEyepieceTracklistFilter'] = array('mood' => 'DAY');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'49') {

		// Show the TracklistWindow (but only Tracks with mood sunset)
		$player->data['RecordsEyepieceTracklistFilter'] = array('mood' => 'SUNSET');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'50') {

		// Show the TracklistWindow (but only Tracks with mood night)
		$player->data['RecordsEyepieceTracklistFilter'] = array('mood' => 'NIGHT');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'51') {

		// Show the TracklistWindow (but only Multilap Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'ONLYMULTILAP');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'52') {

		// Show the TracklistWindow (but only no Multilap Tracks)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NOMULTILAP');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'53') {

		// Show the TracklistWindow (but only Tracks no silver time)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NOSILVER');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'54') {

		// Show the TracklistWindow (but only Tracks no bronze time)
		$player->data['RecordsEyepieceTracklistFilter'] = array('cmd' => 'NOBRONZE');
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'56') {

		// Show the TrackauthorlistWindow
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTrackauthorlistWindow(0, $player);

	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'100') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'149') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 100 );
		$widgets .= re_buildLocalRecordsWindow($page);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'100') && ($answer[2] <= (int)$re_config['ManialinkId'] .'149') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 100 );
		$widgets .= re_buildLocalRecordsWindow($page);

	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'150') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'152') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 150 );
		$widgets .= re_buildLiveRankingsWindow($page);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'150') && ($answer[2] <= (int)$re_config['ManialinkId'] .'152') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 150 );
		$widgets .= re_buildLiveRankingsWindow($page);

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'153') {

		// Show the ToplistWindow
		$widgets .= re_buildToplistWindow();

	}
	else if ($answer[2] == $re_config['ManialinkId'] .'154') {

		// Show the TopBetwinsWindow
		$widgets .= re_buildTopBetwinsWindow();

	}
	else if ($answer[2] == -(int)$re_config['ManialinkId'] .'160') {

		$widgets .= re_buildHelpWindow(0, $player);

	}
	else if ($answer[2] == (int)$re_config['ManialinkId'] .'160') {

		$widgets .= re_buildHelpWindow(1, $player);

	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'200') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'294') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 200 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildMusiclistWindow($page);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'200') && ($answer[2] <= (int)$re_config['ManialinkId'] .'294') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 200 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildMusiclistWindow($page);

	}
	else if ( ($answer[2] >= sprintf("%d%d", $re_config['ManialinkId'], 300) ) && ($answer[2] <= sprintf("%d%d", $re_config['ManialinkId'], 349)) ) {

		// Do not display at score
		if ($re_config['States']['GameState'] != 'score') {
			// Get the selected timezone-group
			$timezone_group = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 300 );

			$widgets .= re_buildClockDetailsWindow($player->data['RecordsEyepiecePlayerTimezone']->realname, $player->data['RecordsEyepiecePlayerTimezone']->display, true, $timezone_group);
		}

	}
	else if ( ($answer[2] >= sprintf("%d%d", $re_config['ManialinkId'], 350) ) && ($answer[2] <= sprintf("%d%d", $re_config['ManialinkId'], 999)) ) {

		// Get the selected timezone
		$timezone_id = (intval( str_replace($re_config['ManialinkId'], '', $answer[2]) ) - 350);

		$array_count = 0;
		$timezone_display = false;
		$timezone_realname = false;
		foreach ($re_config['Timezones'] as $group => &$child) {
			foreach ($child as $display_name => $php_timezone) {
				if ($array_count == $timezone_id) {
					$timezone_display = $display_name;
					$timezone_realname = $php_timezone;
					break 2;
				}
				$array_count ++;
			}
		}

		if ($timezone_display != false) {
			// Save the selected timezone for this Player
			$player->data['RecordsEyepiecePlayerTimezone']->display = $timezone_display;
			$player->data['RecordsEyepiecePlayerTimezone']->realname = $timezone_realname;

			mysql_query("UPDATE `players_extra` SET `timezone`='". $timezone_display.'|'.$timezone_realname ."' WHERE `playerID`='". $player->data['RecordsEyepieceDatabasePlayerId'] ."';");

			// Refresh the clock for this Player
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, $player->data['RecordsEyepiecePlayerTimezone']->realname, true);
		}

		// Close the ClockDetailsWindow
		$widgets .= re_closeAllWindows();

	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'1000') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'1249') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 1000 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildTracklistWindow($page, $player);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'1000') && ($answer[2] <= (int)$re_config['ManialinkId'] .'1249') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 1000 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildTracklistWindow($page, $player);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'2000') && ($answer[2] <= (int)$re_config['ManialinkId'] .'6999') ) {

		// Get the selected Track
		$id = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 2000 );

		// Store tracks in Player object for jukeboxing with plugin.rasp_jukebox.php
		$player->tracklist = array();
		$item = array();
		$item['name']		= $re_cache['Tracklist'][$id]['name'];
		$item['author']		= $re_cache['Tracklist'][$id]['author'];
		$item['environment']	= $re_cache['Tracklist'][$id]['env'];
		$item['filename']	= $re_cache['Tracklist'][$id]['file'];
		$item['uid']		= $re_cache['Tracklist'][$id]['uid'];
		$player->tracklist[] = $item;

		// Juke the selected Track
		if ( function_exists('chat_jukebox') ) {
			$command['author'] = $player;
			$command['params'] = 1;
			chat_jukebox($aseco, $command);
		}

		// Refresh on juke´d track (action from plugin.rasp_jukebox.php)
		$widgets .= re_buildTracklistWindow($player->data['RecordsEyepieceWindowPage'], $player);
	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'7000') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'7249') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 7000 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildTrackauthorlistWindow($page, $player);

	}
	else if ( ($answer[2] >= (int)$re_config['ManialinkId'] .'7000') && ($answer[2] <= (int)$re_config['ManialinkId'] .'7249') ) {

		// Get the wished Page
		$page = intval( str_replace($re_config['ManialinkId'], '', $answer[2]) - 7000 );
		$player->data['RecordsEyepieceWindowPage'] = $page;
		$widgets .= re_buildTrackauthorlistWindow($page, $player);

	}
	else if ( ($answer[2] <= -(int)$re_config['ManialinkId'] .'8000') && ($answer[2] >= -(int)$re_config['ManialinkId'] .'12999') ) {

		// Find the selected TrackAuthor
		$id = intval( str_replace($re_config['ManialinkId'], '', abs($answer[2])) - 8000 );

		// Show the TracklistWindow (but only Tracks from the selected TrackAuthor)
		$player->data['RecordsEyepieceTracklistFilter'] = array('author' => $re_cache['TrackAuthors'][$id]);
		$player->data['RecordsEyepieceWindowPage'] = 0;
		$widgets .= re_buildTracklistWindow(0, $player);

	}
	else if ( ($answer[2] >= -2100) && ($answer[2] <= -2001) ) {

		// Refresh on drop track from jukebox (action from plugin.rasp_jukebox.php)

		// Turn of the automatic "/jukebox display"
		mainwindow_off($aseco, $player->login);

		$page = $player->data['RecordsEyepieceWindowPage'];
		$widgets .= re_buildTracklistWindow($page, $player);

	}
	else if ( ($answer[2] >= -4000) && ($answer[2] <= -2101) ) {

		// Refresh on juke´d song (action from plugin.musicserver.php)
		$page = $player->data['RecordsEyepieceWindowPage'];
		$widgets .= re_buildMusiclistWindow($page);

	}
	else if ($answer[2] == 20) {

		// Refresh on drop complete jukebox (action from plugin.rasp_jukebox.php)
		$page = $player->data['RecordsEyepieceWindowPage'];
		$widgets .= re_buildTracklistWindow($page, $player);

	}


	// Send all widgets
	if ($widgets != '') {
		// Send Manialink
		re_sendManialink($widgets, $player->login);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onDedimaniaRecord (event from plugin.dedimania.php)
function re_onDedimaniaRecord ($aseco, $record) {
	global $re_config;


	// Player reached an new Record at the Challenge, need to Update the 'DedimaniaRecords'
	$re_config['States']['DedimaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['DedimaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['DedimaniaRecords']['TryCount']		= 0;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onGerymaniaRecord (event from plugin.gerymania.php)
function re_onGerymaniaRecord ($aseco, $record) {
	global $re_config;


	// Player reached an new Record at the Challenge, need to Update the 'GerymaniaRecords'
	$re_config['States']['GerymaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['GerymaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['GerymaniaRecords']['TryCount']		= 0;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onLocalRecord (event from plugin.localdatabase.php)
function re_onLocalRecord ($aseco, $finish_item) {
	global $re_config, $re_scores;


	if ($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ENABLED'][0] == true) {

		// Check if the Player has already a LocalRecord, if not only then increase MostRecords
		// to prevent double countings.
		$found = false;
		foreach ($re_scores['LocalRecords'] as &$item) {
			if ($finish_item->player->login == $item['login']) {
				$found = true;
				break;
			}
		}
		if ($found == false) {
			// Increase Record count for this Player
			foreach ($re_scores['MostRecords'] as &$item) {
				if ($finish_item->player->login == $item['login']) {
					$item['score']++;
					break;
				}
			}
		}
	}

	// Player reached an new Record at the Challenge, need to Update the 'LocalRecords'
	$re_config['States']['LocalRecords']['NeedUpdate'] = true;
	$re_config['States']['LocalRecords']['NoRecordsFound'] = false;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onJukeboxChanged (event from plugin.rasp_jukebox.php/chat.admin.php)
// $jukebox is imported from plugin.rasp_jukebox.php
// $command[0] = 'add', 'clear', 'drop', 'play', 'replay', 'restart' & 'skip'
// $command[1] = track data (or 'null' for the 'clear' action)
function re_onJukeboxChanged ($aseco, $command) {
	global $re_config, $re_cache, $jukebox;


	// Init
	$widgets = '';

	if ($command[0] == 'clear') {
		$re_config['Challenge']['Jukebox'] = false;
	}

	// Check for changed Tracklist and refresh
	if ($command[0] == 'add') {
		// Get the new Tracklist
		re_getTracklist();

		if ($re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0] == true) {
			// Refresh the TrackcountWidget
			$re_cache['TrackcountWidget'] = re_buildTrackcountWidget();

			// Display the Trackcount-Widget to all Player
			$widgets .= (($re_cache['TrackcountWidget'] != false) ? $re_cache['TrackcountWidget'] : '');
		}
	}

	// Check for changed Jukebox and refresh if required
	if ( ($command[0] == 'add') || ($command[0] == 'drop') || ($command[0] == 'play') || ($command[0] == 'replay') || ($command[0] == 'restart') || ($command[0] == 'skip') ) {
		// Is a Challenge in the Jukebox?
		if (count($jukebox) > 0) {
			foreach ($jukebox as &$track) {
				// Need just the next juke'd Challenge Information, not more
				$re_config['Challenge']['Jukebox'] = $track;
				break;
			}
		}
//		else if ($command[0] == 'restart') {
//			$re_config['Challenge']['Jukebox'] = $re_config['Challenge']['Current'];
//		}
		else {
			$re_config['Challenge']['Jukebox'] = false;
		}


		// Rebuild the Widgets
		$re_cache['ChallengeWidget']['Maximized']	= re_buildChallengeWidget('maximize');
		$re_cache['ChallengeWidget']['Score']		= re_buildChallengeWidget('score');

		// Check if we are at score and refresh the "Next Challenge" Widget
		if ($re_config['States']['GameState'] == 'score') {

			if ( ($command[0] == 'replay') || ($command[0] == 'restart') || ($command[0] == 'skip') ) {
				// Display the ChallengeWidget (if enabled)
				$widgets .= (($re_cache['ChallengeWidget']['Score'] != false) ? $re_cache['ChallengeWidget']['Score'] : '');
			}
		}
	}


	if ($widgets != '') {
		// Send Manialink to all Players
		re_sendManialink($widgets, false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onMusicboxReloaded (event from plugin.musicserver.php)
function re_onMusicboxReloaded ($aseco) {
	global $re_config;


	// Build the Playlist-Cache
	re_getMusicServerPlaylist();
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onDonation (event from plugin.donate.php)
// $donation = [0]=login, [1]=coppers
function re_onDonation ($aseco, $donation) {
	global $re_config, $re_scores;


	if ($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENABLED'][0] == true) {
		// Increase donations for this Player if in TOP
		foreach ($re_scores['TopDonators'] as &$item) {
			if ($item['login'] == $donation[0]) {
				// Lets refresh them at event onEndRace1
				$re_config['States']['TopDonators']['NeedUpdate'] = true;

				$item['score'] += $donation[1];
				break;
			}
		}
	}

}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onKarmaChange (event from plugin.tm-karma-dot-com.php or plugin.rasp_karma.php)
function re_onKarmaChange ($aseco, $karma) {
	global $re_config;


	// Notice that the Karma need a refresh
	$re_config['States']['TopTracks']['NeedUpdate'] = true;
	$re_config['States']['TopVoters']['NeedUpdate'] = true;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onStatusChangeTo3
function re_onStatusChangeTo3 ($aseco, $call) {
	global $re_config;


	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	// At $gamemode 'rounds', 'team' and 'cup' need to emulate 'onNewChallenge'
	if ( ($gamemode == 0) || ($gamemode == 2) || ($gamemode == 5) ) {
		re_onNewChallenge($aseco, false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onBeginRound
function re_onBeginRound ($aseco) {
	global $re_config;


	// At Gamemode 'Rounds' or 'TeamMode' need to refresh now
	if ( ($aseco->server->gameinfo->mode == 0) || ($aseco->server->gameinfo->mode == 2) ) {
		// Init
		$widgets = '';

		// Build the RecordWidgets and ONLY in normal mode send it to each or given Player (if refresh is required)
		re_buildRecordWidgets(false, false);

		if ($re_config['States']['NiceMode'] == true) {
			// Display the RecordWidgets to all Players
			$widgets .= re_showRecordWidgets(false);
		}

		// Send widgets to all Players
		if ($widgets != '') {
			// Send Manialink
			re_sendManialink($widgets, false);
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onEndRound
function re_onEndRound ($aseco) {
	global $re_config;


	// At Gamemode 'Rounds' or 'TeamMode' need to refresh now
	if ( ($aseco->server->gameinfo->mode == 0) || ($aseco->server->gameinfo->mode == 2) ) {
		$re_config['States']['LiveRankings']['NeedUpdate']	= true;
		$re_config['States']['LiveRankings']['NoRecordsFound']	= false;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onNewChallenge
function re_onNewChallenge ($aseco, $challenge_item) {
	global $re_config, $re_cache;


	// Close the Scoretable-Lists at all Players
	$widgets = re_closeScoretableLists();
	re_sendManialink($widgets, false);


	// Check if it is time to switch from "normal" to "nice"-mode or back
	re_checkServerLoad();

	// Set current GameState
	$re_config['States']['GameState'] = 'race';

	// Get the current GameInfos, things about Pointslimit in Rounds and Team...
	$aseco->client->query('GetCurrentGameInfo', 1);
	$re_config['CurrentGameInfos'] = $aseco->client->getResponse();


	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	// Special handling for Gamemode 'Laps'
	if ( ($gamemode != 3) && ( !empty($aseco->events['onCheckpoint'])) ) {
		// Unregister (possible registered) onCheckpoint event for Gamemode 'Laps' if this is not 'Laps'
		$array_pos = 0;
		foreach ($aseco->events['onCheckpoint'] as $func_name) {
			if ($func_name == 're_onCheckpoint') {
				$aseco->console('[plugin.records_eyepiece.php] Unregister event onCheckpoint for Live-Rankings, Gamemode "Laps" is off...');
				unset($aseco->events['onCheckpoint'][$array_pos]);
				break;
			}
			$array_pos ++;
		}
	}
	else if ( ($gamemode == 3) && ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['DISPLAY_TYPE'][0] == false) ) {
		// Register event onCheckpoint in Gamemode 'Laps' and <display_type>checkpoints</display_type> at <live_rankings>
		$aseco->registerEvent('onCheckpoint', 're_onCheckpoint');
		$aseco->console('[plugin.records_eyepiece.php] Register event onCheckpoint for Live-Rankings at Gamemode "Laps"...');
	}


	// Setup the no-score Placeholder depending at the current Gamemode
	if ($gamemode == 4) {
		// 4 = Stunts
		$re_config['PlaceholderNoScore'] = '---';
	}
	else {
		$re_config['PlaceholderNoScore'] = '-:--.--';
	}


	// Reset at each Player the Hash
	foreach ($aseco->server->players->player_list as &$player) {
		$re_cache['PlayerStates'][$player->login]['DedimaniaRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['GerymaniaRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['LocalRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['LiveRankings']	= false;
		$re_cache['PlayerStates'][$player->login]['FinishScore']	= -1;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onNewChallenge2
function re_onNewChallenge2 ($aseco, $challenge_item) {
	global $re_config, $re_cache;


	$aseco->client->query('ManualFlowControlEnable', true);
//	$result = $aseco->client->getResponse();
//	$aseco->console('****** ManualFlowControlEnable(true) '.  var_dump($result) );
//
//	$aseco->client->query('ManualFlowControlIsEnabled');
//	$result = $aseco->client->getResponse();
//	$aseco->console('****** ManualFlowControlIsEnabled() '.  var_dump($result) );


	// Refresh some Scorelists
	if (count($aseco->server->players->player_list) > 0) {
		re_refreshScorelists('main');
	}

	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	// Store the Last-Challenge
	$re_config['Challenge']['Last']					= $re_config['Challenge']['Current'];

	// Store the Current-Challenge
	$re_config['Challenge']['Current']['name']			= re_handleSpecialChars($aseco->server->challenge->name);
	$re_config['Challenge']['Current']['author']			= $aseco->server->challenge->author;
	$re_config['Challenge']['Current']['uid']			= $aseco->server->challenge->uid;
	$re_config['Challenge']['Current']['env']			= $aseco->server->challenge->environment;
	$re_config['Challenge']['Current']['mood']			= $aseco->server->challenge->mood;
	if ($gamemode == 4) {
		// 'Stunts' GameMode
		$re_config['Challenge']['Current']['authortime']	= $aseco->server->challenge->gbx->ascore;		// AuthorScore
		$re_config['Challenge']['Current']['goldtime']		= $aseco->server->challenge->goldtime;
		$re_config['Challenge']['Current']['silvertime']	= $aseco->server->challenge->silvertime;
		$re_config['Challenge']['Current']['bronzetime']	= $aseco->server->challenge->bronzetime;
	}
	else {
		// All other GameModes
		$re_config['Challenge']['Current']['authortime']	= formatTime($aseco->server->challenge->authortime);	// AuthorTime
		$re_config['Challenge']['Current']['goldtime']		= formatTime($aseco->server->challenge->goldtime);
		$re_config['Challenge']['Current']['silvertime']	= formatTime($aseco->server->challenge->silvertime);
		$re_config['Challenge']['Current']['bronzetime']	= formatTime($aseco->server->challenge->bronzetime);
	}

	// Store the Next-Challenge
	$re_config['Challenge']['Next'] = re_getNextChallenge();

	// Display the ChallengeWidget (need this placed here, then only now all needed data filled at event onNewChallenge2)
	$re_cache['ChallengeWidget']['Default']				= re_buildChallengeWidget('default');
	$re_cache['ChallengeWidget']['Maximized']			= re_buildChallengeWidget('maximize');
	$re_cache['ChallengeWidget']['Score']				= re_buildChallengeWidget('score');


	// At Gamemode 'Laps' need to store some extra data
	if ($gamemode == 3) {
		$re_config['Challenge']['NbCheckpoints'] = $challenge_item->nbchecks;
//		$re_config['Challenge']['LapRace'] = $challenge_item->laprace;
	}


	// Init
	$widgets = '';

	if ($re_config['CLOCK_WIDGET'][0]['ENABLED'][0] == true) {
		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {
				// Parameter: $player->login, $timezone, $clickable
				re_buildClockWidget($player->login, $player->data['RecordsEyepiecePlayerTimezone']->realname, true);
			}
		}
		else {
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, false, false);
		}
	}

	if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
		// Build the Playlist-Cache
		re_getMusicServerPlaylist();

		// Display the Music Widget to all Players
		re_getCurrentSong();
		$re_cache['MusicWidget'] = re_buildMusicWidget();

		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {

				// Display the MusicWidget only to the Player if they did'nt has them set to hidden
				if ( ($player->data['RecordsEyepieceWidgetPreference'] == true) && ($re_cache['MusicWidget'] != false) ) {
					re_sendManialink($re_cache['MusicWidget'], $player->login);
				}
			}
		}
		else {
			$widgets .= (($re_cache['MusicWidget'] != false) ? $re_cache['MusicWidget'] : '');
		}
	}

	// Display the Scoretable Widget to all Players
	$widgets .= $re_cache['ToplistWidget'];

	if ($re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0] == true) {
		// Build & Display the Gamemode Widget to all Players
		$re_cache['GamemodeWidget'] = re_buildGamemodeWidget($gamemode);
		$widgets .= (($re_cache['GamemodeWidget'] != false) ? $re_cache['GamemodeWidget'] : '');
	}

	if ($re_config['VISITORS_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Visitors-Widget to all Players
		$widgets .= (($re_cache['VisitorsWidget'] != false) ? $re_cache['VisitorsWidget'] : '');
	}

	if ($re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0] == true) {
		// Refresh the TrackcountWidget
		$re_cache['TrackcountWidget'] = re_buildTrackcountWidget();

		// Display the Trackcount-Widget to all Player
		$widgets .= (($re_cache['TrackcountWidget'] != false) ? $re_cache['TrackcountWidget'] : '');
	}

	// Display the PlacementWidgets at state 'race'
	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['PlacementWidget']['Race'] != false) ? $re_cache['PlacementWidget']['Race'] : '');
	}


	// Reset states of the Widgets
	$re_config['States']['DedimaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['DedimaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['DedimaniaRecords']['TryCount']		= 0;
	$re_config['States']['LocalRecords']['NeedUpdate']		= true;
	$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
	$re_config['States']['LocalRecords']['NoRecordsFound']		= false;
	$re_config['States']['LiveRankings']['NeedUpdate']		= true;
	$re_config['States']['LiveRankings']['UpdateDisplay']		= true;
	$re_config['States']['LiveRankings']['NoRecordsFound']		= false;
	$re_config['States']['GerymaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['GerymaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['GerymaniaRecords']['TryCount']		= 0;

	// Build the RecordWidgets and ONLY in normal mode send it to each or given Player (if refresh is required)
	re_buildRecordWidgets(false, false);

	if ($re_config['States']['NiceMode'] == true) {
		// Display the RecordWidgets to all Players
		$widgets .= re_showRecordWidgets(false);
	}

	// Just refreshed, mark as fresh
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= false;
	$re_config['States']['LocalRecords']['UpdateDisplay']		= false;
	$re_config['States']['LiveRankings']['UpdateDisplay']		= false;
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= false;

	// Set next refresh timestamp
	$re_config['States']['RefreshTimestampRecordWidgets']		= (time() + $re_config['REFRESH_INTERVAL'][0]);

	// Set next refresh preload timestamp
	$re_config['States']['RefreshTimestampPreload']			= (time() + 5);

	// Store the possible Placeholder from TMX
	if ($aseco->server->challenge->tmx != false) {
		$re_config['PlacementPlaceholders']->track_tmx_prefix	= $aseco->server->challenge->tmx->prefix;
		$re_config['PlacementPlaceholders']->track_tmx_id	= $aseco->server->challenge->tmx->id;
		$re_config['PlacementPlaceholders']->track_tmx_pageurl	= $aseco->server->challenge->tmx->pageurl;
	}
	else {
		// Track not at TMX or TMX down
		$re_config['PlacementPlaceholders']->track_tmx_prefix	= false;
		$re_config['PlacementPlaceholders']->track_tmx_id	= false;
		$re_config['PlacementPlaceholders']->track_tmx_pageurl	= false;
	}
	$re_config['PlacementPlaceholders']->track_name			= $re_config['Challenge']['Current']['name'];
	$re_config['PlacementPlaceholders']->track_uid			= $aseco->server->challenge->uid;


	// Display the PlacementWidgets at state 'race'
	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['PlacementWidget']['Race'] != false) ? $re_cache['PlacementWidget']['Race'] : '');
	}


	// Include the ChallengeWidget (if enabled)
	$widgets .= (($re_cache['ChallengeWidget']['Default'] != false) ? $re_cache['ChallengeWidget']['Default'] : '');


	// Send widgets to all Players
	if ($widgets != '') {
		// Send Manialink
		re_sendManialink($widgets, false);
	}

	$aseco->client->query('ManualFlowControlEnable', false);
//	$result = $aseco->client->getResponse();
//	$aseco->console('****** ManualFlowControlEnable(false) '.  var_dump($result) );
//
//	$aseco->client->query('ManualFlowControlIsEnabled');
//	$result = $aseco->client->getResponse();
//	$aseco->console('****** ManualFlowControlIsEnabled() '.  var_dump($result) );
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// TMF: [0]=PlayerUid, [1]=Login, [2]=TimeScore, [3]=CurLap, [4]=CheckpointIndex
// This event is only activated in Gamemode 'Laps' and with <display_type>checkpoints</display_type> at <live_rankings>
function re_onCheckpoint ($aseco, $checkpt) {
	global $re_config;


	// If one Player has finish a round, let the Live-Rankings refresh
	if ( ($checkpt[4]+1) == ($re_config['Challenge']['NbCheckpoints'] * $checkpt[3]) ) {
		$re_config['States']['LiveRankings']['NeedUpdate'] = true;
		$re_config['States']['LiveRankings']['NoRecordsFound'] = false;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onRestartChallenge2
function re_onRestartChallenge2 ($aseco, $challenge) {
	global $re_config, $re_scores, $re_cache;


	// Set current state
	$re_config['States']['GameState'] = 'race';

	// Init
	$widgets = '';

	// Close the Scoretable-Lists at all Players
	$widgets .= re_closeScoretableLists();

	// Display the PlacementWidgets at state 'race'
	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['PlacementWidget']['Race'] != false) ? $re_cache['PlacementWidget']['Race'] : '');
	}

	if ($re_config['CLOCK_WIDGET'][0]['ENABLED'][0] == true) {
		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {
				// Parameter: $player->login, $timezone, $clickable
				re_buildClockWidget($player->login, $player->data['RecordsEyepiecePlayerTimezone']->realname, true);
			}
		}
		else {
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, false, false);
		}
	}

	if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Music Widget to all Players
		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {

				// Display the MusicWidget only to the Player if they did'nt has them set to hidden
				if ( ($player->data['RecordsEyepieceWidgetPreference'] == true) && ($re_cache['MusicWidget'] != false) ) {
					re_sendManialink($re_cache['MusicWidget'], $player->login);
				}
			}
		}

		else {
			$widgets .= (($re_cache['MusicWidget'] != false) ? $re_cache['MusicWidget'] : '');
		}
	}

	// Display the Scoretable Widget to all Players
	$widgets .= $re_cache['ToplistWidget'];

	if ($re_config['GAMEMODE_WIDGET'][0]['ENABLED'][0] == true) {
		// Build & Display the Gamemode Widget to all Players
		$re_cache['GamemodeWidget'] = re_buildGamemodeWidget($aseco->server->gameinfo->mode);
		$widgets .= (($re_cache['GamemodeWidget'] != false) ? $re_cache['GamemodeWidget'] : '');
	}

	if ($re_config['VISITORS_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Visitors-Widget to all Players
		$widgets .= (($re_cache['VisitorsWidget'] != false) ? $re_cache['VisitorsWidget'] : '');
	}

	if ($re_config['TRACKCOUNT_WIDGET'][0]['ENABLED'][0] == true) {
		// Display the Trackcount-Widget to all Player
		$widgets .= (($re_cache['TrackcountWidget'] != false) ? $re_cache['TrackcountWidget'] : '');
	}

	// Reset at each Player the Hash
	foreach ($aseco->server->players->player_list as &$player) {
		$re_cache['PlayerStates'][$player->login]['DedimaniaRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['GerymaniaRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['LocalRecords']	= false;
		$re_cache['PlayerStates'][$player->login]['LiveRankings']	= false;
		$re_cache['PlayerStates'][$player->login]['FinishScore']	= -1;
	}

	// Reset states of the Widgets
	$re_config['States']['DedimaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['DedimaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['DedimaniaRecords']['TryCount']		= 0;
	$re_config['States']['LocalRecords']['NeedUpdate']		= true;
	$re_config['States']['LocalRecords']['UpdateDisplay']		= true;
	$re_config['States']['LocalRecords']['NoRecordsFound']		= false;
	$re_config['States']['LiveRankings']['NeedUpdate']		= true;
	$re_config['States']['LiveRankings']['UpdateDisplay']		= true;
	$re_config['States']['LiveRankings']['NoRecordsFound']		= false;
	$re_config['States']['GerymaniaRecords']['NeedUpdate']		= true;
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= true;
	$re_config['States']['GerymaniaRecords']['NoRecordsFound']	= false;
	$re_config['States']['GerymaniaRecords']['TryCount']		= 0;

	// Build the RecordWidgets and ONLY in normal mode send it to each or given Player (if refresh is required)
	re_buildRecordWidgets(false, false);

	if ($re_config['States']['NiceMode'] == true) {
		// Display the RecordWidgets to all Players
		$widgets .= re_showRecordWidgets(false);
	}

	// Just refreshed, mark as fresh
	$re_config['States']['DedimaniaRecords']['UpdateDisplay']	= false;
	$re_config['States']['LocalRecords']['UpdateDisplay']		= false;
	$re_config['States']['LiveRankings']['UpdateDisplay']		= false;
	$re_config['States']['GerymaniaRecords']['UpdateDisplay']	= false;

	// Set next refresh timestamp
	$re_config['States']['RefreshTimestampRecordWidgets'] = (time() + $re_config['REFRESH_INTERVAL'][0]);


	// Display the ChallengeWidget (if enabled)
	$widgets .= (($re_cache['ChallengeWidget']['Default'] != false) ? $re_cache['ChallengeWidget']['Default'] : '');


	// Send all widgets
	if ($widgets != '') {
		// Send Manialink
		re_sendManialink($widgets, false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// called @ onEndRace1
function re_onEndRace1 ($aseco, $race) {
	global $re_config, $re_cache;


	// Bail out if there are no Players
	if (count($aseco->server->players->player_list) == 0) {
		return;
	}

	// Set current GameState
	$re_config['States']['GameState'] = 'score';

	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	// Refresh the TopWinners Array (if required)
	if ( ($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENABLED'][0] == true) && ($re_config['States']['TopWinners']['NeedUpdate'] == true) ) {
		$re_cache['TopWinners'] = re_buildTopWinnersForScore($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENTRIES'][0]);
		$re_config['States']['TopWinners']['NeedUpdate'] = false;
	}

	// Init
	$widgets = '';

	// Close all RaceWidgets at all connected Players (incl. all Windows)
	$widgets .= re_closeRaceDisplays(false, true);

	// Build the PlacementWidgets at state 'score'
	if ($re_config['PLACEMENT_WIDGET'][0]['ENABLED'][0] == true) {
		$widgets .= re_buildPlacementWidget('score');
	}


	if ($re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['ENABLED'][0] == true) {
		// Hide Dedimania at Stunts-Mode
		if ($gamemode != 4) {
			if ($re_config['States']['DedimaniaRecords']['NeedUpdate'] == true) {
				re_getDedimaniaRecords();
			}
			$widgets .= re_buildDedimaniaRecordsForScore($re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['ENTRIES'][0]);
		}
	}
	if ($re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['ENABLED'][0] == true) {
		// Display Gerymania only at Stunts-Mode
		if ($gamemode == 4) {
			if ($re_config['States']['GerymaniaRecords']['NeedUpdate'] == true) {
				re_getGerymaniaRecords();
			}
			$widgets .= re_buildGerymaniaRecordsForScore($re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['ENTRIES'][0]);
		}
	}
	if ($re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['ENABLED'][0] == true) {
		if ($re_config['States']['LocalRecords']['NeedUpdate'] == true) {
			re_getLocalRecords(6);		// 6 is a dummy GameMode for Score
		}
		$widgets .= re_buildLocalRecordsForScore($re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['ENTRIES'][0]);
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopRankings'] != false) ? $re_cache['TopRankings'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopWinners'] != false) ? $re_cache['TopWinners'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['MostRecords'] != false) ? $re_cache['MostRecords'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['MostFinished'] != false) ? $re_cache['MostFinished'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopPlaytime'] != false) ? $re_cache['TopPlaytime'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopDonators'] != false) ? $re_cache['TopDonators'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopNations'] != false) ? $re_cache['TopNations'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopTracks'] != false) ? $re_cache['TopTracks'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopVoters'] != false) ? $re_cache['TopVoters'] : '');
	}
	if ($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ENABLED'][0] == true) {
		$widgets .= (($re_cache['TopBetwins'] != false) ? $re_cache['TopBetwins'] : '');
	}
	if ($re_config['CLOCK_WIDGET'][0]['ENABLED'][0] == true) {
		if ($re_config['States']['NiceMode'] == false) {
			foreach ($aseco->server->players->player_list as &$player) {
				// Parameter: $player->login, $timezone, $clickable
				re_buildClockWidget($player->login, $player->data['RecordsEyepiecePlayerTimezone']->realname, false);
			}
		}
		else {
			// Parameter: $player->login, $timezone, $clickable
			$widgets .= re_buildClockWidget(false, false, false);
		}
	}

	// Display the ChallengeWidget (if enabled)
	$widgets .= (($re_cache['ChallengeWidget']['Score'] != false) ? $re_cache['ChallengeWidget']['Score'] : '');


	if ($widgets != '') {
		// Send Manialink to all Players
		re_sendManialink($widgets, false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildToplistWidget () {
	global $re_config;


	return $re_config['Templates']['TOPLISTWIDGET']->content;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildGamemodeWidget ($gamemode) {
	global $re_config;


	$limits = false;
	if ($re_config['CurrentGameInfos'] != false) {
		switch ($gamemode) {
			case 0:
				// Rounds
				$limits = $re_config['CurrentGameInfos']['RoundsPointsLimit'] .' pts.';
				break;
			case 1:
				// TimeAttack
				$limits = formatTime($re_config['CurrentGameInfos']['TimeAttackLimit'], false);
				break;
			case 2:
				// TeamMode
				$limits = $re_config['CurrentGameInfos']['TeamPointsLimit'] .' pts.';
				break;
			case 3:
				// Laps
				if ($re_config['CurrentGameInfos']['LapsTimeLimit'] > 0) {
					$limits = formatTime($re_config['CurrentGameInfos']['LapsTimeLimit'], false) .' min.';
				}
				else {
					$limits = $re_config['CurrentGameInfos']['LapsNbLaps'] .' laps';
				}
				break;
			case 4:
				// Stunts
				// Do nothing
				break;
			case 5:
				// CupMode
				$limits = $re_config['CurrentGameInfos']['CupPointsLimit'] .' pts.';
				break;
			default:
				// Do nothing
				break;
		}
	}

	$xml = str_replace(
		array(
			'%manialinkid%',
			'%background_style%',
			'%background_substyle%',
			'%posx%',
			'%posy%',
			'%icon_style%',
			'%icon_substyle%',
			'%gamemode%'
		),
		array(
			$re_config['ManialinkId'] .'07',
			$re_config['GAMEMODE_WIDGET'][0]['BACKGROUND_STYLE'][0],
			$re_config['GAMEMODE_WIDGET'][0]['BACKGROUND_SUBSTYLE'][0],
			$re_config['GAMEMODE_WIDGET'][0]['POS_X'][0],
			$re_config['GAMEMODE_WIDGET'][0]['POS_Y'][0],
			'Icons128x32_1',
			$re_config['Gamemodes'][$gamemode]['icon'],
			$re_config['Gamemodes'][$gamemode]['name']
		),
		$re_config['Templates']['GAMEMODE']->header
	);

	if ($limits != false) {
		$xml .= str_replace(
			array(
				'%posx%',
				'%posy%',
				'%limits%'
			),
			array(
				$re_config['GAMEMODE_WIDGET'][0]['POS_X'][0],
				$re_config['GAMEMODE_WIDGET'][0]['POS_Y'][0],
				$limits
			),
			$re_config['Templates']['GAMEMODE']->limits
		);
	}

	$xml .= $re_config['Templates']['GAMEMODE']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildVisitorsWidget () {
	global $re_config, $re_scores;


	// Build the VisitorsWidget
	$xml = str_replace(
		array(
			'%manialinkid%',
			'%action%',
			'%background_style%',
			'%background_substyle%',
			'%posx%',
			'%posy%',
			'%visitorcount%'
		),
		array(
			$re_config['ManialinkId'].'08',
			$re_config['ManialinkId'].'09',
			$re_config['VISITORS_WIDGET'][0]['BACKGROUND_STYLE'][0],
			$re_config['VISITORS_WIDGET'][0]['BACKGROUND_SUBSTYLE'][0],
			$re_config['VISITORS_WIDGET'][0]['POS_X'][0],
			$re_config['VISITORS_WIDGET'][0]['POS_Y'][0],
			$re_scores['Visitors']
		),
		$re_config['Templates']['VISITORS']->content
	);

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildImagePreload ($part = 1) {
	global $re_config;


//	// Free the display from the preloaded images
//	if ($part == 12) {
//		$xml  = '<manialink id="'. $re_config['ManialinkId'] .'100"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'101"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'102"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'103"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'104"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'105"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'106"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'107"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'108"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'109"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'110"></manialink>';
//		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'111"></manialink>';
//		return $xml;
//	}

	$xml  = '<manialink id="'. $re_config['ManialinkId'] . sprintf("1%02d", ($part-1)) .'">';
	$xml .= '<frame posn="-120 -120 0">';		// Place outside visibility

	if ($part == 1) {
//		$xml .= '<quad posn="0 0 0" sizen="3.5 3.5" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_LEFT'][0] .'"/>';	// Loaded in Widget
//		$xml .= '<quad posn="0 0 0" sizen="3.5 3.5" image="'. $re_config['IMAGES'][0]['WIDGET_CLOSE_LEFT'][0] .'"/>';	// Loaded in Widget
//		$xml .= '<quad posn="0 0 0" sizen="3.5 3.5" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_RIGHT'][0] .'"/>';	// Loaded in Widget
//		$xml .= '<quad posn="0 0 0" sizen="2.1 2.1" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_SMALL'][0] .'"/>';	// Loaded in Widget

		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_NORMAL'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_FOCUS'][0] .'"/>';
	}
	else if ($part == 2) {
		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_MINUS_NORMAL'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_MINUS_FOCUS'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';

//		$xml .= '<quad posn="0 0 0" sizen="11 5.5" image="'. $re_config['IMAGES'][0]['TMX_LOGO_NORMAL'][0] .'"/>';	// Loaded in Widget
//		$xml .= '<quad posn="0 0 0" sizen="11 5.5" image="'. $re_config['IMAGES'][0]['TMX_LOGO_FOCUS'][0] .'"/>';	// Loaded in Widget

//		$xml .= '<quad posn="0 0 0" sizen="7.2 4.34" image="'. $re_config['IMAGES'][0]['WORLDMAP'][0] .'"/>';		// Loaded in Widget
	}
	else if ($part == 3) {
		// <environment><enabled>
		$xml .= '<quad posn="0 0 0" sizen="1.60 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_BAY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.58 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_COAST'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.67 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_DESERT'][0] .'"/>';
	}
	else if ($part == 4) {
		// <environment><enabled>
		$xml .= '<quad posn="0 0 0" sizen="2.19 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_ISLAND'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.75 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_RALLY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.92 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_SNOW'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="3 1.96" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_STADIUM'][0] .'"/>';
	}
	else if ($part == 5) {
		// <environment><focus>
		$xml .= '<quad posn="0 0 0" sizen="1.60 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_BAY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.58 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_COAST'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.67 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_DESERT'][0] .'"/>';
	}
	else if ($part == 6) {
		// <environment><focus>
		$xml .= '<quad posn="0 0 0" sizen="2.19 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_ISLAND'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.75 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_RALLY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.92 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_SNOW'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="3 1.96" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_STADIUM'][0] .'"/>';
	}
	else if ($part == 7) {
		// <environment><disabled>
		$xml .= '<quad posn="0 0 0" sizen="1.60 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_BAY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.58 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_COAST'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.67 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_DESERT'][0] .'"/>';
	}
	else if ($part == 8) {
		// <environment><disabled>
		$xml .= '<quad posn="0 0 0" sizen="2.19 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_ISLAND'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.75 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_RALLY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="1.92 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_SNOW'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="3 1.96" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_STADIUM'][0] .'"/>';
	}
	else if ($part == 9) {
		// <mood><enabled>
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['DAY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['SUNSET'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['NIGHT'][0] .'"/>';
	}
	else if ($part == 10) {
		// <mood><focus>
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['DAY'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['SUNSET'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['NIGHT'][0] .'"/>';
	}
	else if ($part == 11) {
		// <mood><disabled>
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['SUNSET'][0] .'"/>';
		$xml .= '<quad posn="0 0 0" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['NIGHT'][0] .'"/>';
	}

	$xml .= '</frame>';
	$xml .= '</manialink>';

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTrackcountWidget () {
	global $re_config, $re_cache;


	// Build the TrackcountWidget
	$xml = str_replace(
		array(
			'%manialinkid%',
			'%action%',
			'%background_style%',
			'%background_substyle%',
			'%posx%',
			'%posy%',
			'%trackcount%'
		),
		array(
			$re_config['ManialinkId'].'09',
			$re_config['ManialinkId'].'20',
			$re_config['TRACKCOUNT_WIDGET'][0]['BACKGROUND_STYLE'][0],
			$re_config['TRACKCOUNT_WIDGET'][0]['BACKGROUND_SUBSTYLE'][0],
			$re_config['TRACKCOUNT_WIDGET'][0]['POS_X'][0],
			$re_config['TRACKCOUNT_WIDGET'][0]['POS_Y'][0],
			count($re_cache['Tracklist'])
		),
		$re_config['Templates']['TRACKCOUNT']->content
	);

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildMusicWidget () {
	global $re_config;


	// Set the right Icon and Title position
	$position = (($re_config['MUSIC_WIDGET'][0]['POS_X'][0] < 0) ? 'right' : 'left');

	if ($position == 'right') {
		$imagex	= ($re_config['Positions'][$position]['image_open']['x'] + ($re_config['MUSIC_WIDGET'][0]['WIDTH'][0] - 15.5));
		$iconx	= ($re_config['Positions'][$position]['icon']['x'] + ($re_config['MUSIC_WIDGET'][0]['WIDTH'][0] - 15.5));
		$titlex	= ($re_config['Positions'][$position]['title']['x'] + ($re_config['MUSIC_WIDGET'][0]['WIDTH'][0] - 15.5));
	}
	else {
		$imagex	= $re_config['Positions'][$position]['image_open']['x'];
		$iconx	= $re_config['Positions'][$position]['icon']['x'];
		$titlex	= $re_config['Positions'][$position]['title']['x'];
	}

	// Build the MusicWidget
	$xml = '<manialink id="'. $re_config['ManialinkId'] .'30">';

	// Build the entries
	$xml .= str_replace(
		array(
			'%actionid%',
			'%posx%',
			'%posy%',
			'%image_open_pos_x%',
			'%image_open_pos_y%',
			'%image_open%',
			'%posx_icon%',
			'%posy_icon%',
			'%posx_title%',
			'%posy_title%',
			'%halign%',
			'%widgetwidth%',
			'%title_background_width%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '18'),
			$re_config['MUSIC_WIDGET'][0]['POS_X'][0],
			$re_config['MUSIC_WIDGET'][0]['POS_Y'][0],
			$imagex,
			-5,
			$re_config['Positions'][$position]['image_open']['image'],
			$iconx,
			$re_config['Positions'][$position]['icon']['y'],
			$titlex,
			$re_config['Positions'][$position]['title']['y'],
			$re_config['Positions'][$position]['title']['halign'],
			$re_config['MUSIC_WIDGET'][0]['WIDTH'][0],
			($re_config['MUSIC_WIDGET'][0]['WIDTH'][0] - 0.8),
			utf8_encode($re_config['MUSIC_WIDGET'][0]['TITLE'][0])
		),
		$re_config['Templates']['MUSICINFO']->header
	);

	$xml .= '<label posn="1 -2.7 0.004" sizen="15 2" textcolor="FC0F" scale="0.6" text="ARTIST"/>';
	$xml .= '<label posn="1 -3.5 0.004" sizen="15 2" scale="0.9" text="'. $re_config['CurrentMusicInfos']['Artist'] .'"/>';
	$xml .= '<label posn="1 -5.4 0.004" sizen="15 2" textcolor="FC0F" scale="0.6" text="TITLE"/>';
	$xml .= '<label posn="1 -6.2 0.004" sizen="15 2" scale="0.9" text="'. $re_config['CurrentMusicInfos']['Title'] .'"/>';
	$xml .= $re_config['Templates']['MUSICINFO']->footer;


	$xml .= '</manialink>';

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildClockWidget ($login = false, $timezone = false, $clickable = true) {
	global $aseco, $re_config;


	// Calculate time depending on configured Timezone,
	// if in NiceMode the Clock displays not the Player configured timezone
	if ($timezone != false) {
		$time = re_calculateClock($timezone);
	}
	else {
		$time = re_calculateClock($re_config['CLOCK_WIDGET'][0]['DEFAULT_TIMEZONE'][0]);
	}

	// Transform lowercase GameState to UPPERCASE
	$gamestate = strtoupper($re_config['States']['GameState']);

	// Build the ClockWidget
	$xml = str_replace(
		array(
			'%manialinkid%',
			'%actionid%',
			'%background_style%',
			'%background_substyle%',
			'%posx%',
			'%posy%',
			'%time%',
			'%timezone%',
			'%beat%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '06'),
			sprintf("%d%s", $re_config['ManialinkId'], '03'),
			$re_config['CLOCK_WIDGET'][0][$gamestate][0]['BACKGROUND_STYLE'][0],
			$re_config['CLOCK_WIDGET'][0][$gamestate][0]['BACKGROUND_SUBSTYLE'][0],
			$re_config['CLOCK_WIDGET'][0][$gamestate][0]['POS_X'][0],
			$re_config['CLOCK_WIDGET'][0][$gamestate][0]['POS_Y'][0],
			$time['timeformat'],
			$time['timezone'],
			date('B', time())
		),
		$re_config['Templates']['CLOCK']->header
	);

	if ($clickable == false) {
 		$xml = str_replace(' action="'. sprintf("%d%s", $re_config['ManialinkId'], '03') .'"', '', $xml);
	}
	else {
		$xml .= '<quad posn="-0.18 -4.6 0.002" sizen="2.1 2.1" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_SMALL'][0] .'"/>';
	}
	$xml .= $re_config['Templates']['CLOCK']->footer;


	if ($login != false) {
		// Send Manialink
		re_sendManialink($xml, $login);
	}
	else {
		return $xml;	// nicemode
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildClockDetailsWindow ($timezone_realname, $timezone_display, $display = true, $group_selected = false) {
	global $aseco, $re_config;


	if ($display == true) {

		$time = re_calculateClock($timezone_realname);
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				'Icons128x32_1',
				'RT_TimeAttack',
				'Adjust timezone for your personal clock. Current is $FF0'. $timezone_display .' ('. $time['timezone'] .')',
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		if ($group_selected === false) {

			$xml .= '<label posn="2 -5 0.10" sizen="77 0" textsize="1" scale="1" textcolor="FFFF" autonewline="1" text="Here you can easily adjust the time of the clock to your timezone you life in. Select in the worldmap your location and then choose in the list that appears your timezone. $FF0If you did not see a worldmap below, press DEL."/>';
			$xml .= '<label posn="2 -9 0.10" sizen="77 0" textsize="1" scale="1" textcolor="FFFF" autonewline="1" text="For more information about the BEAT time that are displayed below the normal time, just visit $L[http://en.wikipedia.org/wiki/Swatch_Internet_Time]Wikipedia$L"/>';

			$xml .= '<frame posn="3 -11 0">';
				$xml .= '<quad posn="0 0 0.10" sizen="72 43.44" image="'. $re_config['IMAGES'][0]['WORLDMAP'][0] .'"/>';

				// Africa
				$xml .= '<label posn="37 -24.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'300" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$05CAfrica"/>';

				// Argentina
				$xml .= '<label posn="23 -36 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'301" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$5BFArgentina"/>';

				// Asia (Turkey, India, Iran...)
				$xml .= '<label posn="46 -20 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'302" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$05CAsia"/>';

				// Asia (Taiwan, Japan...)
				$xml .= '<label posn="59 -21.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'302" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$5BFAsia"/>';

				// Australia
				$xml .= '<label posn="58 -32 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'303" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CAustralia"/>';

				// Brasil
				$xml .= '<label posn="22.8 -28.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'304" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$05CBrasil"/>';

				// Canada
				$xml .= '<label posn="13 -12 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'305" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CCanada"/>';

				// Central America
				$xml .= '<label posn="18.3 -23.3 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'306" halign="left" style="TextCardScores2" textsize="1" scale="0.6" text="$5BFCentral America"/>';

				// China
				$xml .= '<label posn="52 -18.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'307" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$05CChina"/>';

				// Europe
				$xml .= '<label posn="35.7 -15.8 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'308" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CEurope"/>';

				// Indonesia
				$xml .= '<label posn="52.5 -29 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'309" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$5BFIndonesia"/>';

				// Kazakhstan
				$xml .= '<label posn="44.5 -16 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'310" halign="left" style="TextCardScores2" textsize="1" scale="0.4" text="$05CKazakhstan"/>';

				// Mexico
				$xml .= '<label posn="9.3 -22.3 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'311" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$5BFMexico"/>';

				// Mongolia
				$xml .= '<label posn="51.5 -16 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'312" halign="left" style="TextCardScores2" textsize="1" scale="0.4" text="$05CMongolia"/>';

				// Russia
				$xml .= '<label posn="49.5 -10 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'313" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$05CRussia"/>';

				// South America
				$xml .= '<label posn="11 -29 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'314" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$5BFSouth America"/>';

				// USA
				$xml .= '<label posn="14 -18 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'315" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CUSA"/>';

				// USA (Alaska)
				$xml .= '<label posn="8 -8 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'315" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CAlaska"/>';

				// Arctic Ocean
				$xml .= '<label posn="34 -2 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'316" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$FA0Arctic Ocean"/>';

				// Southern Ocean
				$xml .= '<label posn="37 -40 0.11" sizen="16 0" action="'. $re_config['ManialinkId'] .'316" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$FA0Southern Ocean"/>';

				// Greenland
				$xml .= '<label posn="26 -5.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'316" halign="left" style="TextCardScores2" textsize="1" scale="0.5" text="$05CGreenland"/>';

				// Atlantic Ocean
				$xml .= '<label posn="23 -19 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'317" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$FA0Atlantic Ocean"/>';

				// Pacific Ocean (near America)
				$xml .= '<label posn="2 -25.5 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'318" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$FA0Pacific Ocean"/>';

				// Pacific Ocean (near Australia)
				$xml .= '<label posn="64 -18 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'318" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$FA0Pacific Ocean"/>';

				// Indian Ocean
				$xml .= '<label posn="45 -27 0.11" sizen="14 0" action="'. $re_config['ManialinkId'] .'319" halign="left" style="TextCardScores2" textsize="1" scale="0.55" text="$FA0Indian Ocean"/>';

			$xml .= '</frame>';

//			// List the timezone groups
//			$line_height = 2.2;
//			$line = 0;
//			$xml .= '<frame posn="74 -12 0">';
//			foreach ($re_config['Timezones'] as $group => &$child) {
//				$xml .= '<quad posn="0 -'. ($line_height * $line + 1) .' 0.10" sizen="17 2.2" action="'. $re_config['ManialinkId'] . (450 + $line) .'" style="Bgs1InRace" substyle="BgIconBorder"/>';
//				$xml .= '<label posn="1 -'. ($line_height * $line + 1.3) .' 0.11" sizen="16.5 0" halign="left" textsize="1" scale="0.9" textcolor="05CF" text="'. $group .'"/>';
//				$line ++;
//			}
//			$xml .= '</frame>';
		}
		else {
			// Display the content of the selected timezone-group
			$line_height = 2.2;
			$group_count = 0;
			$line = 0;
			$array_count = 0;
			$xml .= '<frame posn="2 -6 0">';
			foreach ($re_config['Timezones'] as $group => &$child) {
				if ($group_count == $group_selected) {
					$offset = 0;
					foreach ($child as $display_name => &$php_timezone) {
						$xml .= '<quad posn="'. (0 + $offset) .' -'. ($line_height * $line + 1) .' 0.10" sizen="17 2.2" action="'. $re_config['ManialinkId'] . (350 + $array_count) .'" style="Bgs1InRace" substyle="BgIconBorder"/>';
						$xml .= '<label posn="'. (1 + $offset) .' -'. ($line_height * $line + 1.3) .' 0.11" sizen="16.5 0" halign="left" textsize="1" scale="0.9" textcolor="05CF" text="'. $display_name .'"/>';

						// Count Array-Position for action id
						$array_count ++;

						$line ++;

						// Reset lines
						if ($line >= 20) {
							$offset += 19.5;
							$line = 0;
						}
					}

					// Break the first foreach
					break;
				}
				else {
					// Count always the entries of each child, otherwise never find the selected entry
					$array_count += count($child);
				}
				$group_count ++;
			}
			$xml .= '</frame>';
		}

		$xml .= $re_config['Templates']['WINDOW']->footer;
	}
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildPlacementWidget ($gamestate = 'score') {
	global $aseco, $re_config;


	// Init
	$xml = '';

	// Preset the search pattern
	$searchpattern = '(%TRACK_TMX_PREFIX%|%TRACK_TMX_ID%|%TRACK_TMX_PAGEURL%|%TRACK_UID%|%TRACK_NAME%)';

	$tmx = false;
	if ($re_config['PlacementPlaceholders']->track_tmx_prefix != false) {
		$tmx = true;
	}

	if ($gamestate == 'always') {

		// Build the Widgets at 'always'
		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'04">';
		foreach ($re_config['PLACEMENT_WIDGET'][0]['PLACEMENT'] as &$placement) {
			if ($placement['DISPLAY'][0] == 'ALWAYS') {

				// First: Remove all Placeholder, that are not supported here,
				// because this <placement> are never refreshed!
				$xml = str_replace(
					array('%TRACK_TMX_PREFIX%','%TRACK_TMX_ID%','%TRACK_UID%','%TRACK_NAME%','%TRACK_TMX_PAGEURL%'),
					array('','','','',''),
					$xml
				);

				// Second: Build the <placement>
				$xml .= re_getPlacementEntry($placement);
			}
		}
		$xml .= '</manialink>';
	}

	if ($gamestate == 'race') {

		// Build the Widgets at 'race'
		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'02">';
		foreach ($re_config['PLACEMENT_WIDGET'][0]['PLACEMENT'] as &$placement) {
			if ($placement['DISPLAY'][0] == 'RACE') {

				// First: Remove all Placeholder, that are not supported here,
				// because this <placement> are never refreshed!
				$xml = str_replace(
					array('%TRACK_TMX_PREFIX%','%TRACK_TMX_ID%','%TRACK_UID%','%TRACK_NAME%','%TRACK_TMX_PAGEURL%'),
					array('','','','',''),
					$xml
				);

				// Second: Build the <placement>
				$xml .= re_getPlacementEntry($placement);
			}
		}
		$xml .= '</manialink>';

		// Hide 'score' PlacementWidgets
		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'03"></manialink>';
	}

	if ($gamestate == 'score') {

		// Build the Widgets at 'score'
		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'03">';
		foreach ($re_config['PLACEMENT_WIDGET'][0]['PLACEMENT'] as &$placement) {
			if ($placement['DISPLAY'][0] == 'SCORE') {
				if ($tmx == false) {
					// Try to find Placeholders and skip
					if ( isset($placement['URL'][0]) ) {
						if (preg_match($searchpattern, $placement['URL'][0]) > 0) {
							continue;
						}
					}
					if ( isset($placement['MANIALINK'][0]) ) {
						if (preg_match($searchpattern, $placement['MANIALINK'][0]) > 0) {
							continue;
						}
					}
				}
				$xml .= re_getPlacementEntry($placement);
			}
		}
		$xml .= '</manialink>';

		// Hide 'race' PlacementWidgets
		$xml .= '<manialink id="'. $re_config['ManialinkId'] .'02"></manialink>';
	}




	// Replace the supported Placeholder, if already loaded
	// (at startup the event onPlayerConnect is always to early, the Track is not loaded yet)
	if ($tmx == true) {
		$xml = str_replace(
			array(
				'%TRACK_TMX_PREFIX%',
				'%TRACK_TMX_ID%',
				'%TRACK_TMX_PAGEURL%'
			),
			array(
				$re_config['PlacementPlaceholders']->track_tmx_prefix,
				$re_config['PlacementPlaceholders']->track_tmx_id,
				$re_config['PlacementPlaceholders']->track_tmx_pageurl
			),
			$xml
		);
	}
	if ($re_config['PlacementPlaceholders']->track_uid != false) {
		$xml = str_replace(
			array(
				'%TRACK_UID%',
				'%TRACK_NAME%'
			),
			array(
				$re_config['PlacementPlaceholders']->track_uid,
				$re_config['PlacementPlaceholders']->track_name
			),
			$xml
		);
	}

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getPlacementEntry ($placement) {


	$xml = '<frame posn="'. $placement['POS_X'][0] .' '. $placement['POS_Y'][0] .' 3">';

	// Build the background for the Widget
	if ( isset($placement['BACKGROUND_STYLE'][0]) ) {
		$xml .= '<quad posn="0 0 0.001" sizen="'. $placement['WIDTH'][0] .' '. $placement['HEIGHT'][0] .'"';

		if ( (isset($placement['BACKGROUND_STYLE'][0])) && (isset($placement['BACKGROUND_SUBSTYLE'][0])) ) {
			$xml .= ' style="'. $placement['BACKGROUND_STYLE'][0] .'" substyle="'. $placement['BACKGROUND_SUBSTYLE'][0] .'"';
		}
		if ( isset($placement['URL'][0]) ) {
			$xml .= ' url="'. $placement['URL'][0] .'"';
		}
		else if ( isset($placement['MANIALINK'][0]) ) {
			$xml .= ' manialink="'. $placement['MANIALINK'][0] .'"';
		}
		else if ( isset($placement['ACTION_ID'][0]) ) {
			$xml .= ' action="'. $placement['ACTION_ID'][0] .'"';
		}

		$xml .= '/>';
	}

	// Build the image quad for the Widget if needed
	if ( isset($placement['IMAGE'][0]) ) {
		$xml .= '<quad posn="0 0 0.002" sizen="'. $placement['WIDTH'][0] .' '. $placement['HEIGHT'][0] .'" image="'. $placement['IMAGE'][0] .'"';

		if ( isset($placement['IMAGEFOCUS'][0]) ) {
			$xml .= ' imagefocus="'. $placement['IMAGEFOCUS'][0] .'"';
		}
		if ( isset($placement['HALIGN'][0]) ) {
			$xml .= ' halign="'. $placement['HALIGN'][0] .'"';
		}
		if ( isset($placement['VALIGN'][0]) ) {
			$xml .= ' valign="'. $placement['VALIGN'][0] .'"';
		}

		if ( isset($placement['URL'][0]) ) {
			$xml .= ' url="'. $placement['URL'][0] .'"';
		}
		else if ( isset($placement['MANIALINK'][0]) ) {
			$xml .= ' manialink="'. $placement['MANIALINK'][0] .'"';
		}
		else if ( isset($placement['ACTION_ID'][0]) ) {
			$xml .= ' action="'. $placement['ACTION_ID'][0] .'"';
		}

		$xml .= '/>';
	}

	// Build the icon quad for the Widget if needed
	if ( isset($placement['ICON_STYLE'][0]) ) {
		$xml .= '<quad posn="0 0 0.003" sizen="'. $placement['WIDTH'][0] .' '. $placement['HEIGHT'][0] .'" style="'. $placement['ICON_STYLE'][0] .'" substyle="'. $placement['ICON_SUBSTYLE'][0] .'"';

		if ( isset($placement['HALIGN'][0]) ) {
			$xml .= ' halign="'. $placement['HALIGN'][0] .'"';
		}
		if ( isset($placement['VALIGN'][0]) ) {
			$xml .= ' valign="'. $placement['VALIGN'][0] .'"';
		}

		if ( isset($placement['URL'][0]) ) {
			$xml .= ' url="'. $placement['URL'][0] .'"';
		}
		else if ( isset($placement['MANIALINK'][0]) ) {
			$xml .= ' manialink="'. $placement['MANIALINK'][0] .'"';
		}
		else if ( isset($placement['ACTION_ID'][0]) ) {
			$xml .= ' action="'. $placement['ACTION_ID'][0] .'"';
		}

		$xml .= '/>';
	}

	// Build the text label for the Widget if needed
	if ( isset($placement['TEXT'][0]) ) {
		$xml .= '<label posn="0 0 0.004" sizen="'. $placement['WIDTH'][0] .' '. $placement['HEIGHT'][0] .'"';

		if ( isset($placement['HALIGN'][0]) ) {
			$xml .= ' halign="'. $placement['HALIGN'][0] .'"';
		}
		if ( isset($placement['VALIGN'][0]) ) {
			$xml .= ' valign="'. $placement['VALIGN'][0] .'"';
		}
		if ( isset($placement['TEXTSIZE'][0]) ) {
			$xml .= ' textsize="'. $placement['TEXTSIZE'][0] .'"';
		}
		if ( isset($placement['TEXTSCALE'][0]) ) {
			$xml .= ' scale="'. $placement['TEXTSCALE'][0] .'"';
		}

		$xml .= ' text="'. $placement['TEXT'][0] .'"/>';
	}

	$xml .= '</frame>';

	return $xml;
}


/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_showRecordWidgets ($force_display = false) {
	global $aseco, $re_config, $re_cache;


	// Bail out if Scoretable is displayed
	if ($re_config['States']['GameState'] == 'score') {
		return;
	}

	// Bail out if there are no Players
	if (count($aseco->server->players->player_list) == 0) {
		return;
	}

	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	$widgets = '';
	if ( ($re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['DEDIMANIA_RECORDS'][0] == true) ) {
		if ( ($re_config['States']['DedimaniaRecords']['UpdateDisplay'] == true) || ($force_display == true) ) {
			$widgets .= (($re_cache['DedimaniaRecords']['NiceMode'] != false) ? $re_cache['DedimaniaRecords']['NiceMode'] : '');
		}
	}
	if ( ($re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['LOCAL_RECORDS'][0] == true) ) {
		if ( ($re_config['States']['LocalRecords']['UpdateDisplay'] == true) || ($force_display == true) ) {
			$widgets .= (($re_cache['LocalRecords']['NiceMode'] != false) ? $re_cache['LocalRecords']['NiceMode'] : '');
		}
	}
	if ( ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['LIVE_RANKINGS'][0] == true) ) {
		if ( ($re_config['States']['LiveRankings']['UpdateDisplay'] == true) || ($force_display == true) ) {
			$widgets .= (($re_cache['LiveRankings']['NiceMode'] != false) ? $re_cache['LiveRankings']['NiceMode'] : '');
		}
	}
	if ( ($re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['GERYMANIA_RECORDS'][0] == true) ) {
		if ( ($re_config['States']['GerymaniaRecords']['UpdateDisplay'] == true) || ($force_display == true) ) {
			$widgets .= (($re_cache['GerymaniaRecords']['NiceMode'] != false) ? $re_cache['GerymaniaRecords']['NiceMode'] : '');
		}
	}

	return $widgets;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $target = the same as the normal $player object, but only this Player gets the requested Widgets
// $force  = an array where the required Widgets are identified
function re_buildRecordWidgets ($target = false, $force = false) {
	global $aseco, $re_config, $re_cache;


	// Get current Gamemode
	$gamemode = $aseco->server->gameinfo->mode;

	$buildDedimaniaRecordsWidget = false;
	$buildLocalRecordsWidget = false;
	$buildLiveRankingsWidget = false;
	$buildGerymaniaRecordsWidget = false;
	if ( ($re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['DEDIMANIA_RECORDS'][0] == true) ) {
		// Refresh the Widget only if it needs an update
		if ($re_config['States']['DedimaniaRecords']['NeedUpdate'] == true) {

			// Get current Records
			re_getDedimaniaRecords();

			// Only set to false if records are loaded and displayed,
			// receiving the Dedimania Records takes some time, need to try again later,
			// but only if there are Records. If nobody reached a Record, do not try again.
			if ($re_config['States']['DedimaniaRecords']['NoRecordsFound'] == false) {
				$re_config['States']['DedimaniaRecords']['NeedUpdate'] = false;
			}

			// Say yes to build the Widget
			$buildDedimaniaRecordsWidget = true;
		}
		if ($re_config['States']['DedimaniaRecords']['UpdateDisplay'] == true) {

			// Say yes to build the Widget
			$buildDedimaniaRecordsWidget = true;
		}
	}
	if ( ($re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['LOCAL_RECORDS'][0] == true) ) {
		// Refresh the Widget only if it needs an update
		if ($re_config['States']['LocalRecords']['NeedUpdate'] == true) {

			// Get current Records
			re_getLocalRecords($gamemode);

			// Only set to false if records are loaded and displayed,
			// but only if there are Records. If nobody reached a Record, do not try again.
			if ($re_config['States']['LocalRecords']['NoRecordsFound'] == false) {
				$re_config['States']['LocalRecords']['NeedUpdate'] = false;
			}

			// Say yes to build the Widget
			$buildLocalRecordsWidget = true;
		}
		if ($re_config['States']['LocalRecords']['UpdateDisplay'] == true) {

			// Say yes to build the Widget
			$buildLocalRecordsWidget = true;
		}
	}
	if ( ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['LIVE_RANKINGS'][0] == true) ) {
		// Refresh the Widget only if it needs an update
		if ($re_config['States']['LiveRankings']['NeedUpdate'] == true) {

			// Get current Records
			re_getLiveRankings($gamemode);

			// Only set to false if records are loaded and displayed,
			// but only if there are Players finished the map. If nobody finished this map, do not try again.
			if ($re_config['States']['LiveRankings']['NoRecordsFound'] == false) {
				$re_config['States']['LiveRankings']['NeedUpdate'] = false;
			}

			// Say yes to build the Widget
			$buildLiveRankingsWidget = true;
		}
		if ($re_config['States']['LiveRankings']['UpdateDisplay'] == true) {

			// Say yes to build the Widget
			$buildLiveRankingsWidget = true;
		}
	}
	if ( ($re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['ALLOW'][0]['GERYMANIA_RECORDS'][0] == true) ) {
		// Refresh the Widget only if it needs an update
		if ($re_config['States']['GerymaniaRecords']['NeedUpdate'] == true) {

			// Get current Records
			re_getGerymaniaRecords();

			// Only set to false if records are loaded and displayed,
			// receiving the Gerymania Records takes some time, need to try again later,
			// but only if there are Records. If nobody reached a Record, do not try again.
			if ($re_config['States']['GerymaniaRecords']['NoRecordsFound'] == false) {
				$re_config['States']['GerymaniaRecords']['NeedUpdate'] = false;
			}

			// Say yes to build the Widget
			$buildGerymaniaRecordsWidget = true;
		}
		if ($re_config['States']['GerymaniaRecords']['UpdateDisplay'] == true) {

			// Say yes to build the Widget
			$buildGerymaniaRecordsWidget = true;
		}
	}


	if ($re_config['States']['NiceMode'] == false) {

		// Clean mem (from possible reverted NiceMode)
		$re_cache['DedimaniaRecords']['NiceMode']	= false;
		$re_cache['LocalRecords']['NiceMode']		= false;
		$re_cache['LiveRankings']['NiceMode']		= false;
		$re_cache['GerymaniaRecords']['NiceMode']	= false;

		// If we switched to score, bail out
		if ($re_config['States']['GameState'] == 'score') {
			return;
		}

		// Build the Widgets for all connected Players or given Player ($target same as $player)
		if ($target != false) {
			$player_list = array($target);
		}
		else {
			$player_list = $aseco->server->players->player_list;
		}
		foreach ($player_list as &$player) {

			// Did the Player has the Records Widget set to hidden?
			if ($player->data['RecordsEyepieceWidgetPreference'] == false) {
				continue;
			}

			$widgets = '';
			if ( ($buildDedimaniaRecordsWidget == true) || (($force['DedimaniaRecords'] == true) && ($re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true)) ) {
				$widgets .= re_buildDedimaniaRecordsWidget($player->login, $player->data['RecordsEyepieceWidgetEmptyEntry'], $gamemode, $re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			}
			if ( ($buildLocalRecordsWidget == true) || (($force['LocalRecords'] == true) && ($re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true)) ) {
				$widgets .= re_buildLocalRecordsWidget($player->login, $player->data['RecordsEyepieceWidgetEmptyEntry'], $gamemode, $re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			}
			if ( ($buildLiveRankingsWidget == true) || (($force['LiveRankings'] == true) && ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true)) ) {
				$widgets .= re_buildLiveRankingsWidget($player->login, $player->data['RecordsEyepieceWidgetEmptyEntry'], $gamemode, $re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			}
			if ( ($buildGerymaniaRecordsWidget == true) || (($force['GerymaniaRecords'] == true) && ($re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENABLED'][0] == true)) ) {
				$widgets .= re_buildGerymaniaRecordsWidget($player->login, $player->data['RecordsEyepieceWidgetEmptyEntry'], $gamemode, $re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			}

			if ($widgets != '') {
				// Send Manialink to given Player
				re_sendManialink($widgets, $player->login);
			}
		}
	}
	else {

		// Build the RecordWidgets for all connected Players and ignore the Player specific highlites
		if ($buildDedimaniaRecordsWidget == true) {
			$re_cache['DedimaniaRecords']['NiceMode'] = re_buildDedimaniaRecordsWidget(false, false, $gamemode, $re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			$re_config['States']['DedimaniaRecords']['UpdateDisplay'] = true;
		}
		if ($buildLocalRecordsWidget == true) {
			$re_cache['LocalRecords']['NiceMode'] = re_buildLocalRecordsWidget(false, false, $gamemode, $re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			$re_config['States']['LocalRecords']['UpdateDisplay'] = true;
		}
		if ($buildLiveRankingsWidget == true) {
			$re_cache['LiveRankings']['NiceMode'] = re_buildLiveRankingsWidget(false, false, $gamemode, $re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			$re_config['States']['LiveRankings']['UpdateDisplay'] = true;
		}
		if ($buildGerymaniaRecordsWidget == true) {
			$re_cache['GerymaniaRecords']['NiceMode'] = re_buildGerymaniaRecordsWidget(false, false, $gamemode, $re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0]);
			$re_config['States']['GerymaniaRecords']['UpdateDisplay'] = true;
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_sendManialink ($widgets, $login = false, $timeout = 0, $include_customui = true) {
	global $aseco, $re_config;


	$xml  = '<?xml version="1.0" encoding="UTF-8"?>';
	$xml .= '<manialinks>';
	$xml .= $widgets;

	if ($include_customui == true) {
		if ($re_config['CHALLENGE_WIDGET'][0]['ENABLED'][0] == true) {
			// Disable 'challenge_info' and use own ChallengeInfoWidget
			setCustomUIField('challenge_info', false);
		}

		if ( ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][0][0]['ENABLED'][0] == true) && ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][0][0]['DISABLE_ROUND_SCORES'][0] == true) ) {
			// Disable 'round_scores'
			setCustomUIField('round_scores', false);
		}

		// Add complete CustomUI block
		$xml .= getCustomUIBlock();
	}

	$xml .= '</manialinks>';


	if ($login != false) {
		// Send to given Player
		$aseco->client->query('SendDisplayManialinkPageToLogin', $login, $xml, ($timeout * 1000), false);
	}
	else {
		// Send to all connected Players
		$aseco->client->query('SendDisplayManialinkPage', $xml, ($timeout * 1000), false);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_closeScoretableLists () {
	global $aseco, $re_config;

	// 05 = ChallengeWidget
	// 06 = ClockWidget
	// 15 = DedimaniaRecords
	// 16 = LocalRecords
	// 17 = GerymaniaRecords
	// 18 = TopRankings at Score
	// 19 = TopWinners at Score
	// 20 = MostRecords at Score
	// 21 = MostFinished at Score
	// 22 = TopPlaytime at Score
	// 23 = TopDonators at Score
	// 24 = TopNations at Score
	// 25 = TopTracks at Score
	// 26 = TopVoters at Score
	// 27 = TopBetwins at Score
	$ids = array('05','06','15','16','17','18','19','20','21','22','23','24','25','26','27');

	$xml = '';
	foreach ($ids as &$id) {
		$xml .= '<manialink id="'. $re_config['ManialinkId'].$id .'"></manialink>';
	}

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_closeRaceDisplays ($login = false, $all = true) {
	global $aseco, $re_config;


	// 00 = All Windows (maybe open for a Player)
	// 07 = GamemodeWidget
	// 08 = VisitorsWidget
	// 09 = TrackcountWidget
	// 10 = ToplistWidget
	// 11 = DedimaniaRecords
	// 12 = LocalRecords
	// 13 = LiveRankings
	// 14 = GerymaniaRecords
	// 30 = MusicWidget
	if ($all == false) {
		// Do NOT close 'GamemodeWidget', 'VisitorsWidget', 'TrackcountWidget' and 'ToplistWidget'
		$ids = array('00',                    '11','12','13','14','30');
	}
	else {
		$ids = array('00','07','08','09','10','11','12','13','14','30');
	}

	$xml = '';
	foreach ($ids as &$id) {
		$xml .= '<manialink id="'. $re_config['ManialinkId'].$id .'"></manialink>';
	}

	if ($login != false) {
		// Send to given Player
		re_sendManialink($xml, $login);
	}
	else {
		// Return the xml
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_closeAllWindows ($login = false) {
	global $aseco, $re_config;


	// 00 = All Windows
	$ids = array('00');

	$xml = '';
	foreach ($ids as &$id) {
		$xml .= '<manialink id="'. $re_config['ManialinkId'].$id .'"></manialink>';
	}

	if ($login != false) {
		// Send to given Player
		re_sendManialink($xml, $login);
	}
	else {
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $dedi_db is imported from plugin.dedimania.php
function re_getDedimaniaRecords () {
	global $aseco, $re_config, $re_scores, $dedi_db;


	// Clean array
	$re_scores['DedimaniaRecords'] = array();

	// Increase counter
	$re_config['States']['DedimaniaRecords']['TryCount'] ++;

	if ( isset($dedi_db['Challenge']['Records']) ) {
		if (count($dedi_db['Challenge']['Records']) == 0) {
			if ($re_config['States']['DedimaniaRecords']['TryCount'] >= 5) {
				$re_config['States']['DedimaniaRecords']['NoRecordsFound'] = true;
			}
		}
		else {
			for ($i = 0; $i < count($dedi_db['Challenge']['Records']); $i ++) {
				if ($dedi_db['Challenge']['Records'][$i]['Best'] > 0) {
					$re_scores['DedimaniaRecords'][$i]['rank']	= ($i+1);
					$re_scores['DedimaniaRecords'][$i]['login']	= $dedi_db['Challenge']['Records'][$i]['Login'];
					$re_scores['DedimaniaRecords'][$i]['nickname']	= re_handleSpecialChars($dedi_db['Challenge']['Records'][$i]['NickName']);
					$re_scores['DedimaniaRecords'][$i]['score']	= formatTime($dedi_db['Challenge']['Records'][$i]['Best']);
				}
			}

			$re_scores['DedimaniaRecordsChkSum'] = re_buildRecordDigest('dedimania', $dedi_db['Challenge']['Records']);
			$re_config['States']['DedimaniaRecords']['NoRecordsFound'] = false;
		}
	}
	else {
		// Dedimania records was not loaded yet, let´s try again later
		$re_config['States']['DedimaniaRecords']['NeedUpdate'] = true;
		$re_config['States']['DedimaniaRecords']['NoRecordsFound'] = true;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $gery_db is imported from plugin.gerymania.php
function re_getGerymaniaRecords () {
	global $aseco, $re_config, $re_scores, $gery_db;


	// Clean array
	$re_scores['GerymaniaRecords'] = array();

	// Increase counter
	$re_config['States']['GerymaniaRecords']['TryCount'] ++;

	if ($gery_db != false) {
		if (count($gery_db) == 0) {
			if ($re_config['States']['GerymaniaRecords']['TryCount'] >= 5) {
				$re_config['States']['GerymaniaRecords']['NoRecordsFound'] = true;
			}
		}
		else {
			for ($i = 0; $i < count($gery_db); $i ++) {
				if ($gery_db[$i]['score'] > 0) {
					$re_scores['GerymaniaRecords'][$i]['rank']	= ($i+1);
					$re_scores['GerymaniaRecords'][$i]['login']	= $gery_db[$i]['login'];
					$re_scores['GerymaniaRecords'][$i]['nickname']	= re_handleSpecialChars($gery_db[$i]['nick']);
					$re_scores['GerymaniaRecords'][$i]['score']	= $gery_db[$i]['score'];
				}
			}

			$re_scores['GerymaniaRecordsChkSum'] = re_buildRecordDigest('gerymania', $gery_db);
			$re_config['States']['GerymaniaRecords']['NoRecordsFound'] = false;
		}
	}
	else {
		// Gerymania records was not loaded yet, let´s try again later
		$re_config['States']['GerymaniaRecords']['NeedUpdate'] = true;
		$re_config['States']['GerymaniaRecords']['NoRecordsFound'] = true;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getLocalRecords ($gamemode) {
	global $aseco, $re_scores;


	// Clean array
	$re_scores['LocalRecords'] = array();

	if (count($aseco->server->records->record_list) == 0) {
		$re_config['States']['LocalRecords']['NoRecordsFound'] = true;
	}
	else {
		$i = 0;
		foreach ($aseco->server->records->record_list as &$entry) {
			$re_scores['LocalRecords'][$i]['rank']		= ($i+1);
			$re_scores['LocalRecords'][$i]['login']		= $entry->player->login;
			$re_scores['LocalRecords'][$i]['nickname']	= re_handleSpecialChars($entry->player->nickname);
			if ($gamemode == 4) {
				// 4 = Stunts
				$re_scores['LocalRecords'][$i]['score'] = $entry->score;
			}
			else {
				$re_scores['LocalRecords'][$i]['score'] = formatTime($entry->score);
			}

			$i++;
		}

		$re_scores['LocalRecordsChkSum'] = re_buildRecordDigest('locals', $aseco->server->records->record_list);
		$re_config['States']['LocalRecords']['NoRecordsFound'] = false;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getLiveRankings ($gamemode) {
	global $aseco, $re_config, $re_scores;


	$aseco->client->resetError();
	if ($gamemode == 2) {
		// TeamMode
		$aseco->client->query('GetCurrentRanking', 2,0);
	}
	else {
		// All other GameModes
		$aseco->client->query('GetCurrentRanking', 300,0);
	}
	if ( $aseco->client->isError() ) {
		$re_config['States']['LiveRankings']['NoRecordsFound'] = true;
	}
	else {
		$ranks = $aseco->client->getResponse();
		if (count($ranks) == 0) {
			$re_config['States']['LiveRankings']['NoRecordsFound'] = true;
		}
		else {

			// Clean before filling
			$re_scores['LiveRankings'] = array();

			for ($i=0; $i < count($ranks); $i++){
				if ( ($ranks[$i]['BestTime'] > 0) || ($ranks[$i]['Score'] > 0) ) {
					$re_scores['LiveRankings'][$i]['rank']		= ($i+1);
					$re_scores['LiveRankings'][$i]['login']		= ( ($ranks[$i]['Login'] != '') ? $ranks[$i]['Login'] : 'TEAM-'.$ranks[$i]['PlayerId']);
					$re_scores['LiveRankings'][$i]['nickname']	= re_handleSpecialChars($ranks[$i]['NickName']);
					if ($gamemode == 0) {
						// 0 = Rounds, display Score instead Time?
						if ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['DISPLAY_TYPE'][0] == true) {
							$re_scores['LiveRankings'][$i]['score'] = formatTime($ranks[$i]['BestTime']);
						}
						else {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'];
						}
					}
					else if ($gamemode == 2) {
						// 2 = TeamMode (Player(Team) with score)
						if ( isset($re_config['CurrentGameInfos']['TeamPointsLimit']) ) {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'] .'/'. $re_config['CurrentGameInfos']['TeamPointsLimit'];
						}
						else {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'];
						}
					}
					else if ($gamemode == 3) {
						// 3 = Laps, display Checkpoints instead Time?
						if ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['DISPLAY_TYPE'][0] == true) {
							$re_scores['LiveRankings'][$i]['score'] = formatTime($ranks[$i]['BestTime']);
						}
						else {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'] . (($ranks[$i]['Score'] == 1) ? ' cp.' : ' cps.');
						}
					}
					else if ($gamemode == 4) {
						// 4 = Stunts
						$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'];
					}
					else if ($gamemode == 5) {
						// 5 = CupMode
						if ( isset($re_config['CurrentGameInfos']['CupPointsLimit']) ) {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'] .'/'. $re_config['CurrentGameInfos']['CupPointsLimit'];
						}
						else {
							$re_scores['LiveRankings'][$i]['score'] = $ranks[$i]['Score'];
						}
					}
					else {
						$re_scores['LiveRankings'][$i]['score'] = formatTime($ranks[$i]['BestTime']);
					}
				}
				else if ($gamemode == 2) {
					// 2 = TeamMode (Player(Team) without score)
					if ( isset($re_config['CurrentGameInfos']['TeamPointsLimit']) ) {
						$re_scores['LiveRankings'][$i]['score'] = '0/'. $re_config['CurrentGameInfos']['TeamPointsLimit'];
					}
					else {
						$re_scores['LiveRankings'][$i]['score'] = 0;
					}
				}
			}

			// Change the Team login/nicknames and colors in TeamMode
			if ($gamemode == 2) {
				$re_scores['LiveRankings'][0]['login'] = 'TEAM-0';
				$re_scores['LiveRankings'][1]['login'] = 'TEAM-1';
				$re_scores['LiveRankings'][0]['nickname'] = '$08FTeam Blue';
				$re_scores['LiveRankings'][1]['nickname'] = '$F50Team Red';
			}

			$re_config['States']['LiveRankings']['NoRecordsFound'] = false;
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getVisitors () {
	global $re_scores;


	$query = 'SELECT COUNT(`Id`) AS `PlayerCount` FROM `players`;';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['Visitors'] = 0;

		if ($row = mysql_fetch_object($res)) {
			$re_scores['Visitors'] = number_format((int)$row->PlayerCount, 0, '.', ' ');
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopRankings ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		(ROUND(`r`.`avg` / 1000) / 10) AS `avg`
	FROM `players` AS `p`
	LEFT JOIN `rs_rank` AS `r` ON `p`.`Id`=`r`.`PlayerId`
	WHERE `r`.`avg`!=0
	ORDER BY `r`.`avg` ASC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopRankings'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopRankings'][$i]['login']		= $row->Login;
			$re_scores['TopRankings'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['TopRankings'][$i]['score']		= sprintf("%.1f", $row->avg);

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopWinners ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		`p`.`Wins`
	FROM `players` AS `p`
	ORDER BY `p`.`Wins` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopWinners'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopWinners'][$i]['login']		= $row->Login;
			$re_scores['TopWinners'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['TopWinners'][$i]['score']		= number_format((int)$row->Wins, 0, '.', ' ');

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getMostRecords ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		COUNT(`p`.`Id`) AS `Count`
	FROM `records` AS `r`
	INNER JOIN `players` AS `p` ON `r`.`PlayerId`=`p`.`Id`
	GROUP BY `p`.`Id`
	ORDER BY `Count` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['MostRecords'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['MostRecords'][$i]['login']		= $row->Login;
			$re_scores['MostRecords'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['MostRecords'][$i]['score']		= number_format((int)$row->Count, 0, '.', ' ');

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getMostFinished ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		COUNT(`r`.`score`) AS `Count`
	FROM `rs_times` AS `r`
	LEFT JOIN `players` AS `p` ON `p`.`Id`=`r`.`playerID`
	GROUP BY `r`.`playerID`
	ORDER BY `Count` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['MostFinished'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['MostFinished'][$i]['login']		= $row->Login;
			$re_scores['MostFinished'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['MostFinished'][$i]['score']		= number_format((int)$row->Count, 0, '.', ' ');

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopPlaytime ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		`p`.`TimePlayed`
	FROM `players`AS `p`
	ORDER BY `TimePlayed` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopPlaytime'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopPlaytime'][$i]['login']		= $row->Login;
			$re_scores['TopPlaytime'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['TopPlaytime'][$i]['score']		= number_format(round($row->TimePlayed / 3600), 0, '.', ' ').' h';

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopDonators ($limit = 100) {
	global $re_config, $re_scores;


	$query = '
	SELECT
		`p`.`Login`,
		`p`.`NickName`,
		`pe`.`donations`
	FROM `players` AS `p`
	LEFT JOIN `players_extra` AS `pe` ON `p`.`Id`=`pe`.`playerID`
	WHERE `pe`.`donations`!=0
	ORDER BY `pe`.`donations` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopDonators'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopDonators'][$i]['login']		= $row->Login;
			$re_scores['TopDonators'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
			$re_scores['TopDonators'][$i]['score']		= number_format((int)$row->donations, 0, '.', ' ');

			$i++;
		}

		$re_config['States']['TopDonators']['NeedUpdate'] = false;
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getNationList ($limit = 100) {
	global $re_scores;


	$query = '
	SELECT
		COUNT(`Nation`) AS `Count`,
		`Nation`
	FROM `players`
	GROUP BY `Nation`
	ORDER BY `Count` DESC
	LIMIT '. $limit .';';

	$flagfix = array(
		'SCG'	=> 'SRB',
		'ROM'	=> 'ROU',
		'CAR'	=> 'CMR'
	);

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopNations'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopNations'][$i]['nation']		= (isset($flagfix[$row->Nation]) ? $flagfix[$row->Nation] : $row->Nation);
			$re_scores['TopNations'][$i]['score']		= number_format((int)$row->Count, 0, '.', ' ');

			$i++;
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopTracks ($limit = 100) {
	global $re_config, $re_scores;


	$query = '
	SELECT
		SUM(`k`.`Score`) AS `karma`,
		`c`.`Name` AS `challenge`
	FROM `rs_karma` AS `k`
	LEFT JOIN `challenges` AS `c` ON `c`.`Id`=`k`.`ChallengeId`
	GROUP BY `k`.`ChallengeId`
	ORDER BY `karma` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopTracks'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopTracks'][$i]['karma']		= number_format((int)$row->karma, 0, '.', ' ');
			$re_scores['TopTracks'][$i]['track']		= re_handleSpecialChars($row->challenge);

			$i++;
		}

		$re_config['States']['TopTracks']['NeedUpdate'] = false;
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopVoters ($limit = 100) {
	global $re_config, $re_scores;


	$query = '
	SELECT
		COUNT(`r`.`Score`) AS `vote_count`,
		`p`.`NickName` AS `nickname`
	FROM `rs_karma` AS `r`, `players` AS `p`
	WHERE `r`.`PlayerId`=`p`.`Id`
	GROUP BY `r`.`PlayerId`
	ORDER BY `vote_count` DESC
	LIMIT '. $limit .';';

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopVoters'] = array();

		$i = 0;
		while ($row = mysql_fetch_object($res)) {
			$re_scores['TopVoters'][$i]['score']		= number_format((int)$row->vote_count, 0, '.', ' ');
			$re_scores['TopVoters'][$i]['nickname']		= re_handleSpecialChars($row->nickname);

			$i++;
		}

		$re_config['States']['TopVoters']['NeedUpdate'] = false;
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTopBetwins ($limit = 100) {
	global $re_config, $re_scores;


	if ($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['DISPLAY'][0] == true) {
		// Calculate the Average
		$query = '
		SELECT
			`p`.`NickName`,
			((`b`.`wins` / `b`.`stake`) * `b`.`countwins`) AS `won`
		FROM `betting` AS `b`
		LEFT JOIN `players` AS `p` ON `p`.`Login`=`b`.`login`
		WHERE `b`.`wins`>0
		AND `p`.`NickName` IS NOT NULL
		ORDER BY `won` DESC
		LIMIT '. $limit .';';
	}
	else {
		// Get the Coppers
		$query = '
		SELECT
			`p`.`NickName`,
			`b`.`wins` AS `won`
		FROM `betting` AS `b`
		LEFT JOIN `players` AS `p` ON `p`.`Login`=`b`.`login`
		WHERE `b`.`wins`>0
		AND `p`.`NickName` IS NOT NULL
		ORDER BY `won` DESC
		LIMIT '. $limit .';';
	}

	$res = mysql_query($query);
	if ( ($res) && (mysql_num_rows($res) > 0) ) {

		// Clean before filling
		$re_scores['TopBetwins'] = array();

		$i = 0;
		if ($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['DISPLAY'][0] == true) {
			// Wanna have the average
			while ($row = mysql_fetch_object($res)) {
				$re_scores['TopBetwins'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
				$re_scores['TopBetwins'][$i]['won']		= sprintf("%.2f", $row->won);

				$i++;
			}
		}
		else {
			// Wanna have the Coppers
			while ($row = mysql_fetch_object($res)) {
				$re_scores['TopBetwins'][$i]['nickname']	= re_handleSpecialChars($row->NickName);
				$re_scores['TopBetwins'][$i]['won']		= number_format((int)$row->won, 0, '.', ' ');

				$i++;
			}
		}
	}
	mysql_free_result($res);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $music_server is imported from plugin.musicserver.php
function re_getCurrentSong () {
	global $aseco, $music_server, $re_config, $re_cache;


	// Get current song and strip server path
	$aseco->client->query('GetForcedMusic');
	$current = $aseco->client->getResponse();

	if ( ($current['Url'] != '') || ($current['File'] != '') ) {
		$songname = strtolower(str_replace($music_server->server, '', ($current['Url'] != '' ? $current['Url'] : $current['File'])));
		for ($i = 0; $i < count($re_cache['MusicServerPlaylist']); $i ++) {
			if ($re_cache['MusicServerPlaylist'][$i]['File'] == $songname) {
				$re_config['CurrentMusicInfos'] = array(
					'Artist'	=> $re_cache['MusicServerPlaylist'][$i]['Artist'],
					'Title'		=> $re_cache['MusicServerPlaylist'][$i]['Title']
				);
				return;
			}
		}
	}

	$re_config['CurrentMusicInfos'] = array(
		'Artist'	=> 'unknown',
		'Title'		=> 'unknown',
	);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $music_server is imported from plugin.musicserver.php
function re_getMusicServerPlaylist () {
	global $re_cache, $re_config, $music_server;


	// Clean before refill
	$re_cache['MusicServerPlaylist'] = array();

	// Remove hole in array (only required in XASECO <= 1.12)
	$music_server->songs = array_values($music_server->songs);

	$id = 1;	// SongId starts from 1
	foreach ($music_server->songs as $song) {

		if ( (isset($music_server->tags[$song]['Artist'])) && (!empty($music_server->tags[$song]['Artist'])) ) {
			$re_cache['MusicServerPlaylist'][] = array(
				'SongId'	=> $id,
				'File'		=> strtolower($song),		// strtolower() required for re_getCurrentSong()
				'Artist'	=> '$Z'. re_handleSpecialChars(utf8_decode($music_server->tags[$song]['Artist'])),
				'Title'		=> '$Z'. re_handleSpecialChars(utf8_decode($music_server->tags[$song]['Title']))
			);
		}
		else {
			// Try to convert filename into "Artist" and "Title",
			// e.g. "paul_kalkbrenner_-_gebrunn_gebrunn_(berlin_calling_mix).ogg"
			// to $artist = 'Paul Kalkbrenner', $title = 'Gebrunn Gebrunn (Berlin Calling Mix)'
			$artist = '---';
			$title = '(Without Ogg Vorbis Infotag)';

			// Replace "_" with " "
			$music = str_replace('_', ' ', $song);

			// Remove ".ogg" or ".mux"
			$music = str_ireplace(
				array(
					'.ogg',
					'.mux'
				),
				array(
					'',
					''
				),
				$music
			);

			$pieces = explode('-', $music);
			foreach ($pieces as &$item) {
				$item = trim($item);
			}
			if (count($pieces) > 2) {
				$artist = $pieces[0];
				$title = $pieces[count($pieces)-1];
			}
			else {
				$artist = (isset($pieces[0]) ? $pieces[0] : $artist);
				$title = (isset($pieces[1]) ? $pieces[1] : $title);
			}

			$re_cache['MusicServerPlaylist'][] = array(
				'SongId'	=> $id,
				'File'		=> strtolower($song),		// strtolower() required for re_getCurrentSong()
				'Artist'	=> '$Z'. re_handleSpecialChars(utf8_decode(ucwords($artist))),
				'Title'		=> '$Z'. re_handleSpecialChars(utf8_decode(ucwords($title)))
			);
		}
		$id ++;
	}


	if ($re_config['FEATURES'][0]['SORT_SONGLIST'][0] == true) {
		// Build the arrays for sorting
		$artists = array();
		$titles = array();
		foreach ($re_cache['MusicServerPlaylist'] as $key => &$row) {
			$artists[$key]	= $row['Artist'];
			$titles[$key]	= $row['Title'];
		}

		// Make sure all that is to compare is lowercase
		$artists = array_map('strtolower', $artists);
		$titles = array_map('strtolower', $titles);

		// Sort by Artist and Title
		array_multisort($artists, SORT_ASC, $titles, SORT_ASC, $re_cache['MusicServerPlaylist']);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getConnectedPlayerRecord ($login, $line, $topcount, $behind_rankings = false) {
	global $aseco, $re_config;


	// Is the given Player currently online? If true, mark her/his Record at other Players.
	if ( isset($aseco->server->players->player_list[$login]) ) {
		if (($line+1) > $topcount) {
			// Add Background for Player with an record here
			$xml  = '<quad posn="-1.5 -'. ($re_config['LineHeight'] * $line + 2.7) .' 0.003" sizen="18.5 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_SUBSTYLE'][0] .'"/>';
			$xml .= '<quad posn="15.15 -'. ($re_config['LineHeight'] * $line + 2.8) .' 0.004" sizen="1.8 1.8" style="Icons128x128_1" substyle="'. (($behind_rankings == true) ? 'ChallengeAuthor' : 'Solo') .'"/>';
			$xml .= '<quad posn="-1.4 -'. ($re_config['LineHeight'] * $line + 2.8) .' 0.004" sizen="1.8 1.8" style="Icons128x128_1" substyle="'. (($behind_rankings == true) ? 'ChallengeAuthor' : 'Solo') .'"/>';
		}
		else {
			// Add only a marker for Player with an record here
			$xml  = '<quad posn="-1.5 -'. ($re_config['LineHeight'] * $line + 2.7) .' 0.003" sizen="2 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_SUBSTYLE'][0] .'"/>';
			$xml .= '<quad posn="15 -'. ($re_config['LineHeight'] * $line + 2.7) .' 0.003" sizen="2 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_OTHER_SUBSTYLE'][0] .'"/>';
			$xml .= '<quad posn="15.15 -'. ($re_config['LineHeight'] * $line + 2.8) .' 0.004" sizen="1.8 1.8" style="Icons128x128_1" substyle="'. (($behind_rankings == true) ? 'ChallengeAuthor' : 'Solo') .'"/>';
			$xml .= '<quad posn="-1.4 -'. ($re_config['LineHeight'] * $line + 2.8) .' 0.004" sizen="1.8 1.8" style="Icons128x128_1" substyle="'. (($behind_rankings == true) ? 'ChallengeAuthor' : 'Solo') .'"/>';
		}
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getPlayerLocalRecords ($pid) {
	global $aseco;


	// Get Player's record for each Challenge
	$query = "SELECT `r`.`PlayerId`, `r`.`Score`, `c`.`Uid`, `r`.`ChallengeId`
		  FROM `records` AS `r`
		  LEFT JOIN `challenges` AS `c` ON `c`.`Id` = `r`.`ChallengeId`
		  WHERE `r`.`Score` != ''
	          ORDER BY `r`.`ChallengeId` ASC, `Score` ". ($aseco->server->gameinfo->mode == 4 ? 'DESC' : 'ASC') .",`Date` ASC;";
	$result = mysql_query($query);

	if ($result) {
		$last = false;
		$list = array();
		$pos = 1;
		while ($row = mysql_fetch_object($result)) {

			// Reset Rank counter
			if ($last != $row->Uid) {
				$last = $row->Uid;
				$pos = 1;
			}

			// Do not count Rank if already in Tracklist
			if ( isset($list[$row->Uid]) ) {
				continue;
			}

			// Only add the calling Player
			if ($row->PlayerId == $pid) {
				$list[$row->Uid] = array(
					'rank'	=> $pos,
					'score'	=> $row->Score,
				);
				continue;
			}
			$pos ++;
		}
	}
	mysql_free_result($result);

	return $list;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_findPlayerRecords ($login) {
	global $re_scores;


	$DedimaniaRecords	= false;
	$LocalRecords		= false;
	$GerymaniaRecords	= false;

	// Check for DedimaniaRecords
	if ( count($re_scores['DedimaniaRecords']) > 0) {
		foreach ($re_scores['DedimaniaRecords'] as &$item) {
			if ($item['login'] == $login) {
				$DedimaniaRecords = true;
				break;
			}
		}
	}

	// Check for LocalRecords
	if ( count($re_scores['LocalRecords']) > 0) {
		foreach ($re_scores['LocalRecords'] as &$item) {
			if ($item['login'] == $login) {
				$LocalRecords = true;
				break;
			}
		}
	}

	// Check for GerymaniaRecords
	if ( count($re_scores['GerymaniaRecords']) > 0) {
		foreach ($re_scores['GerymaniaRecords'] as &$item) {
			if ($item['login'] == $login) {
				$GerymaniaRecords = true;
				break;
			}
		}
	}

	return array('DedimaniaRecords' => $DedimaniaRecords, 'GerymaniaRecords' => $GerymaniaRecords, 'LocalRecords' => $LocalRecords);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopRankingsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '18'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopRankings']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopRankings'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopWinnersForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '19'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopWinners']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopWinners'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildMostRecordsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '20'),
			$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_STYLE'][0],
					$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['MostRecords']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['MostRecords'] as &$item) 		{
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildMostFinishedForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '21'),
			$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['MostFinished']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['MostFinished'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopPlaytimeForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '22'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopPlaytime']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopPlaytime'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopDonatorsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '23'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopDonators']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopDonators'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right"  scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopNationsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '24'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopNations']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopNations'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<quad posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset - 0.3) .' 0.002" sizen="2 2" image="tmtp://Skins/Avatars/Flags/'. (($item['nation'] == 'OTH') ? 'other' : $item['nation']) .'.dds"/>';
			$xml .= '<label posn="7 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="8.75 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $re_config['IocNations'][$item['nation']] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopTracksForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '25'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopTracks']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopTracks'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['karma'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['track'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopVotersForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '26'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopVoters']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopVoters'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopBetwinsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '27'),
			$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['TopBetwins']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['TopBetwins'] as &$item) {
			$xml .= '<label posn="4 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.4 1.7" halign="right"  scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['won'] .'"/>';
			$xml .= '<label posn="4.65 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="11.1 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildDedimaniaRecordsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '15'),
			$re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['DEDIMANIA_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['DedimaniaRecords']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['DedimaniaRecords'] as &$item) {
			$xml .= '<label posn="2.1 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="1.7 1.7" halign="right" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . ($line + 1) .'."/>';
			$xml .= '<label posn="5.7 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.8 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="5.9 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="9.6 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildGerymaniaRecordsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '17'),
			$re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['GERYMANIA_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['GerymaniaRecords']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['GerymaniaRecords'] as &$item) {
			$xml .= '<label posn="2.1 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="1.7 1.7" halign="right" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . ($line + 1) .'."/>';
			$xml .= '<label posn="5.7 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.8 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="5.9 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="9.6 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLocalRecordsForScore ($limit = 6) {
	global $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%manialinkid%',
			'%posx%',
			'%posy%',
			'%widgetheight%',
			'%icon_style%',
			'%icon_substyle%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '16'),
			$re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['POS_X'][0],
			$re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['POS_Y'][0],
			($re_config['LineHeight'] * $re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['ENTRIES'][0] + 3.3),
			$re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['ICON_SUBSTYLE'][0],
			utf8_encode($re_config['SCORETABLE_LISTS'][0]['LOCAL_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['SCORETABLE_LISTS']->header
	);

	if ( count($re_scores['LocalRecords']) > 0 ) {
		// Build the entries
		$line = 0;
		$offset = 3;
		foreach ($re_scores['LocalRecords'] as &$item) {
			$xml .= '<label posn="2.1 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="1.7 1.7" halign="right" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . ($line + 1) .'."/>';
			$xml .= '<label posn="5.7 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="3.8 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<label posn="5.9 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.002" sizen="9.6 1.7" scale="0.9" text="'. $re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}
	}
	$xml .= $re_config['Templates']['SCORETABLE_LISTS']->footer;

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildDedimaniaRecordsWidget ($login, $preset, $gamemode, $limit = 50) {
	global $re_config, $re_scores, $re_cache;


	// Set the Topcount
	$topcount = $re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Add Widget header
	$xml = $re_cache['DedimaniaRecords'][$gamemode]['WidgetHeader'];

	// Build the entries if already loaded
	if ( count($re_scores['DedimaniaRecords']) > 0 ) {

		if ($re_config['States']['NiceMode'] == false) {
			// Build the "CloseToYou" Array
			$records = re_buildCloseToYouArray($re_scores['DedimaniaRecords'], $preset, $limit, $topcount);

			// Now check if it is required to build this Manialink (only required in normal mode, nice mode send always)
			$digest = re_buildCloseToYouDigest($records);
			if ($re_cache['PlayerStates'][$login]['DedimaniaRecords'] != false) {
				if ( ($re_cache['PlayerStates'][$login]['DedimaniaRecords'] != $digest) || ($re_config['States']['DedimaniaRecords']['UpdateDisplay'] == true) ) {

					// Widget is different as before, store them and build the new Widget
					$re_cache['PlayerStates'][$login]['DedimaniaRecords'] = $digest;
				}
				else {
					// Widget is unchanged, no need to send now
					return;
				}
			}
			else {
				// Widget is build first time for this Player, store them and build the new Widget
				$re_cache['PlayerStates'][$login]['DedimaniaRecords'] = $digest;
			}
		}
		else {
			$records = $re_scores['DedimaniaRecords'];
		}

		// Create the Widget entries
		$line = 0;
		$behind_rankings = false;
		foreach ($records as &$item) {

			// Mark all Players behind the current with an orange icon instead a green one
			if ($item['login'] == $login) {
				$behind_rankings = true;
			}

			// Mark connected Players with a record
			if ( ($re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0] == true) && ($re_config['States']['NiceMode'] == false) && ($item['login'] != $login) ) {
				$xml .= re_getConnectedPlayerRecord($item['login'], $line, $topcount, $behind_rankings);
			}

			// Build record entries
			$xml .= re_getCloseToYouEntry($item, $line, $topcount, $re_config['PlaceholderNoScore'], $re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0]);

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}

	}
	else if ($login != false) {
		// Create an empty entry
		$xml .= re_getCloseToYouEntry($preset, 0, $topcount, $re_config['PlaceholderNoScore'], $re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0]);
	}

	// Add Widget footer
	$xml .= $re_cache['DedimaniaRecords'][$gamemode]['WidgetFooter'];

	// Send the Widget now
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildDedimaniaRecordsWidgetBody ($gamemode) {
	global $re_config;


	// Set the right Icon and Title position
	$position = (($re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0] < 0) ? 'right' : 'left');

	// Set the Topcount
	$topcount = $re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Calculate the widget height (+ 3.3 for title)
	$widget_height = ($re_config['LineHeight'] * $re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0] + 3.3);

	if ($position == 'right') {
		$imagex	= ($re_config['Positions'][$position]['image_open']['x'] + ($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
		$iconx	= ($re_config['Positions'][$position]['icon']['x'] + ($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
		$titlex	= ($re_config['Positions'][$position]['title']['x'] + ($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
	}
	else {
		$imagex	= $re_config['Positions'][$position]['image_open']['x'];
		$iconx	= $re_config['Positions'][$position]['icon']['x'];
		$titlex	= $re_config['Positions'][$position]['title']['x'];
	}

	$build->header = str_replace(
		array(
			'%manialinkid%',
			'%actionid%',
			'%posx%',
			'%posy%',
			'%image_open_pos_x%',
			'%image_open_pos_y%',
			'%image_open%',
			'%posx_icon%',
			'%posy_icon%',
			'%icon_style%',
			'%icon_substyle%',
			'%halign%',
			'%posx_title%',
			'%posy_title%',
			'%widgetwidth%',
			'%widgetheight%',
			'%title_background_width%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '11'),
			sprintf("%d%s", $re_config['ManialinkId'], '04'),
			$re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0],
			$re_config['DEDIMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_Y'][0],
			$imagex,
			-($widget_height - 3.3),
			$re_config['Positions'][$position]['image_open']['image'],
			$iconx,
			$re_config['Positions'][$position]['icon']['y'],
			$re_config['DEDIMANIA_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['DEDIMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
			$re_config['Positions'][$position]['title']['halign'],
			$titlex,
			$re_config['Positions'][$position]['title']['y'],
			$re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0],
			$widget_height,
			($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] - 0.8),
			utf8_encode($re_config['DEDIMANIA_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['RECORD_WIDGETS']->header
	);

	// Add Background for top X Players
	if ($topcount > 0) {
		$build->header .= '<quad posn="0.4 -2.6 0.003" sizen="'. ($re_config['DEDIMANIA_RECORDS'][0]['WIDTH'][0] - 0.8) .' '. (($topcount * $re_config['LineHeight']) + 0.3) .'" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	}

	$build->footer = $re_config['Templates']['RECORD_WIDGETS']->footer;

	return $build;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildGerymaniaRecordsWidget ($login, $preset, $gamemode, $limit = 50) {
	global $re_config, $re_scores, $re_cache;


	// Set the Topcount
	$topcount = $re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Add Widget header
	$xml = $re_cache['GerymaniaRecords'][$gamemode]['WidgetHeader'];

	// Build the entries if already loaded
	if ( count($re_scores['GerymaniaRecords']) > 0 ) {

		if ($re_config['States']['NiceMode'] == false) {
			// Build the "CloseToYou" Array
			$records = re_buildCloseToYouArray($re_scores['GerymaniaRecords'], $preset, $limit, $topcount);

			// Now check if it is required to build this Manialink (only required in normal mode, nice mode send always)
			$digest = re_buildCloseToYouDigest($records);
			if ($re_cache['PlayerStates'][$login]['GerymaniaRecords'] != false) {
				if ( ($re_cache['PlayerStates'][$login]['GerymaniaRecords'] != $digest) || ($re_config['States']['GerymaniaRecords']['UpdateDisplay'] == true) ) {

					// Widget is different as before, store them and build the new Widget
					$re_cache['PlayerStates'][$login]['GerymaniaRecords'] = $digest;
				}
				else {
					// Widget is unchanged, no need to send now
					return;
				}
			}
			else {
				// Widget is build first time for this Player, store them and build the new Widget
				$re_cache['PlayerStates'][$login]['GerymaniaRecords'] = $digest;
			}
		}
		else {
			$records = $re_scores['GerymaniaRecords'];
		}

		// Create the Widget entries
		$line = 0;
		$behind_rankings = false;
		foreach ($records as &$item) {

			// Mark all Players behind the current with an orange icon instead a green one
			if ($item['login'] == $login) {
				$behind_rankings = true;
			}

			// Mark connected Players with a record
			if ( ($re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0] == true) && ($re_config['States']['NiceMode'] == false) && ($item['login'] != $login) ) {
				$xml .= re_getConnectedPlayerRecord($item['login'], $line, $topcount, $behind_rankings);
			}

			// Build record entries
			$xml .= re_getCloseToYouEntry($item, $line, $topcount, $re_config['PlaceholderNoScore'], $re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0]);

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}

	}
	else if ($login != false) {
		// Create an empty entry
		$xml .= re_getCloseToYouEntry($preset, 0, $topcount, $re_config['PlaceholderNoScore'], $re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0]);
	}

	// Add Widget footer
	$xml .= $re_cache['GerymaniaRecords'][$gamemode]['WidgetFooter'];

	// Send the Widget now
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildGerymaniaRecordsWidgetBody ($gamemode) {
	global $re_config;


	// Set the right Icon and Title position
	$position = (($re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0] < 0) ? 'right' : 'left');

	// Set the Topcount
	$topcount = $re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Calculate the widget height (+ 3.3 for title)
	$widget_height = ($re_config['LineHeight'] * $re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0] + 3.3);

	if ($position == 'right') {
		$imagex	= ($re_config['Positions'][$position]['image_open']['x'] + ($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
		$iconx	= ($re_config['Positions'][$position]['icon']['x'] + ($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
		$titlex	= ($re_config['Positions'][$position]['title']['x'] + ($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] - 15.5));
	}
	else {
		$imagex	= $re_config['Positions'][$position]['image_open']['x'];
		$iconx	= $re_config['Positions'][$position]['icon']['x'];
		$titlex	= $re_config['Positions'][$position]['title']['x'];
	}

	$build->header = str_replace(
		array(
			'%manialinkid%',
			'%actionid%',
			'%posx%',
			'%posy%',
			'%image_open_pos_x%',
			'%image_open_pos_y%',
			'%image_open%',
			'%posx_icon%',
			'%posy_icon%',
			'%icon_style%',
			'%icon_substyle%',
			'%halign%',
			'%posx_title%',
			'%posy_title%',
			'%widgetwidth%',
			'%widgetheight%',
			'%title_background_width%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '14'),
			sprintf("%d%s", $re_config['ManialinkId'], '07'),
			$re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0],
			$re_config['GERYMANIA_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_Y'][0],
			$imagex,
			-($widget_height - 3.3),
			$re_config['Positions'][$position]['image_open']['image'],
			$iconx,
			$re_config['Positions'][$position]['icon']['y'],
			$re_config['GERYMANIA_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['GERYMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
			$re_config['Positions'][$position]['title']['halign'],
			$titlex,
			$re_config['Positions'][$position]['title']['y'],
			$re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0],
			$widget_height,
			($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] - 0.8),
			utf8_encode($re_config['GERYMANIA_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['RECORD_WIDGETS']->header
	);

	// Add Background for top X Players
	if ($topcount > 0) {
		$build->header .= '<quad posn="0.4 -2.6 0.003" sizen="'. ($re_config['GERYMANIA_RECORDS'][0]['WIDTH'][0] - 0.8) .' '. (($topcount * $re_config['LineHeight']) + 0.3) .'" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	}

	$build->footer = $re_config['Templates']['RECORD_WIDGETS']->footer;

	return $build;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLocalRecordsWidget ($login, $preset, $gamemode, $limit = 50) {
	global $re_config, $re_scores, $re_cache;


	// Set the Topcount
	$topcount = $re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Add Widget header
	$xml = $re_cache['LocalRecords'][$gamemode]['WidgetHeader'];

	// Build the entries if already loaded
	if ( count($re_scores['LocalRecords']) > 0 ) {

		if ($re_config['States']['NiceMode'] == false) {
			// Build the "CloseToYou" Array
			$records = re_buildCloseToYouArray($re_scores['LocalRecords'], $preset, $limit, $topcount);

			// Now check if it is required to build this Manialink (only required in normal mode, nice mode send always)
			$digest = re_buildCloseToYouDigest($records);
			if ($re_cache['PlayerStates'][$login]['LocalRecords'] != false) {
				if ( ($re_cache['PlayerStates'][$login]['LocalRecords'] != $digest) || ($re_config['States']['LocalRecords']['UpdateDisplay'] == true) ) {

					// Widget is different as before, store them and build the new Widget
					$re_cache['PlayerStates'][$login]['LocalRecords'] = $digest;
				}
				else {
					// Widget is unchanged, no need to send now
					return;
				}
			}
			else {
				// Widget is build first time for this Player, store them and build the new Widget
				$re_cache['PlayerStates'][$login]['LocalRecords'] = $digest;
			}
		}
		else {
			$records = $re_scores['LocalRecords'];
		}

		// Create the Widget entries
		$line = 0;
		$behind_rankings = false;
		foreach ($records as &$item) {

			// Mark all Players behind the current with an orange icon instead a green one
			if ($item['login'] == $login) {
				$behind_rankings = true;
			}

			// Mark connected Players with a record
			if ( ($re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0] == true) && ($re_config['States']['NiceMode'] == false) && ($item['login'] != $login) ) {
				$xml .= re_getConnectedPlayerRecord($item['login'], $line, $topcount, $behind_rankings);
			}

			// Build record entries
			$xml .= re_getCloseToYouEntry($item, $line, $topcount, $re_config['PlaceholderNoScore'], $re_config['LOCAL_RECORDS'][0]['WIDTH'][0]);

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}

	}
	else if ($login != false) {
		// Create an empty entry
		$xml .= re_getCloseToYouEntry($preset, 0, $topcount, $re_config['PlaceholderNoScore'], $re_config['LOCAL_RECORDS'][0]['WIDTH'][0]);
	}

	// Add Widget footer
	$xml .= $re_cache['LocalRecords'][$gamemode]['WidgetFooter'];

	// Send the Widget now
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLocalRecordsWidgetBody ($gamemode) {
	global $re_config;


	// Set the right Icon and Title position
	$position = (($re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0] < 0) ? 'right' : 'left');

	// Set the Topcount
	$topcount = $re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Calculate the widget height (+ 3.3 for title)
	$widget_height = ($re_config['LineHeight'] * $re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0] + 3.3);

	if ($position == 'right') {
		$imagex	= ($re_config['Positions'][$position]['image_open']['x'] + ($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] - 15.5));
		$iconx	= ($re_config['Positions'][$position]['icon']['x'] + ($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] - 15.5));
		$titlex	= ($re_config['Positions'][$position]['title']['x'] + ($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] - 15.5));
	}
	else {
		$imagex	= $re_config['Positions'][$position]['image_open']['x'];
		$iconx	= $re_config['Positions'][$position]['icon']['x'];
		$titlex	= $re_config['Positions'][$position]['title']['x'];
	}

	$build->header = str_replace(
		array(
			'%manialinkid%',
			'%actionid%',
			'%posx%',
			'%posy%',
			'%image_open_pos_x%',
			'%image_open_pos_y%',
			'%image_open%',
			'%posx_icon%',
			'%posy_icon%',
			'%icon_style%',
			'%icon_substyle%',
			'%halign%',
			'%posx_title%',
			'%posy_title%',
			'%widgetwidth%',
			'%widgetheight%',
			'%title_background_width%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '12'),
			sprintf("%d%s", $re_config['ManialinkId'], '05'),
			$re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0],
			$re_config['LOCAL_RECORDS'][0]['GAMEMODE'][0][$gamemode][0]['POS_Y'][0],
			$imagex,
			-($widget_height - 3.3),
			$re_config['Positions'][$position]['image_open']['image'],
			$iconx,
			$re_config['Positions'][$position]['icon']['y'],
			$re_config['LOCAL_RECORDS'][0]['ICON_STYLE'][0],
			$re_config['LOCAL_RECORDS'][0]['ICON_SUBSTYLE'][0],
			$re_config['Positions'][$position]['title']['halign'],
			$titlex,
			$re_config['Positions'][$position]['title']['y'],
			$re_config['LOCAL_RECORDS'][0]['WIDTH'][0],
			$widget_height,
			($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] - 0.8),
			utf8_encode($re_config['LOCAL_RECORDS'][0]['TITLE'][0])
		),
		$re_config['Templates']['RECORD_WIDGETS']->header
	);

	// Add Background for top X Players
	if ($topcount > 0) {
		$build->header .= '<quad posn="0.4 -2.6 0.003" sizen="'. ($re_config['LOCAL_RECORDS'][0]['WIDTH'][0] - 0.8) .' '. (($topcount * $re_config['LineHeight']) + 0.3) .'" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	}

	$build->footer = $re_config['Templates']['RECORD_WIDGETS']->footer;

	return $build;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLiveRankingsWidget ($login, $preset, $gamemode, $limit = 50) {
	global $re_config, $re_scores, $re_cache;


	// Set the Placeholder for "No Score"
	if ( ($gamemode == 0) && ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['DISPLAY_TYPE'][0] == false) ) {
		// 0 = Rounds, only set this if 'score' are to display, if 'time' use the default
		$placeholder = 0;
	}
	else if ( ($gamemode == 3) && ($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['DISPLAY_TYPE'][0] == false) ) {
		// 3 = Laps, only set this if 'checkpoints' are to display, if 'time' use the default
		$placeholder = '0 cps.';
	}
	else {
		// All other gets the default
		$placeholder = $re_config['PlaceholderNoScore'];
	}

	// Set the Topcount
	$topcount = $re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Add Widget header
	$xml = $re_cache['LiveRankings'][$gamemode]['WidgetHeader'];

	// Build the entries if already loaded
	if ( count($re_scores['LiveRankings']) > 0 ) {

		if ( ($re_config['States']['NiceMode'] == false) && ($gamemode != 2) ) {
			// Build the "CloseToYou" Array, but not in TeamMode and NiceMode
			$records = re_buildCloseToYouArray($re_scores['LiveRankings'], $preset, $limit, $topcount);
		}
		else if ( ($re_config['States']['NiceMode'] == false) && ($gamemode == 2) ) {
			// Need to handle TeamMode other then all other Gamemodes
			$records = $re_scores['LiveRankings'];
			$records[0]['self'] = 0;
			$records[0]['rank'] = false;
			$records[1]['self'] = 0;
			$records[1]['rank'] = false;
		}
		else {
			$records = $re_scores['LiveRankings'];
		}


		// Now check if it is required to build this Manialink (only required in normal mode, nice mode send always)
		if ($re_config['States']['NiceMode'] == false) {
			$digest = re_buildCloseToYouDigest($records);
			if ($re_cache['PlayerStates'][$login]['LiveRankings'] != false) {
				if ($re_cache['PlayerStates'][$login]['LiveRankings'] != $digest) {

					// Widget is different as before, store them and build the new Widget
					$re_cache['PlayerStates'][$login]['LiveRankings'] = $digest;
				}
				else {
					// Widget is unchanged, no need to send now
					return;
				}
			}
			else {
				// Widget is build first time for this Player, store them and build the new Widget
				$re_cache['PlayerStates'][$login]['LiveRankings'] = $digest;
			}
		}


		// Create the Widget entries
		$line = 0;
		foreach ($records as &$item) {
			// No markers of connected Players with a record in LiveRankings,
			// that overload the Widget with marker, because (maybe) all Players are online right now.

			// Build record entries
			$xml .= re_getCloseToYouEntry($item, $line, $topcount, $placeholder, $re_config['LIVE_RANKINGS'][0]['WIDTH'][0]);

			$line ++;

			if ($line >= $limit) {
				break;
			}
		}

	}
	else if ($login != false) {
		// Create an empty entry
		$xml .= re_getCloseToYouEntry($preset, 0, $topcount, $placeholder, $re_config['LIVE_RANKINGS'][0]['WIDTH'][0]);
	}

	// Add Widget footer
	$xml .= $re_cache['LiveRankings'][$gamemode]['WidgetFooter'];

	// Send the Widget now
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLiveRankingsWidgetBody ($gamemode) {
	global $re_config;


	// Set the right Icon and Title position
	$position = (($re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0] < 0) ? 'right' : 'left');

	// Set the Topcount
	$topcount = $re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['TOPCOUNT'][0];

	// Calculate the widget height (+ 3.3 for title)
	$widget_height = ($re_config['LineHeight'] * $re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['ENTRIES'][0] + 3.3);

	if ($position == 'right') {
		$imagex	= ($re_config['Positions'][$position]['image_open']['x'] + ($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] - 15.5));
		$iconx	= ($re_config['Positions'][$position]['icon']['x'] + ($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] - 15.5));
		$titlex	= ($re_config['Positions'][$position]['title']['x'] + ($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] - 15.5));
	}
	else {
		$imagex	= $re_config['Positions'][$position]['image_open']['x'];
		$iconx	= $re_config['Positions'][$position]['icon']['x'];
		$titlex	= $re_config['Positions'][$position]['title']['x'];
	}

	$build->header = str_replace(
		array(
			'%manialinkid%',
			'%actionid%',
			'%posx%',
			'%posy%',
			'%image_open_pos_x%',
			'%image_open_pos_y%',
			'%image_open%',
			'%posx_icon%',
			'%posy_icon%',
			'%icon_style%',
			'%icon_substyle%',
			'%halign%',
			'%posx_title%',
			'%posy_title%',
			'%widgetwidth%',
			'%widgetheight%',
			'%title_background_width%',
			'%title%'
		),
		array(
			sprintf("%d%s", $re_config['ManialinkId'], '13'),
			sprintf("%d%s", $re_config['ManialinkId'], '06'),
			$re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['POS_X'][0],
			$re_config['LIVE_RANKINGS'][0]['GAMEMODE'][0][$gamemode][0]['POS_Y'][0],
			$imagex,
			-($widget_height - 3.3),
			$re_config['Positions'][$position]['image_open']['image'],
			$iconx,
			$re_config['Positions'][$position]['icon']['y'],
			$re_config['LIVE_RANKINGS'][0]['ICON_STYLE'][0],
			$re_config['LIVE_RANKINGS'][0]['ICON_SUBSTYLE'][0],
			$re_config['Positions'][$position]['title']['halign'],
			$titlex,
			$re_config['Positions'][$position]['title']['y'],
			$re_config['LIVE_RANKINGS'][0]['WIDTH'][0],
			$widget_height,
			($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] - 0.8),
			utf8_encode($re_config['LIVE_RANKINGS'][0]['TITLE'][0])
		),
		$re_config['Templates']['RECORD_WIDGETS']->header
	);

	// Add Background for top X Players
	if ($topcount > 0) {
		$build->header .= '<quad posn="0.4 -2.6 0.003" sizen="'. ($re_config['LIVE_RANKINGS'][0]['WIDTH'][0] - 0.8) .' '. (($topcount * $re_config['LineHeight']) + 0.3) .'" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	}

	$build->footer = $re_config['Templates']['RECORD_WIDGETS']->footer;

	return $build;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// Fully stolen from plugins.fufi.widgets.php (thanks fufi) and changed to my needs
function re_buildCloseToYouArray ($records, $preset, $ctuCount, $topCount) {
	global $re_config;


	// Set login to compare later
	$login = $preset['login'];

	// Init arrays
	$result = array_fill(0, $ctuCount, null);
	$better = array();
	$worse = array();
	$self = null;
	$isbetter = true;

	// Constructs arrays with records of better and worse players than the specified player
	for ($i=0; $i<count($records); $i++) {
		$entry = $records[$i];
		$entry['rank'] = $i + 1;
		if ($isbetter) {
			if ($records[$i]['login'] == $login) {
				$self = $entry;
				$isbetter = false;
			}
			else {
				$better[] = $entry;
			}
		}
		else {
			$worse[] = $entry;
		}
	}

	// Do the top x stuff
	$arrayTop = array();
	if ( count($better) > $topCount){
		for ($i=0; $i<$topCount; $i++) {
			$arrayTop[$i] = array();
			$arrayTop[$i] = array_shift($better);
			$arrayTop[$i]['self'] = -1;
		}
		$ctuCount -= $topCount;
	}

	// Go through the possibile scenarios and choose the right one (wow, what an explanation^^)
	if (!$self) {
		$lastIdx = $ctuCount - 1;
		$result[$lastIdx] = array();
		$result[$lastIdx]['rank'] = $preset['rank'];
		$result[$lastIdx]['login'] = $preset['login'];
		$result[$lastIdx]['nickname'] = $preset['nickname'];
		$result[$lastIdx]['score'] = $re_config['PlaceholderNoScore'];		// Changed onNewChallenge at related Gamemode (e.g. 'Stunts')
		$result[$lastIdx]['self'] = 0;
		for ($i=count($better)-1; $i>=0; $i--) {
			if (--$lastIdx >= 0) {
				$result[$lastIdx] = $better[$i];
				$result[$lastIdx]['self'] = -1;
			}
		}
	}
	else {
		$hasbetter = true;
		$hasworse = true;
		$resultNew = array();

		$resultNew[0] = $self;
		$resultNew[0]['self'] = 0;

		$idx = 0;

		while ( (count($resultNew) < $ctuCount) && (($hasbetter) || ($hasworse)) ) {

			if ( ($hasbetter) && (count($better) >= ($idx+1)) ) {

				// Push one record before
				$rec = $better[count($better) - 1 - $idx];
				$rec['self'] = -1;
				$help = array();
				$help[0] = $rec;
				for ($i=0; $i<count($resultNew); $i++) {
					$help[$i+1] = $resultNew[$i];
				}
				$resultNew = $help;
			}
			else {
				$hasbetter = false;
			}
			if ( count($resultNew) < ($ctuCount) ) {
				if ( ($hasworse) && (count($worse) >= ($idx+1)) ) {

					// Push one record behind
					$rec = $worse[$idx];
					$rec['self'] = 1;
					$resultNew[] = $rec;
				}
				else {
					$hasworse = false;
				}
			}
			$idx ++;
		}
		$result = $resultNew;
	}
	$result = array_merge($arrayTop, $result);

	$resultNew = array();
	$count = 0;
	for ($i=0; $i<count($result); $i++) {
		if ($result[$i] != null){
			if ( ( isset($result[$i]['self']) ) && ($result[$i]['self'] == 0) ) {
				if ($count >= $topCount) {
					$result[$i]['highlitefull'] = true;
				}
				else {
					$result[$i]['highlitefull'] = false;
				}
			}
			$resultNew[] = $result[$i];
			$count ++;
		}
	}
	$result = $resultNew;

	return $result;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// Fully stolen from plugins.fufi.widgets.php (thanks fufi)
function re_buildCloseToYouDigest ($array) {


	$result = '';
	for ($i=0; $i<count($array); $i++) {
		$result .= $array[$i]['rank'];
		$result .= $array[$i]['login'];
		$result .= $array[$i]['nickname'];
		$result .= $array[$i]['score'];
	}
	return md5($result);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $list = 'locals', 'dedimania' or 'gerymania'
function re_buildRecordDigest ($list, $array) {
	global $aseco;


	if ($list == 'locals') {
		$result = '';
		foreach ($array as &$entry) {
			$result .= $entry->player->login;
			$result .= $entry->player->nickname;
			$result .= $entry->score;
		}
		return md5($result);
	}
	else if ($list == 'dedimania') {
		$result = '';
		foreach ($array as &$entry) {
			$result .= $entry['Login'];
			$result .= $entry['NickName'];
			$result .= $entry['Best'];
		}
		return md5($result);
	}
	else if ($list == 'gerymania') {
		$result = '';
		foreach ($array as &$entry) {
			$result .= $entry['login'];
			$result .= $entry['nick'];
			$result .= $entry['score'];
		}
		return md5($result);
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getCloseToYouEntry ($item, $line, $topcount, $noscore, $widgetwidth) {
	global $re_config;



	// Set offset for calculation the line-heights
	$offset = 3;

	// Set default Text color
	$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0];

	// Do not build the Player related highlites if in NiceMode!
	$xml = '';
	if ($re_config['States']['NiceMode'] == false) {
		if ($item['self'] == -1) {
			if ($item['rank'] < ($topcount+1)) {
				$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['TOP'][0];
			}
			else {
				$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['BETTER'][0];
			}
		}
		else if ($item['self'] == 1) {
			if ($item['rank'] < ($topcount+1)) {
				$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['TOP'][0];
			}
			else {
				$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['WORSE'][0];
			}
		}
		else {
			$textcolor = $re_config['WIDGET_RACE'][0]['COLORS'][0]['SELF'][0];

			if ( (isset($item['highlitefull'])) && ($item['highlitefull']) ) {
				$xml .= '<quad posn="-1.5 -'. ($re_config['LineHeight'] * $line + $offset - 0.3) .' 0.003" sizen="'. ($widgetwidth + 3) .' 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_SUBSTYLE'][0] .'"/>';
				$xml .= '<quad posn="'. ($widgetwidth - 0.35) .' -'. ($re_config['LineHeight'] * $line + $offset - 0.1) .' 0.004" sizen="1.6 1.6" style="Icons64x64_1" substyle="ArrowPrev"/>';
				$xml .= '<quad posn="-1.3 -'. ($re_config['LineHeight'] * $line + $offset - 0.1) .' 0.004" sizen="1.6 1.6" style="Icons64x64_1" substyle="ArrowNext"/>';
			}
			else if ($item['rank'] != false) {	// $item['rank'] is set 'false' in TeamMode to skip the highlite here in re_buildLiveRankingsWidget()
				$xml .= '<quad posn="-1.5 -'. ($re_config['LineHeight'] * $line + $offset - 0.3) .' 0.003" sizen="2 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_SUBSTYLE'][0] .'"/>';
				$xml .= '<quad posn="'. ($widgetwidth - 0.5) .' -'. ($re_config['LineHeight'] * $line + $offset - 0.3) .' 0.003" sizen="2 2" style="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['HIGHLITE_SELF_SUBSTYLE'][0] .'"/>';
				$xml .= '<quad posn="'. ($widgetwidth - 0.3) .' -'. ($re_config['LineHeight'] * $line + $offset - 0.1) .' 0.004" sizen="1.6 1.6" style="Icons64x64_1" substyle="ArrowPrev"/>';
				$xml .= '<quad posn="-1.3 -'. ($re_config['LineHeight'] * $line + $offset - 0.1) .' 0.004" sizen="1.6 1.6" style="Icons64x64_1" substyle="ArrowNext"/>';
			}
		}
	}

	if ($item['rank'] != false) {
		if ( ($re_config['States']['NiceMode'] == true) && ($item['rank'] <= $topcount) ) {
			$textcolor = $re_config['NICEMODE'][0]['COLORS'][0]['TOP'][0];
		}
		else if ( ($re_config['States']['NiceMode'] == true) && ($item['rank'] > $topcount) ) {
			$textcolor = $re_config['NICEMODE'][0]['COLORS'][0]['WORSE'][0];
		}


		$xml .= '<label posn="2.3 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.004" sizen="1.7 1.7" halign="right" scale="0.9" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $item['rank'] .'."/>';
		$xml .= '<label posn="5.9 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.004" sizen="3.8 1.7" halign="right" scale="0.9" textcolor="'. $textcolor .'" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . ( (isset($item['score'])) ? $item['score'] : $noscore) .'"/>';
	}
	else {
		// In TeamMode nobody has a rank
		$xml .= '<label posn="5.9 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.004" sizen="5.3 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . ( (isset($item['score'])) ? $item['score'] : $noscore) .' pts."/>';
	}
	$xml .= '<label posn="6.1 -'. ($re_config['LineHeight'] * $line + $offset) .' 0.004" sizen="'. sprintf("%.02f", ($widgetwidth / 100 * 62.58)) .' 1.7" scale="0.9" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $item['nickname'] .'"/>';

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildDedimaniaRecordsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['DedimaniaRecords']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['DEDIMANIA_RECORDS'][0]['ICON_STYLE'][0],
				$re_config['DEDIMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['DEDIMANIA_RECORDS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['DedimaniaRecords'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildGerymaniaRecordsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['GerymaniaRecords']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['GERYMANIA_RECORDS'][0]['ICON_STYLE'][0],
				$re_config['GERYMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['GERYMANIA_RECORDS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['GerymaniaRecords'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLocalRecordsWindow ($page) {
	global $re_config, $re_scores;


	if ( count($re_scores['LocalRecords']) > 0) {

		// Frame for Previous/Next Buttons
		$buttons = '<frame posn="67.05 -53.2 0">';

		// Previous button
		if ($page > 0) {
			$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ($page + 99) .'" style="Icons64x64_1" substyle="ArrowPrev"/>';
		}
		else {
			$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="4.95 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}

		// Next button (display only if more pages to display)
		if ( ($page < 50) && (count($re_scores['LocalRecords']) > 100) && (($page+1) < (ceil(count($re_scores['LocalRecords'])/100))) ) {
			$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($page + 101) .'" style="Icons64x64_1" substyle="ArrowNext"/>';
		}
		else {
			$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="8.25 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}
		$buttons .= '</frame>';


		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['LOCAL_RECORDS'][0]['ICON_STYLE'][0],
				$re_config['LOCAL_RECORDS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['LOCAL_RECORDS'][0]['TITLE'][0]),
				$buttons
			),
			$re_config['Templates']['WINDOW']->header
		);

		$entries = 0;
		$line = 0;
		$offset = 0;
		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		for ($i = ($page * 100); $i < (($page * 100) + 100); $i ++) {

			// Is there a record?
			if ( !isset($re_scores['LocalRecords'][$i]) ) {
				break;
			}

			$item = $re_scores['LocalRecords'][$i];

			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $item['rank'] .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildLiveRankingsWindow ($page) {
	global $re_config, $re_scores;


	if ( count($re_scores['LiveRankings']) > 0) {

		// Frame for Previous/Next Buttons
		$buttons = '<frame posn="67.05 -53.2 0">';

		// Previous button
		if ($page > 0) {
			$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ($page + 149) .'" style="Icons64x64_1" substyle="ArrowPrev"/>';
		}
		else {
			$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="4.95 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}

		// Next button (display only if more pages to display)
		if ( ($page < 3) && (count($re_scores['LiveRankings']) > 100) && (($page+1) < (ceil(count($re_scores['LiveRankings'])/100))) ) {
			$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($page + 151) .'" style="Icons64x64_1" substyle="ArrowNext"/>';
		}
		else {
			$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="8.25 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}
		$buttons .= '</frame>';


		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['LIVE_RANKINGS'][0]['ICON_STYLE'][0],
				$re_config['LIVE_RANKINGS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['LIVE_RANKINGS'][0]['TITLE'][0]),
				$buttons
			),
			$re_config['Templates']['WINDOW']->header
		);

		$line = 0;
		$offset = 0;
		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		for ($i = ($page * 100); $i < (($page * 100) + 100); $i ++) {

			// Is there a rank?
			if ( !isset($re_scores['LiveRankings'][$i]) ) {
				break;
			}

			$item = $re_scores['LiveRankings'][$i];

			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $item['rank'] .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopRankingsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopRankings']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopRankings'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopWinnersWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopWinners']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopWinners'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildMostRecordsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['MostRecords']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['MostRecords'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildMostFinishedWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['MostFinished']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['MostFinished'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopPlaytimeWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopPlaytime']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopPlaytime'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopDonatorsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopDonators']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopDonators'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopTracksWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopTracks']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopTracks'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['karma'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['track'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopVotersWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopVoters']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopVoters'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopBetwinsWindow () {
	global $re_config, $re_scores;


	if ( count($re_scores['TopBetwins']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$rank = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopBetwins'] as &$item) {
			$xml .= '<label posn="'. (2.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="'. (6.1 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['won'] .'"/>';
			$xml .= '<label posn="'. (6.6 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($rank >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $jb_buffer and $jukebox are imported from plugin.rasp_jukebox.php
// $maxrecs is imported from rasp.settings.php
function re_buildTracklistWindow ($page, $player) {
	global $aseco, $re_config, $re_cache, $jb_buffer, $jukebox, $maxrecs;


	// Filter activity requested?
	$tracklist = array();
	$filteroption = '';	// Title addition
	if ( is_array($player->data['RecordsEyepieceTracklistFilter']) ) {
		if ( isset($player->data['RecordsEyepieceTracklistFilter']['env']) ){
			// Filter for environment
			foreach ($re_cache['Tracklist'] as &$track) {
				if (strtoupper($track['env']) == $player->data['RecordsEyepieceTracklistFilter']['env']) {
					$tracklist[] = $track;
				}
			}
			$filteroption = '(Filter: Only env. '. ucfirst(strtolower($player->data['RecordsEyepieceTracklistFilter']['env'])) .')';
		}
		else if ( isset($player->data['RecordsEyepieceTracklistFilter']['author']) ){
			// Filter for TrackAuthor
			foreach ($re_cache['Tracklist'] as &$track) {
				if ($track['author'] == $player->data['RecordsEyepieceTracklistFilter']['author']) {
					$tracklist[] = $track;
				}
			}
			$filteroption = '(Filter: Only Tracks by '. $player->data['RecordsEyepieceTracklistFilter']['author'] .')';
		}
		else if ( isset($player->data['RecordsEyepieceTracklistFilter']['cmd'])) {
			if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NORANK') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( !isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['rank']) ) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Not Ranked Tracks)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'ONLYRANK') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['rank']) ) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only Ranked Tracks)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NOAUTHOR') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]) ) {
						if ( ($aseco->server->gameinfo->mode == 4) && ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] <= $track['authortime_filter']) ) {
							$tracklist[] = $track;
						}
						else if ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] >= $track['authortime_filter']) {
							$tracklist[] = $track;
						}
					}
				}
				$filteroption = '(Filter: No Author Time)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NOGOLD') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]) ) {
						if ( ($aseco->server->gameinfo->mode == 4) && ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] <= $track['goldtime_filter']) ) {
							$tracklist[] = $track;
						}
						else if ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] >= $track['goldtime_filter']) {
							$tracklist[] = $track;
						}
					}
				}
				$filteroption = '(Filter: No Gold Time)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NOSILVER') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]) ) {
						if ( ($aseco->server->gameinfo->mode == 4) && ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] <= $track['silvertime_filter']) ) {
							$tracklist[] = $track;
						}
						else if ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] >= $track['silvertime_filter']) {
							$tracklist[] = $track;
						}
					}
				}
				$filteroption = '(Filter: No Silver Time)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NOBRONZE') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]) ) {
						if ( ($aseco->server->gameinfo->mode == 4) && ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] <= $track['bronzetime_filter']) ) {
							$tracklist[] = $track;
						}
						else if ($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['score'] >= $track['bronzetime_filter']) {
							$tracklist[] = $track;
						}
					}
				}
				$filteroption = '(Filter: No Bronze Time)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NORECENT') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( !in_array($track['uid'], $jb_buffer) ) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: No Recent)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'ONLYRECENT') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ( in_array($track['uid'], $jb_buffer) ) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only Recent)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'JUKEBOX') {
				foreach ($re_cache['Tracklist'] as &$track) {
					foreach ($jukebox as &$item) {
						// Find the Tracks from the Jukebox
						if ($item['uid'] == $track['uid']) {
							$tracklist[] = $track;
							break;
						}
					}
				}
				$filteroption = '(Filter: Only Jukebox)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'ONLYMULTILAP') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['multilap'] == true) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only Multilap)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['cmd'] == 'NOMULTILAP') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['multilap'] != true) {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: No Multilap)';
			}
		}
		else if ( isset($player->data['RecordsEyepieceTracklistFilter']['mood'])) {
			if ($player->data['RecordsEyepieceTracklistFilter']['mood'] == 'SUNSET') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['mood'] == 'Sunset') {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only mood Sunset)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['mood'] == 'DAY') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['mood'] == 'Day') {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only mood Day)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['mood'] == 'SUNRISE') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['mood'] == 'Sunrise') {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only mood Sunrise)';
			}
			else if ($player->data['RecordsEyepieceTracklistFilter']['mood'] == 'NIGHT') {
				foreach ($re_cache['Tracklist'] as &$track) {
					if ($track['mood'] == 'Night') {
						$tracklist[] = $track;
					}
				}
				$filteroption = '(Filter: Only mood Night)';
			}
		}
	}
	else {
		// No Filter, show all Tracks
		$tracklist = $re_cache['Tracklist'];
	}


	// Get the total of songs
	$totaltracks = ((count($tracklist) < 5000) ? count($tracklist) : 5000);

	// Determind the maxpages
	$maxpages = round($totaltracks / 20);

	// Determine admin ability to drop all jukeboxed and to add recent played tracks
	$dropall = $aseco->allowAbility($player, 'dropjukebox');
	$add_recent = $aseco->allowAbility($player, 'chat_jb_recent');


	// Frame for Filteroptions/Previous/Next Buttons
	$buttons = '<frame posn="52.2 -53.2 0">';

	// Filteroptions Button
	$buttons .= '<frame posn="-3.3 0 0">';
	$buttons .= '<quad posn="0 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] .'21" style="Icons64x64_1" substyle="ToolTree"/>';
	$buttons .= '</frame>';

	// Button "Drop current juke´d tracks"
	if ($aseco->allowAbility($player, 'clearjukebox')) {
		$buttons .= '<frame posn="0 0 0">';
		$buttons .= '<quad posn="0 0 0.12" sizen="3.2 3.2" action="20" style="Icons64x64_1" substyle="ArrowDown"/>';
		$buttons .= '<quad posn="0.85 -1.1 0.13" sizen="1.5 1.4" bgcolor="EEEF"/>';
		$buttons .= '<quad posn="0.25 -0.2 0.14" sizen="2.9 2.9" style="Icons128x128_1" substyle="LoadTrack"/>';
		$buttons .= '<label posn="0.8 -0.76 0.16" sizen="6 6" textsize="2" scale="0.8" text="$S$O$F00X"/>';
		$buttons .= '</frame>';
	}

	// Previous button
	if ($page > 0) {
		// First
		$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] .'1000" style="Icons64x64_1" substyle="ArrowFirst"/>';

		// Previous (-5)
		$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ((($page + 994) < 1000) ? 1000 : ($page + 994)) .'" style="Icons64x64_1" substyle="ArrowFastPrev"/>';

		// Previous (-1)
		$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ($page + 999) .'" style="Icons64x64_1" substyle="ArrowPrev"/>';
	}
	else {
		// First
		$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="6.6 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Previous (-5)
		$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="9.9 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Previous (-1)
		$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="13.2 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}

	// Next button (display only if more pages to display)
	if ( ($page < 250) && ($totaltracks > 20) && (($page + 1) < (ceil($totaltracks / 20))) ) {
		// Next (+1)
		$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($page + 1001) .'" style="Icons64x64_1" substyle="ArrowNext"/>';

		// Next (+5)
		$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ((($page + 1006) > ($maxpages + 999)) ? ($maxpages + 999) : ($page + 1006)) .'" style="Icons64x64_1" substyle="ArrowFastNext"/>';

		// Last
		$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($maxpages + 999) .'" style="Icons64x64_1" substyle="ArrowLast"/>';
	}
	else {
		// Next (+1)
		$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="16.5 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Next (+5)
		$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="19.8 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Last
		$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="23.1 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}
	$buttons .= '</frame>';

	// Create Windowtitle depending on the $tracklist
	if (count($tracklist) == 0) {
		$title = 'Tracks on this Server';
	}
	else {
		$title = 'Tracks on this Server   -   viewing Track '. (($page * 20) + 1) .' - '. (((($page * 20) + 20) > $totaltracks) ? $totaltracks : (($page * 20) + 20)) .' from '. $totaltracks . (($totaltracks == 1) ? ' Tracks' : ' Tracks') .' total '. $filteroption;
	}

	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'Icons128x128_1',
			'NewTrack',
			$title,
			$buttons
		),
		$re_config['Templates']['WINDOW']->header
	);


	$line = 0;
	$offset = 0;

	$xml .= '<frame posn="2.5 -5.7 1">';
	if (count($tracklist) == 0) {
		$xml .= '<label posn="0 0 0.10" sizen="72.4 0" autonewline="1" textsize="1" textcolor="FF0F" text="This filter return an empty result, which means that no Track match your wished filter."/>';
	}
	else {
		for ($i = ($page * 20); $i < (($page * 20) + 20); $i ++) {

			// Is there a Track?
			if ( !isset($tracklist[$i]) ) {
				break;
			}

			// Get Track
			$track = &$tracklist[$i];


			// Find the Player who has juked this track
			$login = false;
			$juked = 0;
			$tid = 1;
			foreach ($jukebox as &$item) {
				if ($item['uid'] == $track['uid']) {
					$login = $item['Login'];
					$juked = $tid;
					break;
				}
				$tid++;
			}


			$xml .= '<frame posn="'. $offset .' -'. (9.45 * $line) .' 1">';

			// 'Alpine' same as 'Snow'; 'Speed' same as 'Desert'
			switch (strtoupper($track['env'])) {
				case 'STADIUM':
					$xml .= '<quad posn="0.7 -0.35 0.06" sizen="3 1.96" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_STADIUM'][0] .'"/>';
					break;
				case 'BAY':
					$xml .= '<quad posn="1.35 0.1 0.06" sizen="1.60 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_BAY'][0] .'"/>';
					break;
				case 'COAST':
					$xml .= '<quad posn="1.45 0.1 0.06" sizen="1.58 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_COAST'][0] .'"/>';
					break;
				case 'DESERT':
					$xml .= '<quad posn="1.35 0.1 0.06" sizen="1.67 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_DESERT'][0] .'"/>';
					break;
				case 'ISLAND':
					$xml .= '<quad posn="1.05 0.1 0.06" sizen="2.19 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_ISLAND'][0] .'"/>';
					break;
				case 'RALLY':
					$xml .= '<quad posn="1.35 0.1 0.06" sizen="1.75 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_RALLY'][0] .'"/>';
					break;
				case 'ALPINE':
					$xml .= '<quad posn="1.25 0.1 0.06" sizen="1.92 2.7" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_SNOW'][0] .'"/>';
					break;
				default:
					// do nothing
			}

			if ( (!in_array($track['uid'], $jb_buffer)) && ($juked == 0) ) {
				$xml .= '<format textsize="1" textcolor="FFFF"/>';
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] . ($track['id']+2000) .'" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_PLUS_FOCUS'][0] .'"/>';
				$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
				$xml .= '<label posn="3.8 -0.55 0.05" sizen="17.3 0" textsize="1" text="Track #'. ($i+1) .'"/>';
				$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="1" text="'. $track['name'] .'"/>';
				$xml .= '<label posn="1 -4.5 0.04" sizen="17.3 2" scale="0.9" text="by '. $track['author'] .'"/>';
			}
			else if ( (in_array($track['uid'], $jb_buffer)) && ($juked > 0) ) {
				$xml .= '<format textsize="1" textcolor="FFF8"/>';
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				if ( ($dropall) || ($login == $player->login) ) {
					$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. (-2000-$juked) .'" image="'. $re_config['IMAGES'][0]['WIDGET_MINUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_MINUS_FOCUS'][0] .'"/>';
				}
				$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="Bgs1InRace" substyle="BgListLine"/>';
				$xml .= '<label posn="3.8 -0.55 0.05" sizen="17.3 0" textcolor="000F" textsize="1" text="Track #'. ($i+1) .'"/>';
				$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="1" text="'. stripColors($track['name'], true) .'"/>';
				$xml .= '<label posn="1 -4.5 0.04" sizen="17.3 2" scale="0.9" text="by '. stripColors($track['author'], true) .'"/>';
			}
			else if (in_array($track['uid'], $jb_buffer)) {
				$xml .= '<format textsize="1" textcolor="FFF8"/>';
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				if ($add_recent) {
					$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] . ($track['id']+2000) .'" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_PLUS_FOCUS'][0] .'"/>';
				}
				$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				$xml .= '<label posn="3.8 -0.55 0.05" sizen="17.3 0" textsize="1" text="Track #'. ($i+1) .'"/>';
				$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="1" text="'. stripColors($track['name'], true) .'"/>';
				$xml .= '<label posn="1 -4.5 0.04" sizen="17.3 2" scale="0.9" text="by '. stripColors($track['author'], true) .'"/>';
			}
			else {
				$xml .= '<format textsize="1" textcolor="FFFF"/>';
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				if ( ($dropall) || ($login == $player->login) ) {
					$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. (-2000-$juked) .'" image="'. $re_config['IMAGES'][0]['WIDGET_MINUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_MINUS_FOCUS'][0] .'"/>';
				}
				$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="Bgs1InRace" substyle="BgListLine"/>';
				$xml .= '<label posn="3.8 -0.55 0.05" sizen="17.3 0" textcolor="000F" textsize="1" text="Track #'. ($i+1) .'"/>';
				$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="1" text="'. $track['name'] .'"/>';
				$xml .= '<label posn="1 -4.5 0.04" sizen="17.3 2" scale="0.9" text="by '. $track['author'] .'"/>';
			}

			// Authortime
			$xml .= '<quad posn="0.7 -6.8 0.04" sizen="1.7 1.7" style="BgRaceScore2" substyle="ScoreReplay"/>';
			$xml .= '<label posn="2.7 -7.15 0.04" sizen="6 2" scale="0.75" text="'. $track['authortime'] .'"/>';

			// Player Rank
			$pos = isset($player->data['RecordsEyepieceTracksRecords'][$track['uid']]['rank']) ? $player->data['RecordsEyepieceTracksRecords'][$track['uid']]['rank'] : 0;
			$xml .= '<quad posn="6.8 -6.8 0.04" sizen="2 2" style="Icons128x128_1" substyle="Rankings"/>';
			$xml .= '<label posn="9 -7.15 0.04" sizen="6 2" scale="0.75" text="'. (($pos >= 1 && $pos <= $maxrecs) ? sprintf("%0". strlen($maxrecs) ."d", $pos) : 'No Rec') .'."/>';

			$xml .= '</frame>';


			$line ++;

			// Reset lines
			if ($line >= 5) {
				$offset += 19.05;
				$line = 0;
			}
		}
	}
	$xml .= '</frame>';

	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTracklistFilterWindow () {
	global $aseco, $re_config, $re_cache;


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'Icons128x128_1',
			'NewTrack',
			'Filteroptions for Tracklist',
			''
		),
		$re_config['Templates']['WINDOW']->header
	);

	$xml .= '<frame posn="2.5 -5.7 1">'; // Content Window

	// All Tracks
	$xml .= '<frame posn="0 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'39" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="All Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display all Tracks, that are currently available on this Server."/>';
	$xml .= '</frame>';

	// Current Jukebox
	$xml .= '<frame posn="19.05 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'40" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Current Jukebox"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks, that are in the jukebox to get played."/>';
	$xml .= '</frame>';

	// Select Trackauthor
	$xml .= '<frame posn="38.1 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'56" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Select Trackauthor"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Select a Trackauthor and display only Tracks from this author."/>';
	$xml .= '</frame>';

	// Only Recent Tracks
	$xml .= '<frame posn="0 -9.45 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'42" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Only Recent Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks that have been played recently."/>';
	$xml .= '</frame>';

	// No Recent Tracks
	$xml .= '<frame posn="0 -18.9 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'41" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Recent Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks that have been played not recently."/>';
	$xml .= '</frame>';

	// Only Ranked Tracks
	$xml .= '<frame posn="19.05 -9.45 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'44" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Only Ranked Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you already have a rank received."/>';
	$xml .= '</frame>';

	// Not Ranked Tracks
	$xml .= '<frame posn="19.05 -18.9 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'43" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Not Ranked Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you not already have a rank received."/>';
	$xml .= '</frame>';

	// Only Multilap Tracks
	$xml .= '<frame posn="38.1 -9.45 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'51" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Only Multilap Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks that have been played recently."/>';
	$xml .= '</frame>';

	// No Multilap Tracks
	$xml .= '<frame posn="38.1 -18.9 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'52" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Multilap Tracks"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks that have been played not recently."/>';
	$xml .= '</frame>';

	// No Author Time
	$xml .= '<frame posn="57.15 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'46" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Author '. (($aseco->server->gameinfo->mode == 4) ? 'Score' : 'Time') .'"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you did not beat the author '. (($aseco->server->gameinfo->mode == 4) ? 'score' : 'time') .' on."/>';
	$xml .= '</frame>';

	// No Gold Time
	$xml .= '<frame posn="57.15 -9.45 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'45" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Gold '. (($aseco->server->gameinfo->mode == 4) ? 'Score' : 'Time') .'"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you did not beat the gold '. (($aseco->server->gameinfo->mode == 4) ? 'score' : 'time') .' on."/>';
	$xml .= '</frame>';

	// No Silver Time
	$xml .= '<frame posn="57.15 -18.9 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'53" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Silver '. (($aseco->server->gameinfo->mode == 4) ? 'Score' : 'Time') .'"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you did not beat the silver '. (($aseco->server->gameinfo->mode == 4) ? 'score' : 'time') .' on."/>';
	$xml .= '</frame>';

	// No Bronze Time
	$xml .= '<frame posn="57.15 -28.35 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'54" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="No Bronze '. (($aseco->server->gameinfo->mode == 4) ? 'Score' : 'Time') .'"/>';
	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Display only Tracks where you did not beat the bronze '. (($aseco->server->gameinfo->mode == 4) ? 'score' : 'time') .' on."/>';
	$xml .= '</frame>';

	// EMPTY
	$xml .= '<frame posn="57.15 -37.8 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
//	$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'55" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
//	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
//	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="Select Trackauthor"/>';
//	$xml .= '<label posn="1 -2.7 0.04" sizen="16 2" scale="0.9" autonewline="1" text="Select a Trackauthor and display only Tracks from this author."/>';
	$xml .= '</frame>';



	// Mood
	$xml .= '<frame posn="0 -28.35 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="55.85 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="55.05 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="55.05 0" textsize="1" text="Track mood"/>';

	// Sunrise
	if ($re_cache['TracklistCounts']['Mood']['SUNRISE'] > 0) {
		$xml .= '<quad posn="1.6 -3 0.06" sizen="10.88 5.44" action="'. $re_config['ManialinkId'] .'47" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['SUNRISE'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<label posn="12 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Sunrise"/>';
	}
	else {
		$xml .= '<quad posn="1.6 -3 0.06" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['SUNRISE'][0] .'"/>';
		$xml .= '<label posn="12 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Sunrise"/>';
	}

	// Day
	if ($re_cache['TracklistCounts']['Mood']['DAY'] > 0) {
		$xml .= '<quad posn="15.5 -3 0.06" sizen="10.88 5.44" action="'. $re_config['ManialinkId'] .'48" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['DAY'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['DAY'][0] .'"/>';
		$xml .= '<label posn="25.9 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Day"/>';
	}
	else {
		$xml .= '<quad posn="15.5 -3 0.06" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['DAY'][0] .'"/>';
		$xml .= '<label posn="25.9 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Day"/>';
	}

	// Sunset
	if ($re_cache['TracklistCounts']['Mood']['SUNSET'] > 0) {
		$xml .= '<quad posn="29.4 -3 0.06" sizen="10.88 5.44" action="'. $re_config['ManialinkId'] .'49" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['SUNSET'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['SUNSET'][0] .'"/>';
		$xml .= '<label posn="39.8 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Sunset"/>';
	}
	else {
		$xml .= '<quad posn="29.4 -3 0.06" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['SUNSET'][0] .'"/>';
		$xml .= '<label posn="39.8 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Sunset"/>';
	}

	// Night
	if ($re_cache['TracklistCounts']['Mood']['NIGHT'] > 0) {
		$xml .= '<quad posn="43.3 -3 0.06" sizen="10.88 5.44" action="'. $re_config['ManialinkId'] .'50" image="'. $re_config['IMAGES'][0]['MOOD'][0]['ENABLED'][0]['NIGHT'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['MOOD'][0]['FOCUS'][0]['NIGHT'][0] .'"/>';
		$xml .= '<label posn="53.7 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Night"/>';
	}
	else {
		$xml .= '<quad posn="43.3 -3 0.06" sizen="10.88 5.44" image="'. $re_config['IMAGES'][0]['MOOD'][0]['DISABLED'][0]['NIGHT'][0] .'"/>';
		$xml .= '<label posn="53.7 -7 0.07" halign="right" sizen="10 2" scale="0.8" text="Night"/>';
	}
	$xml .= '</frame>';



	// Track environment
	$xml .= '<frame posn="0 -37.8 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="55.85 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="55.05 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="Icons128x128_1" substyle="Browse"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="55.05 0" textsize="1" text="Track environment"/>';

	// 'Stadium'
	if ($re_cache['TracklistCounts']['Environment']['STADIUM'] > 0) {
		$xml .= '<quad posn="1.6 -3.43 0.06" sizen="5.4 3.53" action="'. $re_config['ManialinkId'] .'22" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_STADIUM'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_STADIUM'][0] .'"/>';
		$xml .= '<label posn="2.4 -7.63 0.07" sizen="10 2" scale="0.8" text="Stadium"/>';
	}
	else {
		$xml .= '<quad posn="1.6 -3.43 0.06" sizen="5.4 3.53" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_STADIUM'][0] .'"/>';
		$xml .= '<label posn="2.4 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Stadium"/>';
	}

	// 'Bay'
	if ($re_cache['TracklistCounts']['Environment']['BAY'] > 0) {
		$xml .= '<quad posn="11.2 -2.53 0.06" sizen="2.88 4.86" action="'. $re_config['ManialinkId'] .'23" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_BAY'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_BAY'][0] .'"/>';
		$xml .= '<label posn="11.9 -7.63 0.07" sizen="10 2" scale="0.8" text="Bay"/>';
	}
	else {
		$xml .= '<quad posn="11.2 -2.53 0.06" sizen="2.88 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_BAY'][0] .'"/>';
		$xml .= '<label posn="11.9 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Bay"/>';
	}

	// 'Coast'
	if ($re_cache['TracklistCounts']['Environment']['COAST'] > 0) {
		$xml .= '<quad posn="18.9 -2.53 0.06" sizen="2.84 4.86" action="'. $re_config['ManialinkId'] .'24" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_COAST'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_COAST'][0] .'"/>';
		$xml .= '<label posn="18.9 -7.63 0.07" sizen="10 2" scale="0.8" text="Coast"/>';
	}
	else {
		$xml .= '<quad posn="18.9 -2.53 0.06" sizen="2.84 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_COAST'][0] .'"/>';
		$xml .= '<label posn="18.9 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Coast"/>';
	}

	// 'Speed' same as 'Desert'
	if ($re_cache['TracklistCounts']['Environment']['DESERT'] > 0) {
		$xml .= '<quad posn="26.6 -2.53 0.06" sizen="3 4.86" action="'. $re_config['ManialinkId'] .'25" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_DESERT'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_DESERT'][0] .'"/>';
		$xml .= '<label posn="26.7 -7.63 0.07" sizen="10 2" scale="0.8" text="Desert"/>';
	}
	else {
		$xml .= '<quad posn="26.6 -2.53 0.06" sizen="3 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_DESERT'][0] .'"/>';
		$xml .= '<label posn="26.7 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Desert"/>';
	}

	// 'Island'
	if ($re_cache['TracklistCounts']['Environment']['ISLAND'] > 0) {
		$xml .= '<quad posn="34.3 -2.53 0.06" sizen="3.94 4.86" action="'. $re_config['ManialinkId'] .'26" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_ISLAND'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_ISLAND'][0] .'"/>';
		$xml .= '<label posn="35.1 -7.63 0.07" sizen="10 2" scale="0.8" text="Island"/>';
	}
	else {
		$xml .= '<quad posn="34.3 -2.53 0.06" sizen="3.94 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_ISLAND'][0] .'"/>';
		$xml .= '<label posn="35.1 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Island"/>';
	}

	// 'Rally'
	if ($re_cache['TracklistCounts']['Environment']['RALLY'] > 0) {
		$xml .= '<quad posn="42.3 -2.53 0.06" sizen="3.15 4.86" action="'. $re_config['ManialinkId'] .'27" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_RALLY'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_RALLY'][0] .'"/>';
		$xml .= '<label posn="43.1 -7.63 0.07" sizen="10 2" scale="0.8" text="Rally"/>';
	}
	else {
		$xml .= '<quad posn="42.3 -2.53 0.06" sizen="3.15 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_RALLY'][0] .'"/>';
		$xml .= '<label posn="43.1 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Rally"/>';
	}

	// 'Alpine' same as 'Snow'
	if ($re_cache['TracklistCounts']['Environment']['ALPINE'] > 0) {
		$xml .= '<quad posn="50.4 -2.53 0.06" sizen="3.46 4.86" action="'. $re_config['ManialinkId'] .'28" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['ENABLED'][0]['ICON_SNOW'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['FOCUS'][0]['ICON_SNOW'][0] .'"/>';
		$xml .= '<label posn="51 -7.63 0.07" sizen="10 2" scale="0.8" text="Snow"/>';
	}
	else {
		$xml .= '<quad posn="50.4 -2.53 0.06" sizen="3.46 4.86" image="'. $re_config['IMAGES'][0]['ENVIRONMENT'][0]['DISABLED'][0]['ICON_SNOW'][0] .'"/>';
		$xml .= '<label posn="51 -7.63 0.07" sizen="10 2" scale="0.8" textcolor="FFF8" text="Snow"/>';
	}
	$xml .= '</frame>';


	$xml .= '</frame>'; // Content Window

	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTrackauthorlistWindow ($page, $player) {
	global $re_config, $re_cache;


	// Get the total of authors
	$totalauthors = ((count($re_cache['TrackAuthors']) < 5000) ? count($re_cache['TrackAuthors']) : 5000);

	// Determind the maxpages
	$maxpages = round($totalauthors / 80);


	// Frame for Previous/Next Buttons
	$buttons = '<frame posn="52.2 -53.2 0">';

	// Previous button
	if ($page > 0) {
		// First
		$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] .'7000" style="Icons64x64_1" substyle="ArrowFirst"/>';

		// Previous (-5)
		$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ((($page + 6995) < 7000) ? 7000 : ($page + 6995)) .'" style="Icons64x64_1" substyle="ArrowFastPrev"/>';

		// Previous (-1)
		$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ($page + 6999) .'" style="Icons64x64_1" substyle="ArrowPrev"/>';
	}
	else {
		// First
		$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="6.6 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Previous (-5)
		$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="9.9 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Previous (-1)
		$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="13.2 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}

	// Next button (display only if more pages to display)
	if ( ($page < 250) && ($totalauthors > 80) && (($page + 1) < (ceil($totalauthors / 80))) ) {
		// Next (+1)
		$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($page + 7001) .'" style="Icons64x64_1" substyle="ArrowNext"/>';

		// Next (+5)
		$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ((($page + 7006) > ($maxpages + 6999)) ? ($maxpages + 6999) : ($page + 7006)) .'" style="Icons64x64_1" substyle="ArrowFastNext"/>';

		// Last
		$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($maxpages + 6999) .'" style="Icons64x64_1" substyle="ArrowLast"/>';
	}
	else {
		// Next (+1)
		$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="16.5 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Next (+5)
		$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="19.8 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

		// Last
		$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="23.1 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}
	$buttons .= '</frame>';


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'Icons128x128_1',
			'NewTrack',
			'Select Trackauthor for filtering the Tracklist',
			$buttons
		),
		$re_config['Templates']['WINDOW']->header
	);


	$line_height = 2.2;
	$line = 0;
	$array_count = ($page * 80);
	$offset = 0;
	$xml .= '<frame posn="2 -6 0">';
	for ($i = ($page * 80); $i < (($page * 80) + 80); $i ++) {

		// Is there a Author?
		if ( !isset($re_cache['TrackAuthors'][$i]) ) {
			break;
		}

		$xml .= '<quad posn="'. (0 + $offset) .' -'. ($line_height * $line + 1) .' 0.10" sizen="17 2.2" action="-'. $re_config['ManialinkId'] . (8000 + $array_count) .'" style="Bgs1InRace" substyle="BgIconBorder"/>';
		$xml .= '<label posn="'. (1 + $offset) .' -'. ($line_height * $line + 1.3) .' 0.11" sizen="16.5 0" halign="left" textsize="1" scale="0.9" textcolor="05CF" text="'. $re_cache['TrackAuthors'][$i] .'"/>';

		// Count Array-Position for action id
		$array_count ++;

		$line ++;

		// Reset lines
		if ($line >= 20) {
			$offset += 19.5;
			$line = 0;
		}
	}
	$xml .= '</frame>';

	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;

}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTopNationsWindow () {
	global $aseco, $re_config, $re_scores;


	if ( count($re_scores['TopNations']) > 0) {
		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_STYLE'][0],
				$re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_SUBSTYLE'][0],
				utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['TITLE'][0]),
				''
			),
			$re_config['Templates']['WINDOW']->header
		);

		$entry = 1;
		$line = 0;
		$offset = 0;

		$xml .= '<quad posn="21 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="40.5 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';
		$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

		$xml .= '<frame posn="2.5 -5.7 1">';
		$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
		foreach ($re_scores['TopNations'] as &$item) {
			$xml .= '<label posn="'. (2.75 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="3.3 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
			$xml .= '<quad posn="'. (3.5 + $offset) .' '. (($line == 0) ? 0.3 : -(1.9 * $line - 0.3)) .' 0.02" sizen="2 2" image="tmtp://Skins/Avatars/Flags/'. (($item['nation'] == 'OTH') ? 'other' : $item['nation']) .'.dds"/>';
			$xml .= '<label posn="'. (6.2 + $offset) .' -'. (1.9 * $line) .' 0.02" sizen="11.6 1.7" scale="0.9" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $re_config['IocNations'][$item['nation']] .'"/>';

			$line ++;
			$entry ++;

			// Reset lines
			if ($line >= 25) {
				$offset += 19.5;
				$line = 0;
			}

			// Display max. 100 entries, count start from 1
			if ($entry >= 101) {
				break;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
	}
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildTMXChallengeInfoWindow () {
	global $aseco, $re_config;


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'Icons128x128_1',
			'LoadTrack',
			utf8_encode('TMX Track Info'),
			''
		),
		$re_config['Templates']['WINDOW']->header
	);


	$xml .= '<quad posn="2.5 -5.7 0.03" sizen="32.2 24.2" bgcolor="FFF9"/>';
	$xml .= '<label posn="7.5 -16.5 0.04" sizen="25 2" textsize="1" text="Press DEL if can not see an Image here!"/>';
	$xml .= '<quad posn="2.6 -5.8 1" sizen="32 24" image="'. htmlspecialchars($aseco->server->challenge->tmx->imageurl .'&.jpg') .'"/>';
	$xml .= '<label posn="2.9 -31 0.02" sizen="32 3" textsize="3" text="$S'. $re_config['Challenge']['Current']['name'] .'"/>';
	$xml .= '<label posn="2.9 -33.8 0.02" sizen="32 3" textsize="2" scale="0.9" text="by '. $re_config['Challenge']['Current']['author'] .'"/>';

	$upload = $aseco->server->challenge->tmx->uploaded;
	if ($aseco->server->challenge->tmx->uploaded != $aseco->server->challenge->tmx->updated) {
		$upload = $aseco->server->challenge->tmx->updated;
	}
	$xml .= '<label posn="2.9 -36.4 0.02" sizen="32 3" textsize="1" scale="0.8" text="from '. $upload .'"/>';

	// Author comment
	if ($aseco->server->challenge->tmx->acomment != '') {
		$acomment = $aseco->server->challenge->tmx->acomment;

		// Replace <br> with LF
		$acomment = str_ireplace('<br>' , LF, $acomment);
		$acomment = str_ireplace('<br />' , LF, $acomment);

		// Remove BB Code
		$acomment = preg_replace('/\[.*?\]/i', '', $acomment);
		$acomment = preg_replace('/\[\/.*?\]/i', '', $acomment);

		// Remove (simple) HTML Code
		$acomment = preg_replace('/\<.*?\>/i', '', $acomment);
		$acomment = preg_replace('/\<\/.*?\>/i', '', $acomment);

		$xml .= '<label posn="2.9 -39 0.04" sizen="55 24" textsize="1" autonewline="1" maxline="7" text="'. htmlspecialchars($acomment) .'"/>';
	}

	// Times
	$xml .= '<frame posn="38.6 -23.5 0">';
	$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$xml .= '<quad posn="0.1 7.2 0.1" sizen="2.2 2.2" halign="right" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$xml .= '<quad posn="0 4.8 0.1" sizen="2 2" halign="right" style="MedalsBig" substyle="MedalGold"/>';
	$xml .= '<quad posn="0 2.5 0.1" sizen="2 2" halign="right" style="MedalsBig" substyle="MedalSilver"/>';
	$xml .= '<quad posn="0 0.2 0.1" sizen="2 2" halign="right" style="MedalsBig" substyle="MedalBronze"/>';
	$xml .= '<quad posn="0.2 -1.8 0.1" sizen="2.6 2.6" halign="right" style="Icons128x128_1" substyle="Advanced"/>';
	$xml .= '<quad posn="0.2 -4.1 0.1" sizen="2.6 2.6" halign="right" style="Icons128x128_1" substyle="Manialink"/>';

	$xml .= '<label posn="0.5 6.9 0.1" sizen="8 2" text="'. $re_config['Challenge']['Current']['authortime'] .'"/>';
	$xml .= '<label posn="0.5 4.6 0.1" sizen="8 2" text="'. $re_config['Challenge']['Current']['goldtime'] .'"/>';
	$xml .= '<label posn="0.5 2.3 0.1" sizen="8 2" text="'. $re_config['Challenge']['Current']['silvertime'] .'"/>';
	$xml .= '<label posn="0.5 0 0.1" sizen="8 2" text="'. $re_config['Challenge']['Current']['bronzetime'] .'"/>';
	$xml .= '<label posn="0.5 -2.3 0.1" sizen="8 2" text="'. $re_config['Challenge']['Next']['env'] .'"/>';
	$xml .= '<label posn="0.5 -4.6 0.1" sizen="8 2" text="'. $re_config['Challenge']['Next']['mood'] .'"/>';
	$xml .= '</frame>';

	// TMX Trackinfos
	$xml .= '<frame posn="46 -23.5 0">';
	$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$xml .= '<label posn="0 6.9 0.1" sizen="5 2.2" text="Type:"/>';
	$xml .= '<label posn="0 4.6 0.1" sizen="5 2" text="Style:"/>';
	$xml .= '<label posn="0 2.3 0.1" sizen="5 2" text="Difficult:"/>';
	$xml .= '<label posn="0 0 0.1" sizen="5 2" text="Routes:"/>';
	$xml .= '<label posn="0 -2.3 0.1" sizen="5 2.6" text="Awards:"/>';
	$xml .= '<label posn="0 -4.6 0.1" sizen="5 2.6" text="Section:"/>';

	$xml .= '<label posn="5.1 6.9 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->type .'"/>';
	$xml .= '<label posn="5.1 4.6 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->style .'"/>';
	$xml .= '<label posn="5.1 2.3 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->diffic .'"/>';
	$xml .= '<label posn="5.1 0 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->routes .'"/>';
	$xml .= '<label posn="5.1 -2.3 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->awards .'"/>';
	$xml .= '<label posn="5.1 -4.6 0.1" sizen="14.5 2" text=" '. $aseco->server->challenge->tmx->section .'"/>';
	$xml .= '</frame>';

	// Spacer
	$xml .= '<quad posn="60 -5.7 0.02" sizen="0.1 47" bgcolor="FFF5"/>';

	$xml .= '<frame posn="61 -5.7 1">';
	$xml .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$xml .= '<label posn="0.5 0 0.03" sizen="16.25 1.7" scale="0.9" text="TMX Top10 Records"/>';
	$xml .= '<quad posn="-0.05 -1.45 0.02" sizen="16.95 0.1" bgcolor="FFF5"/>';
	if (count($aseco->server->challenge->tmx->recordlist) > 0) {

		$entry = 1;
		$line = 1;
		foreach ($aseco->server->challenge->tmx->recordlist as &$item) {
			$xml .= '<label posn="2.1 -'. (1.9 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $entry .'."/>';
			$xml .= '<label posn="6.1 -'. (1.9 * $line) .' 0.02" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. formatTime($item['time']) . (($upload != $item['trackat']) ? ' $F00$W!' : '') .'"/>';
			$xml .= '<label posn="6.6 -'. (1.9 * $line) .' 0.02" sizen="9.6 1.7" scale="0.9" text="'. $item['name'] .'"/>';

			$line ++;
			$entry ++;

			// Display max. 10 entries (thats the max. from TMX), count start from 1
			if ($entry >= 11) {
				break;
			}
		}
	}
	else {
		$xml .= '<label posn="0.5 -1.9 0.02" sizen="16.25 1.7" textsize="1" scale="0.9" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['SCORES'][0] .'" text="No records found"/>';
	}
	$xml .= '</frame>';


	// TMX-Logo and Links
	$xml .= '<frame posn="36.2 -5.7 1">';
	$xml .= '<format textsize="1" style="TextCardScores2"/>';
	$xml .= '<quad posn="0 0 0.3" sizen="11 5.5" image="'. $re_config['IMAGES'][0]['TMX_LOGO_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['TMX_LOGO_FOCUS'][0] .'" url="http://www.tm-exchange.com/"/>';

	// Page
	$xml .= '<label posn="12 -0.3 0.04" sizen="24 2" scale="0.5" text="$FFF» Visit Track Page" url="'. htmlspecialchars($aseco->server->challenge->tmx->pageurl) .'"/>';

	// Track
	$xml .= '<label posn="12 -2.2 0.04" sizen="24 2" scale="0.5" text="$FFF» Download Track" url="'. htmlspecialchars($aseco->server->challenge->tmx->dloadurl) .'"/>';

	// Replay
	if ($aseco->server->challenge->tmx->replayurl) {
		$xml .= '<label posn="12 -4.1 0.04" sizen="24 2" scale="0.5" text="$FFF» Download Replay" url="'. htmlspecialchars($aseco->server->challenge->tmx->replayurl) .'"/>';
	}
	$xml .= '</frame>';


	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

// $music_server is imported from plugin.musicserver.php
function re_buildMusiclistWindow ($page) {
	global $re_config, $re_cache, $music_server;


	// Get the total of songs
	$totalsongs = ((count($re_cache['MusicServerPlaylist']) < 1900) ? count($re_cache['MusicServerPlaylist']) : 1900);

	if ($totalsongs > 0) {

		// Frame for Previous/Next Buttons
		$buttons = '<frame posn="52.2 -53.2 0">';

		// Button "Drop current juke´d song"
		$buttons .= '<frame posn="0 0 0">';
		$buttons .= '<quad posn="0 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] .'19" style="Icons64x64_1" substyle="ArrowDown"/>';
		$buttons .= '<quad posn="0.85 -1.1 0.13" sizen="1.5 1.4" bgcolor="EEEF"/>';
		$buttons .= '<quad posn="0.25 -0.2 0.14" sizen="2.9 2.9" style="Icons64x64_1" substyle="Music"/>';
		$buttons .= '<label posn="0.8 -0.76 0.16" sizen="6 6" textsize="2" scale="0.8" text="$S$O$F00X"/>';
		$buttons .= '</frame>';

		// Determind the maxpages
		$maxpages = round($totalsongs / 20);

		// Previous button
		if ($page > 0) {
			// First
			$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] .'200" style="Icons64x64_1" substyle="ArrowFirst"/>';

			// Previous (-5)
			$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ((($page + 195) < 200) ? 200 : ($page + 195)) .'" style="Icons64x64_1" substyle="ArrowFastPrev"/>';

			// Previous (-1)
			$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] . ($page + 199) .'" style="Icons64x64_1" substyle="ArrowPrev"/>';
		}
		else {
			// First
			$buttons .= '<quad posn="6.6 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="6.6 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

			// Previous (-5)
			$buttons .= '<quad posn="9.9 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="9.9 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

			// Previous (-1)
			$buttons .= '<quad posn="13.2 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="13.2 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}

		// Next button (display only if more pages to display)
		if ( ($page < 95) && ($totalsongs > 20) && (($page + 1) < (ceil($totalsongs / 20))) ) {
			// Next (+1)
			$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($page + 201) .'" style="Icons64x64_1" substyle="ArrowNext"/>';

			// Next (+5)
			$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ((($page + 206) > ($maxpages + 199)) ? ($maxpages + 199) : ($page + 206)) .'" style="Icons64x64_1" substyle="ArrowFastNext"/>';

			// Last
			$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] . ($maxpages + 199) .'" style="Icons64x64_1" substyle="ArrowLast"/>';
		}
		else {
			// Next (+1)
			$buttons .= '<quad posn="16.5 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="16.5 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

			// Next (+5)
			$buttons .= '<quad posn="19.8 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="19.8 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';

			// Last
			$buttons .= '<quad posn="23.1 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
			$buttons .= '<quad posn="23.1 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		}
		$buttons .= '</frame>';


		$xml = str_replace(
			array(
				'%icon_style%',
				'%icon_substyle%',
				'%window_title%',
				'%prev_next_buttons%'
			),
			array(
				$re_config['MUSIC_WIDGET'][0]['ICON_STYLE'][0],
				$re_config['MUSIC_WIDGET'][0]['ICON_SUBSTYLE'][0],
				'Choose the next Song   -   viewing Song '. (($page * 20) + 1) .' - '. (((($page * 20) + 20) > $totalsongs) ? $totalsongs : (($page * 20) + 20)) .' from '. $totalsongs . (($totalsongs == 1) ? ' Song' : ' Songs') .' total',
				$buttons
			),
			$re_config['Templates']['WINDOW']->header
		);

		$line = 0;
		$offset = 0;

		$xml .= '<frame posn="2.5 -5.7 1">';
		for ($i = ($page * 20); $i < (($page * 20) + 20); $i ++) {

			// Is there a song?
			if ( !isset($re_cache['MusicServerPlaylist'][$i]) ) {
				break;
			}

			// Get filename of Song
			$song = &$re_cache['MusicServerPlaylist'][$i];

			// Is this song already juke´d?
			$juked = false;
			foreach ($music_server->jukebox as $login => &$songid) {
				if ($song['SongId'] == $songid) {
					$juked = true;
					break;
				}
			}

			$xml .= '<frame posn="'. $offset .' -'. (9.45 * $line) .' 1">';
			if ($juked == false) {
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				if ( ($re_config['CurrentMusicInfos']['Artist'] == $song['Artist']) && ($re_config['CurrentMusicInfos']['Title'] == $song['Title']) ) {
					// Current Song
					$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. (-2100 - $song['SongId']) .'" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_PLUS_FOCUS'][0] .'"/>';
					$xml .= '<quad posn="0.4 -0.36 0.03" sizen="16.95 2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
					$xml .= '<format textsize="1" textcolor="FFF8"/>';
				}
				else {
					$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. (-2100 - $song['SongId']) .'" image="'. $re_config['IMAGES'][0]['WIDGET_PLUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_PLUS_FOCUS'][0] .'"/>';
					$xml .= '<quad posn="0.4 -0.36 0.03" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
					$xml .= '<format textsize="1" textcolor="FFFF"/>';
				}
				$xml .= '<label posn="3.2 -0.55 0.04" sizen="17.3 0" textsize="1" text="Song #'. ($i+1) .'"/>';
				$xml .= '<quad posn="0.6 0 0.04" sizen="2.5 2.5" style="'. $re_config['MUSIC_WIDGET'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['MUSIC_WIDGET'][0]['ICON_SUBSTYLE'][0] .'"/>';
				$xml .= '<label posn="1 -3.2 0.04" sizen="17.3 2" textcolor="FC0F" scale="0.6" text="ARTIST"/>';
				$xml .= '<label posn="1 -4 0.04" sizen="17.3 2" scale="0.9" text="'. $song['Artist'] .'"/>';
				$xml .= '<label posn="1 -5.9 0.04" sizen="17.3 2" textcolor="FC0F" scale="0.6" text="TITLE"/>';
				$xml .= '<label posn="1 -6.7 0.04" sizen="17.3 2" scale="0.9" text="'. $song['Title'] .'"/>';
			}
			else {
				$xml .= '<format textsize="1" textcolor="FFF8"/>';
				$xml .= '<quad posn="0 0 0.02" sizen="17.75 9.2" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
				$xml .= '<quad posn="14.15 -5.65 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'19" image="'. $re_config['IMAGES'][0]['WIDGET_MINUS_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_MINUS_FOCUS'][0] .'"/>';
				$xml .= '<quad posn="0.4 -0.36 0.03" sizen="16.95 2" style="Bgs1InRace" substyle="BgListLine"/>';
				$xml .= '<label posn="3.2 -0.55 0.04" sizen="17.3 0" textsize="1" textcolor="000F" text="Song #'. ($i+1) .'"/>';
				$xml .= '<quad posn="0.6 0 0.04" sizen="2.5 2.5" style="BgRaceScore2" substyle="Fame"/>';
				$xml .= '<label posn="1 -3.2 0.04" sizen="17.3 2" textcolor="FC08" scale="0.6" text="ARTIST"/>';
				$xml .= '<label posn="1 -4 0.04" sizen="17.3 2" scale="0.9" text="'. stripColors($song['Artist'], true) .'"/>';
				$xml .= '<label posn="1 -5.9 0.04" sizen="17.3 2" textcolor="FC08" scale="0.6" text="TITLE"/>';
				$xml .= '<label posn="1 -6.7 0.04" sizen="17.3 2" scale="0.9" text="'. stripColors($song['Title'], true) .'"/>';
			}
			$xml .= '</frame>';

			$line ++;

			// Reset lines
			if ($line >= 5) {
				$offset += 19.05;
				$line = 0;
			}
		}
		$xml .= '</frame>';

		$xml .= $re_config['Templates']['WINDOW']->footer;
	}
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildChallengeWidget ($state = 'default', $challenge = false) {
	global $aseco, $re_config;


	if ($re_config['CHALLENGE_WIDGET'][0]['ENABLED'][0] == true) {

		$xml = false;
		if ($state == 'default') {

			// Create the default ChallengeWidget
			$xml = str_replace(
				array(
					'%manialinkid%',
					'%actionid%',
					'%posx%',
					'%posy%',
					'%trackname%',
					'%authortime%',
					'%author%'
				),
				array(
					sprintf("%d%s", $re_config['ManialinkId'], '05'),
					sprintf("%d%s", $re_config['ManialinkId'], '01'),
					$re_config['CHALLENGE_WIDGET'][0]['DEFAULT'][0]['POS_X'][0],
					$re_config['CHALLENGE_WIDGET'][0]['DEFAULT'][0]['POS_Y'][0],
					$re_config['Challenge']['Current']['name'],
					$re_config['Challenge']['Current']['authortime'],
					$re_config['Challenge']['Current']['author']
				),
				$re_config['Templates']['CHALLENGE_DEFAULT']->header
			);
			if ( isset($aseco->server->challenge->tmx->pageurl) ) {
				$xml .= $re_config['Templates']['CHALLENGE_DEFAULT']->tmxbutton;
			}
			$xml .= $re_config['Templates']['CHALLENGE_DEFAULT']->footer;

		}
		else if ($state == 'maximize') {

			// Get Challenge infos for next Challenge
			$re_config['Challenge']['Next'] = re_getNextChallenge();

			// Create the maximized ChallengeWidget
			$xml = str_replace(
				array(
					'%manialinkid%',
					'%actionid%',
					'%posx%',
					'%posy%',
					'%trackname%',
					'%authortime%',
					'%author%',
					'%goldtime%',
					'%silvertime%',
					'%bronzetime%',
					'%nexttrackname%',
					'%nextauthortime%',
					'%nextauthor%',
					'%nextenv%',
					'%nextmood%',
					'%lasttrackname%',
					'%lastauthortime%',
					'%lastauthor%',
					'%lastenv%',
					'%lastmood%'
				),
				array(
					sprintf("%d%s", $re_config['ManialinkId'], '05'),
					sprintf("%d%s", $re_config['ManialinkId'], '02'),
					$re_config['CHALLENGE_WIDGET'][0]['MAXIMIZED'][0]['POS_X'][0],
					$re_config['CHALLENGE_WIDGET'][0]['MAXIMIZED'][0]['POS_Y'][0],
					$re_config['Challenge']['Current']['name'],
					$re_config['Challenge']['Current']['authortime'],
					$re_config['Challenge']['Current']['author'],
					$re_config['Challenge']['Current']['goldtime'],
					$re_config['Challenge']['Current']['silvertime'],
					$re_config['Challenge']['Current']['bronzetime'],
					$re_config['Challenge']['Next']['name'],
					$re_config['Challenge']['Next']['authortime'],
					$re_config['Challenge']['Next']['author'],
					$re_config['Challenge']['Next']['env'],
					$re_config['Challenge']['Next']['mood'],
					$re_config['Challenge']['Last']['name'],
					$re_config['Challenge']['Last']['authortime'],
					$re_config['Challenge']['Last']['author'],
					$re_config['Challenge']['Last']['env'],
					$re_config['Challenge']['Last']['mood']
				),
				$re_config['Templates']['CHALLENGE_MAXIMIZED']->header
			);
			if ( isset($aseco->server->challenge->tmx->pageurl) ) {
				$xml .= $re_config['Templates']['CHALLENGE_MAXIMIZED']->tmxbutton;
			}
			$xml .= $re_config['Templates']['CHALLENGE_MAXIMIZED']->footer;
		}
		else if ($state == 'score') {

			// Challenge infos for next or given Challenge
			if ($challenge == false) {
				$re_config['Challenge']['Next'] = re_getNextChallenge();
				$challenge = $re_config['Challenge']['Next'];
			}

			// Create the maximized ChallengeWidget
			$xml = str_replace(
				array(
					'%manialinkid%',
					'%posx%',
					'%posy%',
					'%nexttrackname%',
					'%nextauthortime%',
					'%nextauthor%',
					'%nextenv%',
					'%nextmood%',
					'%nextgoldtime%',
					'%nextsilvertime%',
					'%nextbronzetime%'
				),
				array(
					sprintf("%d%s", $re_config['ManialinkId'], '05'),
					$re_config['CHALLENGE_WIDGET'][0]['SCORE'][0]['POS_X'][0],
					$re_config['CHALLENGE_WIDGET'][0]['SCORE'][0]['POS_Y'][0],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['name'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['authortime'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['author'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['env'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['mood'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['goldtime'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['silvertime'],
					$re_config['WIDGET_SCORE'][0]['FORMATTING_CODES'][0] . $challenge['bronzetime']
				),
				$re_config['Templates']['CHALLENGE_SCORE']->header
			);
			$xml .= $re_config['Templates']['CHALLENGE_SCORE']->footer;
		}


		if ($xml != false) {
			return $xml;
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildManialinkActionKeys () {
	global $re_config;


	$xml  = '<manialink id="'. $re_config['ManialinkId'] .'01">';
	$xml .= '<quad posn="70 70 1" sizen="0 0" action="382009003" actionkey="3"/>';	// ActionKey F7 for toggle RecordWidgets (same id as fufi.widgets)
	$xml .= '</manialink>';

	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildToplistWindow () {
	global $aseco, $re_config, $re_scores;


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'Icons128x128_1',
			'Rankings',
			'Top Rankings',
			''
		),
		$re_config['Templates']['WINDOW']->header
	);
	$xml .= '<frame posn="2.5 -5.7 1">';	// Content Window

	// Find out if TopBetwins is enabled or has content.
	// If no content, resize Dedimania-/GerymaniaRecords and LocalRecords to fill the space.
	if ( count($re_scores['TopBetwins']) > 0) {
		$pos['height_background']	= 15.43;
		$pos['position_button']		= -11.88;
		$pos['start_position']		= -15.75;	// Only for LocalRecords
		$pos['max_entries']		= 8;
		$pos['line_height']		= 1.75;
	}
	else {
		$pos['height_background']	= 23.34;
		$pos['position_button']		= -19.79;
		$pos['start_position']		= -23.66;	// Only for LocalRecords
		$pos['max_entries']		= 13;
		$pos['line_height']		= 1.7;
	}


	if ($aseco->server->gameinfo->mode != 4) {
		// DedimaniaRecords
		$xml .= '<frame posn="0 0 1">';
		$xml .= '<format textsize="1" textcolor="FFFF"/>';
		$xml .= '<quad posn="0 0 0.02" sizen="17.75 '. $pos['height_background'] .'" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
		$xml .= '<quad posn="14.15 '. $pos['position_button'] .' 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'04" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
		$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
		$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['DEDIMANIA_RECORDS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['DEDIMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0] .'"/>';
		$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['DEDIMANIA_RECORDS'][0]['TITLE'][0]) .'"/>';
		$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
		$rank = 1;
		$line = 0;
		foreach ($re_scores['DedimaniaRecords'] as &$item) {
			$xml .= '<label posn="2.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="6.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="6.6 -'. ($pos['line_height'] * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Display max. $pos['max_entries'] entries, count start from 1
			if ($rank >= $pos['max_entries']) {
				break;
			}
		}
		$xml .= '</frame>';	// Entries
		$xml .= '</frame>';
	}
	else {
		// GerymaniaRecords
		$xml .= '<frame posn="0 0 1">';
		$xml .= '<format textsize="1" textcolor="FFFF"/>';
		$xml .= '<quad posn="0 0 0.02" sizen="17.75 '. $pos['height_background'] .'" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
		$xml .= '<quad posn="14.15 '. $pos['position_button'] .' 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'07" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
		$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
		$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['GERYMANIA_RECORDS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['GERYMANIA_RECORDS'][0]['ICON_SUBSTYLE'][0] .'"/>';
		$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['GERYMANIA_RECORDS'][0]['TITLE'][0]) .'"/>';
		$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
		$rank = 1;
		$line = 0;
		foreach ($re_scores['GerymaniaRecords'] as &$item) {
			$xml .= '<label posn="2.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="6.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
			$xml .= '<label posn="6.6 -'. ($pos['line_height'] * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Display max. $pos['max_entries'] entries, count start from 1
			if ($rank >= $pos['max_entries']) {
				break;
			}
		}
		$xml .= '</frame>';	// Entries
		$xml .= '</frame>';
	}

	// LocalRecords
	$xml .= '<frame posn="0 '. $pos['start_position'] .' 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 '. $pos['height_background'] .'" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 '. $pos['position_button'] .' 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'05" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['LOCAL_RECORDS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['LOCAL_RECORDS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['LOCAL_RECORDS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['LocalRecords'] as &$item) {
		$xml .= '<label posn="2.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. ($pos['line_height'] * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. ($pos['line_height'] * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. $pos['max_entries'] entries, count start from 1
		if ($rank >= $pos['max_entries']) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	if ( count($re_scores['TopBetwins']) > 0) {
		// TopBetwins
		$xml .= '<frame posn="0 -31.50 1">';
		$xml .= '<format textsize="1" textcolor="FFFF"/>';
		$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
		$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'154" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
		$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
		$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['ICON_SUBSTYLE'][0] .'"/>';
		$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_BETWINS'][0]['TITLE'][0]) .'"/>';
		$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
		$rank = 1;
		$line = 0;
		foreach ($re_scores['TopBetwins'] as &$item) {
			$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
			$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['won'] .'"/>';
			$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

			$line ++;
			$rank ++;

			// Display max. 7 entries, count start from 1
			if ($rank >= 8) {
				break;
			}
		}
		$xml .= '</frame>';	// Entries
		$xml .= '</frame>';
	}

	// TopRankings
	$xml .= '<frame posn="19.05 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'10" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_RANKINGS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopRankings'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopWinners
	$xml .= '<frame posn="19.05 -15.75 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'11" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_WINNERS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopWinners'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// MostRecords
	$xml .= '<frame posn="19.05 -31.50 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'12" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_RECORDS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['MostRecords'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// MostFinished
	$xml .= '<frame posn="38.1 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'13" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['MOST_FINISHED'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['MostFinished'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopPlaytime
	$xml .= '<frame posn="38.1 -15.75 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'14" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_PLAYTIME'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopPlaytime'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopDonators
	$xml .= '<frame posn="38.1 -31.50 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'15" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_DONATORS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopDonators'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopTracks
	$xml .= '<frame posn="57.15 0 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'16" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_TRACKS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopTracks'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['karma'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['track'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopVoters
	$xml .= '<frame posn="57.15 -15.75 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'17" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_VOTERS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopVoters'] as &$item) {
		$xml .= '<label posn="2.1 -'. (1.75 * $line) .' 0.01" sizen="2.65 1.7" halign="right" scale="0.9" text="'. $rank .'."/>';
		$xml .= '<label posn="6.1 -'. (1.75 * $line) .' 0.01" sizen="4 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $item['score'] .'"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.01" sizen="9.6 1.7" scale="0.9" text="'. $item['nickname'] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';

	// TopNations
	$xml .= '<frame posn="57.15 -31.50 1">';
	$xml .= '<format textsize="1" textcolor="FFFF"/>';
	$xml .= '<quad posn="0 0 0.02" sizen="17.75 15.43" style="BgsPlayerCard" substyle="BgRacePlayerName"/>';
	$xml .= '<quad posn="14.15 -11.88 0.03" sizen="4 4" action="'. $re_config['ManialinkId'] .'09" image="'. $re_config['IMAGES'][0]['WIDGET_OK_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['WIDGET_OK_FOCUS'][0] .'"/>';
	$xml .= '<quad posn="0.4 -0.36 0.04" sizen="16.95 2" style="BgsPlayerCard" substyle="ProgressBar"/>';
	$xml .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$xml .= '<label posn="3.2 -0.55 0.05" sizen="17.3 0" textsize="1" text="'. utf8_encode($re_config['SCORETABLE_LISTS'][0]['TOP_NATIONS'][0]['TITLE'][0]) .'"/>';
	$xml .= '<frame posn="0 -2.7 0.04">';	// Entries
	$rank = 1;
	$line = 0;
	foreach ($re_scores['TopNations'] as &$item) {
		$xml .= '<label posn="3.15 -'. (1.75 * $line) .' 0.02" sizen="2.65 1.7" halign="right" scale="0.9" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['SCORES'][0] .'" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $item['score'] .'"/>';
		$xml .= '<quad posn="3.9 '. (($line == 0) ? 0.3 : -(1.75 * $line - 0.3)) .' 0.02" sizen="2 2" image="tmtp://Skins/Avatars/Flags/'. (($item['nation'] == 'OTH') ? 'other' : $item['nation']) .'.dds"/>';
		$xml .= '<label posn="6.6 -'. (1.75 * $line) .' 0.02" sizen="11.6 1.7" scale="0.9" text="'. $re_config['WIDGET_RACE'][0]['FORMATTING_CODES'][0] . $re_config['IocNations'][$item['nation']] .'"/>';

		$line ++;
		$rank ++;

		// Display max. 7 entries, count start from 1
		if ($rank >= 8) {
			break;
		}
	}
	$xml .= '</frame>';	// Entries
	$xml .= '</frame>';


	$xml .= '</frame>';	// Content Window
	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildHelpWindow ($page, $player) {
	global $aseco, $re_config;


	// Frame for Previous/Next Buttons
	$buttons = '<frame posn="67.05 -53.2 0">';

	// Previous button
	if ($page == 1) {
		$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" action="-'. $re_config['ManialinkId'] .'160" style="Icons64x64_1" substyle="ArrowPrev"/>';
	}
	else {
		$buttons .= '<quad posn="4.95 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="4.95 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}

	// Next button (display only if more pages to display)
	if ($page == 0) {
		$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" action="'. $re_config['ManialinkId'] .'160" style="Icons64x64_1" substyle="ArrowNext"/>';
	}
	else {
		$buttons .= '<quad posn="8.25 0 0.12" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
		$buttons .= '<quad posn="8.25 0 0.13" sizen="3.2 3.2" style="Icons64x64_1" substyle="StarGold"/>';
	}
	$buttons .= '</frame>';


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			'BgRaceScore2',
			'LadderRank',
			'$L[http://www.undef.de/Trackmania/Plugins/]Records-Eyepiece/'. $re_config['Version'] .'$L for XASECO',
			$buttons
		),
		$re_config['Templates']['WINDOW']->header
	);

	// Set the content
	$xml .= '<frame posn="3 -6 0">';
	$xml .= '<quad posn="60 0 0.11" sizen="12.9 21" image="http://www.bilderload.com/bild/54801/logorecordseyepiecenormal5BAHF.png" imagefocus="http://www.bilderload.com/bild/54800/logorecordseyepiecefocusQKJEC.png" url="http://www.undef.de/Trackmania/Plugins/"/>';

	if ($page == 0) {
		// Begin Help

		// Command "/eyepiece"
		$xml .= '<label posn="0 0 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyepiece"/>';
		$xml .= '<label posn="19 0 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Display this help"/>';

		// Command "/eyepiece hide"
		$xml .= '<label posn="0 -2 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyepiece hide"/>';
		$xml .= '<label posn="19 -2 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Hide the Records-Widgets and store this as your preference"/>';

		// Command "/eyepiece show"
		$xml .= '<label posn="0 -4 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyepiece show"/>';
		$xml .= '<label posn="19 -4 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Show the Records-Widgets and store this as your preference"/>';

		// Command "/togglewidgets"
		$xml .= '<label posn="0 -6 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/togglewidgets $FF0or$FFF F7"/>';
		$xml .= '<label posn="19 -6 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Toggle the display of the Records-Widgets"/>';

		// Command "/elist"
		$xml .= '<label posn="0 -8 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/elist"/>';
		$xml .= '<label posn="19 -8 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Lists tracks currently on the server"/>';

		// Command "/emusic"
		if ($re_config['MUSIC_WIDGET'][0]['ENABLED'][0] == true) {
			$xml .= '<label posn="0 -10 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/emusic"/>';
			$xml .= '<label posn="19 -10 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Lists musics currently on the server"/>';
		}

		// For MasterAdmin Eyes only
		if ($aseco->isMasterAdmin($player)) {
			$xml .= '<label posn="0 -13 0.10" sizen="57 2" textsize="1" textcolor="FF0F" text="Commands for MasterAdmins only:"/>';

			// Command "/eyeset reload"
			$xml .= '<label posn="0 -15 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset reload"/>';
			$xml .= '<label posn="19 -15 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Reloads the records_eyepiece.xml"/>';

			// Command "/eyeset lfresh [INT]"
			$xml .= '<label posn="0 -17 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset lfresh [INT]"/>';
			$xml .= '<label posn="19 -17 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the normal &lt;refresh_interval&gt; sec."/>';

			// Command "/eyeset hfresh [INT]"
			$xml .= '<label posn="0 -19 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset hfresh [INT]"/>';
			$xml .= '<label posn="19 -19 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the nice &lt;refresh_interval&gt; sec."/>';

			// Command "/eyeset llimit [INT]"
			$xml .= '<label posn="0 -21 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset llimit [INT]"/>';
			$xml .= '<label posn="19 -21 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the nice &lt;lower_limit&gt; Players"/>';

			// Command "/eyeset ulimit [INT]"
			$xml .= '<label posn="0 -23 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset ulimit [INT]"/>';
			$xml .= '<label posn="19 -23 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the nice &lt;upper_limit&gt; Players"/>';

			// Command "/eyeset forcenice (true|false)"
			$xml .= '<label posn="0 -25 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset forcenice (true|false)"/>';
			$xml .= '<label posn="19 -25 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the &lt;nicemode&gt;&lt;force&gt;"/>';

			// Command "/eyeset playermarker (true|false)"
			$xml .= '<label posn="0 -27 0.10" sizen="17 2" textsize="1" textcolor="FFFF" text="/eyeset playermarker (true|false)"/>';
			$xml .= '<label posn="19 -27 0.10" sizen="38 2" textsize="1" textcolor="FF0F" text="Set the &lt;features&gt;&lt;mark_online_player_records&gt;"/>';
		}

		if ($re_config['FEATURES'][0]['MARK_ONLINE_PLAYER_RECORDS'][0] == true) {
			$xml .= '<quad posn="-0.3 -38.5 0.10" sizen="2.8 2.8" style="Icons128x128_1" substyle="Solo"/>';
			$xml .= '<label posn="3 -39.2 0.10" sizen="70 0" textsize="1" textcolor="FFFF" text="Marker for an other Player that is currently online at this Server with a record and is ranked before you"/>';

			$xml .= '<quad posn="-0.3 -41.3 0.10" sizen="2.8 2.8" style="Icons128x128_1" substyle="ChallengeAuthor"/>';
			$xml .= '<label posn="3 -42 0.10" sizen="70 0" textsize="1" textcolor="FFFF" text="Marker for an other Player that is currently online at this Server with a record and is ranked behind you"/>';
		}

		$xml .= '<quad posn="0 -44.5 0.10" sizen="2.2 2.2" style="Icons64x64_1" substyle="ArrowNext"/>';
		$xml .= '<label posn="3 -44.8 0.10" sizen="70 0" textsize="1" textcolor="FFFF" text="Marker for your driven record"/>';
	}
	else {
		// Begin About
		$xml .= '<label posn="0 0 0.10" sizen="57 0" autonewline="1" textsize="1" textcolor="FF0F" text="This plugin based upon the well known and good old FuFi.Widgets who accompanied us for years, it was written from scratch to change the look and feel of the Widgets and to make it easier to configure. Also to use the new XASECO features and events for more speed (since 1.12).'. LF.LF .'Some new features are included to have more information available and easily accessible. The famous feature (i think) is the adjustable clock, no more need to calculate the local time from a Server far away! Also included the $FFF$L[http://en.wikipedia.org/wiki/Swatch_Internet_Time]BEAT (the Swatch Internet Time)$L$FF0, that displays the time which is worldwide the same.'. LF.LF .'Another nice feature are the clickable Record-Widgets to display all the driven records and not just a few in the small Widgets.'. LF.LF .'The extended $FFF$L[www.tm-exchange.com]TMX-Trackinfo$L$FF0 Window display more information of a Track as the default currently does and also in a very nice way.'. LF.LF .'The next very nice thing is the Tracklist where you can easily add a Track to the Jukebox. The integrated filter options makes it easy for e.g. list only Tracks with the mood night or only Stadium Tracks or only Tracks from a selected Trackauthor...'. LF.LF .'$OHave fun with the Records-Eyepiece!"/>';
	}
	$xml .= '</frame>';


	$xml .= $re_config['Templates']['WINDOW']->footer;
	return $xml;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_buildWelcomeWindow ($login = false) {
	global $aseco, $re_config;


	$xml = str_replace(
		array(
			'%icon_style%',
			'%icon_substyle%',
			'%window_title%',
			'%prev_next_buttons%'
		),
		array(
			$re_config['WELCOME_WINDOW'][0]['ICON_STYLE'][0],
			$re_config['WELCOME_WINDOW'][0]['ICON_SUBSTYLE'][0],
			'Welcome to '. stripColors($aseco->server->name) .'!',
			''
		),
		$re_config['Templates']['WINDOW']->header
	);

	// Replace line break markers with line break
	$re_config['WELCOME_WINDOW'][0]['MESSAGE'][0] = str_replace('{br}', LF, $re_config['WELCOME_WINDOW'][0]['MESSAGE'][0]);

	// Set the content
	$xml .= '<label posn="3 -6 0.10" sizen="72.4 0" autonewline="1" textsize="1" textcolor="FF0F" text="'. utf8_encode($re_config['WELCOME_WINDOW'][0]['MESSAGE'][0]) .'"/>';

	$xml .= $re_config['Templates']['WINDOW']->footer;

	if ($login != false) {
		// Send it direct to the Player
		re_sendManialink($xml, $login, $re_config['WELCOME_WINDOW'][0]['AUTOHIDE'][0], false);
	}
	else {
		return $xml;
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_loadTemplates () {
	global $re_config;


	$templates = array();

	//--------------------------------------------------------------//
	// BEGIN: Widget for Scoretable Lists				//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %widgetheight%
	// %icon_style%, %icon_substyle%
	// %title%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';
	$header .= '<quad posn="0 0 0.001" sizen="15.5 %widgetheight%" style="'. $re_config['WIDGET_SCORE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_SCORE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';

	// Icon and Title
	$header .= '<quad posn="0.4 -0.36 0.002" sizen="14.7 2" style="'. $re_config['WIDGET_SCORE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_SCORE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 -0.15 0.003" sizen="2.5 2.5" style="%icon_style%" substyle="%icon_substyle%"/>';
	$header .= '<label posn="3.2 -0.5 0.004" sizen="10.2 0" textsize="1" text="%title%"/>';
	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';

	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['SCORETABLE_LISTS']->header = $header;
	$templates['SCORETABLE_LISTS']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Scoretable Lists				//
	//--------------------------------------------------------------//




	//--------------------------------------------------------------//
	// BEGIN: Widget for Challenge (default)			//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %actionid%
	// %trackname%, %authortime%, %author%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';

	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$header .= '<quad posn="0 0 0.01" sizen="20.25 8.65" action="%actionid%" style="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="-0.3 -5.1 0.03" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_LEFT'][0] .'"/>';
	$header .= '<quad posn="0.4 -0.36 0.04" sizen="19.45 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['CURRENT_TRACK'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['CURRENT_TRACK'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="3.2 -0.55 0.05" sizen="18.8 0" textsize="1" text="'. utf8_encode($re_config['CHALLENGE_WIDGET'][0]['TITLE'][0]['CURRENT_TRACK'][0]) .'"/>';
	$header .= '<label posn="1.8 -2.7 0.04" sizen="18.5 2" scale="1" text="%trackname%"/>';
	$header .= '<label posn="1.8 -4.5 0.04" sizen="18.5 2" scale="0.9" text="by %author%"/>';
	$header .= '<quad posn="1.5 -6.25 0.04" sizen="1.7 1.7" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$header .= '<label posn="3.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%authortime%"/>';

	$tmx = '<quad posn="12 -6.05 0.05" sizen="4.4 2.2" halign="right" action="'. sprintf("%d%s", $re_config['ManialinkId'], '08') .'" image="'. $re_config['IMAGES'][0]['TMX_LOGO_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['TMX_LOGO_FOCUS'][0] .'"/>';

	$header .= '<quad posn="0 100 0" sizen="11 5.5" image="'. $re_config['IMAGES'][0]['TMX_LOGO_NORMAL'][0] .'"/>';		// Preload
	$header .= '<quad posn="0 100 0" sizen="11 5.5" image="'. $re_config['IMAGES'][0]['TMX_LOGO_FOCUS'][0] .'"/>';		// Preload
	$header .= '<quad posn="0 100 0.05" sizen="3.5 3.5" image="'. $re_config['IMAGES'][0]['WIDGET_CLOSE_LEFT'][0] .'"/>';	// Preload

	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['CHALLENGE_DEFAULT']->header = $header;
	$templates['CHALLENGE_DEFAULT']->tmxbutton = $tmx;
	$templates['CHALLENGE_DEFAULT']->footer = $footer;

	unset($header, $tmx, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Challenge (default)				//
	//--------------------------------------------------------------//




	//--------------------------------------------------------------//
	// BEGIN: Widget for Challenge (maximized)			//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %actionid%
	// %nexttrackname%, %nextauthortime%, %nextauthor%, %nextenv%, %nextmood%
	// %lasttrackname%, %lastauthortime%, %lastauthor%, %lastenv%, %lastmood%
	// %trackname%, %authortime%, %author%, %goldtime%, %silvertime%, %bronzetime%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 1">';
	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$header .= '<quad posn="0 0 0.01" sizen="59.55 8.65" action="%actionid%" style="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="-0.3 -5.1 0.05" sizen="4 4" image="'. $re_config['IMAGES'][0]['WIDGET_CLOSE_LEFT'][0] .'"/>';

	// Current Challenge
	$header .= '<frame posn="39.3 0 0">';
	$header .= '<quad posn="0.4 -2.35 0.02" sizen="19.45 5.9" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.4 -0.36 0.04" sizen="19.45 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['CURRENT_TRACK'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['CURRENT_TRACK'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="3.2 -0.55 0.05" sizen="18.8 0" textsize="1" text="'. utf8_encode($re_config['CHALLENGE_WIDGET'][0]['TITLE'][0]['CURRENT_TRACK'][0]) .'"/>';
	$header .= '<label posn="1.8 -2.7 0.04" sizen="18.5 2" scale="1" text="%trackname%"/>';
	$header .= '<label posn="1.8 -4.5 0.04" sizen="18.5 2" scale="0.9" text="by %author%"/>';
	$header .= '<quad posn="1.5 -6.25 0.04" sizen="1.7 1.7" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$header .= '<label posn="3.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%authortime%"/>';
	$header .= '</frame>';

	// Next Challenge
	$header .= '<frame posn="19.65 0 0">';
	$header .= '<quad posn="0.4 -2.35 0.02" sizen="19.45 5.9" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.4 -0.36 0.04" sizen="19.45 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['NEXT_TRACK'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['NEXT_TRACK'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="3.2 -0.55 0.05" sizen="18.8 0" textsize="1" text="'. utf8_encode($re_config['CHALLENGE_WIDGET'][0]['TITLE'][0]['NEXT_TRACK'][0]) .'"/>';
	$header .= '<label posn="1.8 -2.7 0.04" sizen="18.5 2" scale="1" text="%nexttrackname%"/>';
	$header .= '<label posn="1.8 -4.5 0.04" sizen="18.5 2" scale="0.9" text="by %nextauthor%"/>';
	$header .= '<quad posn="1.5 -6.25 0.04" sizen="1.7 1.7" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$header .= '<label posn="3.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%nextauthortime%"/>';
	$header .= '<quad posn="7.3 -6.25 0.04" sizen="2 2" style="Icons128x128_1" substyle="Advanced"/>';
	$header .= '<label posn="9.3 -6.55 0.04" sizen="6 2" scale="0.75" text="%nextenv%"/>';
	$header .= '<quad posn="13.5 -6.25 0.04" sizen="2 2" style="Icons128x128_1" substyle="Manialink"/>';
	$header .= '<label posn="15.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%nextmood%"/>';
	$header .= '</frame>';

	// Last Challenge
	$header .= '<frame posn="0 0 0">';
	$header .= '<quad posn="0.4 -2.35 0.02" sizen="19.45 5.9" style="'. $re_config['WIDGET_RACE'][0]['TOP_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TOP_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.4 -0.36 0.04" sizen="19.45 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 0 0.05" sizen="2.5 2.5" style="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['LAST_TRACK'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['LAST_TRACK'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="3.2 -0.55 0.05" sizen="18.8 0" textsize="1" text="'. utf8_encode($re_config['CHALLENGE_WIDGET'][0]['TITLE'][0]['LAST_TRACK'][0]) .'"/>';
	$header .= '<label posn="1.8 -2.7 0.04" sizen="18.5 2" scale="1" text="%lasttrackname%"/>';
	$header .= '<label posn="1.8 -4.5 0.04" sizen="18.5 2" scale="0.9" text="by %lastauthor%"/>';
	$header .= '<quad posn="1.5 -6.25 0.04" sizen="1.7 1.7" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$header .= '<label posn="3.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%lastauthortime%"/>';
	$header .= '<quad posn="7.3 -6.25 0.04" sizen="2 2" style="Icons128x128_1" substyle="Advanced"/>';
	$header .= '<label posn="9.3 -6.55 0.04" sizen="6 2" scale="0.75" text="%lastenv%"/>';
	$header .= '<quad posn="13.5 -6.25 0.04" sizen="2 2" style="Icons128x128_1" substyle="Manialink"/>';
	$header .= '<label posn="15.5 -6.55 0.04" sizen="6 2" scale="0.75" text="%lastmood%"/>';
	$header .= '</frame>';

	$tmx  = '<frame posn="39.3 0 0">';
	$tmx .= '<quad posn="12 -6.05 0.05" sizen="4.4 2.2" halign="right" action="'. sprintf("%d%s", $re_config['ManialinkId'], '08') .'" image="'. $re_config['IMAGES'][0]['TMX_LOGO_NORMAL'][0] .'" imagefocus="'. $re_config['IMAGES'][0]['TMX_LOGO_FOCUS'][0] .'"/>';
	$tmx .= '</frame>';

	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['CHALLENGE_MAXIMIZED']->header = $header;
	$templates['CHALLENGE_MAXIMIZED']->tmxbutton = $tmx;
	$templates['CHALLENGE_MAXIMIZED']->footer = $footer;

	unset($header, $tmx, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Challenge (maximized)			//
	//--------------------------------------------------------------//




	//--------------------------------------------------------------//
	// BEGIN: Widget for Challenge (score)				//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %nexttrackname%, %nextauthor%, %nextenv%, %nextmood%, %nextauthortime%, %nextgoldtime%, %nextsilvertime%, %nextbronzetime%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';

	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_SCORE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';
	$header .= '<quad posn="0 0 0.001" sizen="17.6 14.1" style="'. $re_config['WIDGET_SCORE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_SCORE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';

	// Icon and Title
	$header .= '<quad posn="0.4 -0.36 0.002" sizen="16.8 2" style="'. $re_config['WIDGET_SCORE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_SCORE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="0.6 -0.15 0.003" sizen="2.5 2.5" style="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['NEXT_TRACK'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['CHALLENGE_WIDGET'][0]['ICONS'][0]['NEXT_TRACK'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="3.2 -0.5 0.004" sizen="10.2 0" text="'. utf8_encode($re_config['CHALLENGE_WIDGET'][0]['TITLE'][0]['NEXT_TRACK'][0]) .'"/>';

	// Challenge Name
	$header .= '<label posn="1.35 -3 0.11" sizen="15 2" text="%nexttrackname%"/>';

	// Frame for the Trackinfo "Details"
	$header .= '<frame posn="0.5 -10 0">';
	$header .= '<label posn="0.85 5 0.11" sizen="14.5 2" scale="0.9" text="by %nextauthor%"/>';
	$header .= '<quad posn="2.95 3.38 0.11" sizen="2.5 2.5" halign="right" style="Icons128x128_1" substyle="Advanced"/>';
	$header .= '<label posn="3.3 2.9 0.11" sizen="12 2" scale="0.9" text="%nextenv%"/>';
	$header .= '<quad posn="11.1 3.53 0.11" sizen="2.6 2.6" halign="right" style="Icons128x128_1" substyle="Manialink"/>';
	$header .= '<label posn="11.3 2.9 0.11" sizen="12 2" scale="0.9" text="%nextmood%"/>';
	$header .= '</frame>';

	// Frame for the Trackinfo "Times"
	$header .= '<frame posn="0.5 -14.3 0">';
	$header .= '<quad posn="2.75 5.25 0.11" sizen="2 2" halign="right" style="BgRaceScore2" substyle="ScoreReplay"/>';
	$header .= '<label posn="3.3 5 0.11" sizen="6 2" scale="0.9" text="%nextauthortime%"/>';
	$header .= '<quad posn="2.75 3.1 0.11" sizen="1.9 1.9" halign="right" style="MedalsBig" substyle="MedalGold"/>';
	$header .= '<label posn="3.3 2.9 0.11" sizen="6 2" scale="0.9" text="%nextgoldtime%"/>';
	$header .= '<quad posn="10.75 5.1 0.11" sizen="1.9 1.9" halign="right" style="MedalsBig" substyle="MedalSilver"/>';
	$header .= '<label posn="11.3 5 0.11" sizen="6 2" scale="0.9" text="%nextsilvertime%"/>';
	$header .= '<quad posn="10.75 3.1 0.11" sizen="1.9 1.9" halign="right" style="MedalsBig" substyle="MedalBronze"/>';
	$header .= '<label posn="11.3 2.9 0.11" sizen="6 2" scale="0.9" text="%nextbronzetime%"/>';
	$header .= '</frame>';

	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['CHALLENGE_SCORE']->header = $header;
	$templates['CHALLENGE_SCORE']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Challenge (score)				//
	//--------------------------------------------------------------//




	//--------------------------------------------------------------//
	// BEGIN: Widget for Clock					//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %actionid%
	// %background_style%, %background_substyle%
	// %time%, %timezone%
	// %beat%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';
	$header .= '<format textsize="1"/>';

	// Content
	$header .= '<quad posn="0 0 0.001" sizen="4.6 6.5" action="%actionid%" style="%background_style%" substyle="%background_substyle%"/>';
	$header .= '<label posn="2.3 -0.6 0.1" sizen="6 2" halign="center" text="%time%"/>';
	$header .= '<label posn="2.3 -2.1 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['CLOCK_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="%timezone%"/>';
	$header .= '<label posn="2.3 -3.4 0.1" sizen="6 2" halign="center" text="%beat%"/>';
	$header .= '<label posn="2.3 -4.9 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['CLOCK_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="BEAT"/>';
	$header .= '<quad posn="0 100 0" sizen="7.2 4.34" image="'. $re_config['IMAGES'][0]['WORLDMAP'][0] .'"/>';	// Preload


	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['CLOCK']->header = $header;
	$templates['CLOCK']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Clock					//
	//--------------------------------------------------------------//




	//--------------------------------------------------------------//
	// BEGIN: Widget for Scoretable					//
	//--------------------------------------------------------------//
	$content  = '<manialink id="'. $re_config['ManialinkId'] .'10">';
	$content .= '<frame posn="'. $re_config['TOPLIST_WIDGET'][0]['POS_X'][0] .' '. $re_config['TOPLIST_WIDGET'][0]['POS_Y'][0] .' 0">';
	$content .= '<format textsize="1"/>';
	$content .= '<quad posn="0 0 0.001" sizen="4.6 6.5" action="'. $re_config['ManialinkId'] .'153" style="'. $re_config['TOPLIST_WIDGET'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['TOPLIST_WIDGET'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';
	$content .= '<quad posn="-0.18 -4.6 0.002" sizen="2.1 2.1" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_SMALL'][0] .'"/>';
	$content .= '<quad posn="0.7 -0.3 0.002" sizen="3.35 3" style="Icons128x128_1" substyle="Rankings"/>';
	$content .= '<label posn="2.3 -3.4 0.1" sizen="6.35 2" halign="center" scale="0.95" text="MORE"/>';
	$content .= '<label posn="2.3 -4.9 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['TOPLIST_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="RANKING"/>';
	$content .= '</frame>';
	$content .= '</manialink>';

	$templates['TOPLISTWIDGET']->content = $content;

	unset($content);
	//--------------------------------------------------------------//
	// END: Widget for Scoretable					//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: Widget for Gamemode					//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %posx%, %posy%
	// %background_style%, %background_substyle%
	// %icon_style%, %icon_substyle%
	// %limits%
	// %gamemode%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';
	$header .= '<format textsize="1"/>';
	$header .= '<quad posn="0 0 0.001" sizen="4.6 6.5" style="%background_style%" substyle="%background_substyle%"/>';
	$header .= '<quad posn="0.7 -0.3 0.002" sizen="2.9 2.9" style="%icon_style%" substyle="%icon_substyle%"/>';
	$header .= '<label posn="2.3 -4.9 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['GAMEMODE_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="%gamemode%"/>';
	$header .= '</frame>';

	$limits  = '<frame posn="%posx% %posy% 0">';
	$limits .= '<label posn="2.3 -3.4 0.1" sizen="6.35 2" halign="center" scale="0.6" text="%limits%"/>';
	$limits .= '</frame>';

	$footer  = '</manialink>';

	$templates['GAMEMODE']->header = $header;
	$templates['GAMEMODE']->limits = $limits;
	$templates['GAMEMODE']->footer = $footer;

	unset($header, $limits, $footer);
	//--------------------------------------------------------------//
	// END: Widget for Gamemode					//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: Widget for Visitors					//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %action%
	// %posx%, %posy%
	// %background_style%, %background_substyle%
	// %visitorcount%
	$content  = '<manialink id="%manialinkid%">';
	$content .= '<frame posn="%posx% %posy% 0">';
	$content .= '<format textsize="1"/>';
	$content .= '<quad posn="0 0 0.001" sizen="4.6 6.5" action="%action%" style="%background_style%" substyle="%background_substyle%"/>';
	$content .= '<quad posn="-0.18 -4.6 0.002" sizen="2.1 2.1" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_SMALL'][0] .'"/>';
	$content .= '<quad posn="0.7 -0.3 0.002" sizen="3.2 3.2" style="Icons128x128_1" substyle="Solo"/>';
	$content .= '<label posn="2.3 -3.4 0.1" sizen="3.65 2" halign="center" text="%visitorcount%"/>';
	$content .= '<label posn="2.3 -4.9 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['VISITORS_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="VISITORS"/>';
	$content .= '</frame>';
	$content .= '</manialink>';

	$templates['VISITORS']->content = $content;

	unset($content);
	//--------------------------------------------------------------//
	// END: Widget for Visitors					//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: Widget for Trackcount					//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %action%
	// %posx%, %posy%
	// %background_style%, %background_substyle%
	// %trackcount%
	$content  = '<manialink id="%manialinkid%">';
	$content .= '<frame posn="%posx% %posy% 0">';
	$content .= '<format textsize="1"/>';
	$content .= '<quad posn="0 0 0.001" sizen="4.6 6.5" action="%action%" style="%background_style%" substyle="%background_substyle%"/>';
	$content .= '<quad posn="-0.18 -4.6 0.002" sizen="2.1 2.1" image="'. $re_config['IMAGES'][0]['WIDGET_OPEN_SMALL'][0] .'"/>';
	$content .= '<quad posn="0.4 0 0.002" sizen="3.8 3.8" style="Icons128x128_1" substyle="LoadTrack"/>';
	$content .= '<label posn="2.3 -3.4 0.1" sizen="3.65 2" halign="center" text="%trackcount%"/>';
	$content .= '<label posn="2.3 -4.9 0.1" sizen="6.35 2" halign="center" textcolor="'. $re_config['TRACKCOUNT_WIDGET'][0]['TEXT_COLOR'][0] .'" scale="0.6" text="TRACKS"/>';
	$content .= '</frame>';
	$content .= '</manialink>';

	$templates['TRACKCOUNT']->content = $content;

	unset($content);
	//--------------------------------------------------------------//
	// END: Widget for Trackcount					//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: Widget for MusicInfo					//
	//--------------------------------------------------------------//
	// %posx%, %posy%
	// %widgetwidth%
	// %title_background_width%
	// %actionid%
	// %image_open_pos_x%, %image_open_pos_y%, %image_open%
	// %posx_icon%, %posy_icon%
	// %posx_title%, %posy_title%
	// %halign%, %title%
	$header  = '<frame posn="%posx% %posy% 0">';
	$header .= '<quad posn="0 0 0.001" sizen="%widgetwidth% 8.3" action="%actionid%" style="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="%image_open_pos_x% %image_open_pos_y% 0.05" sizen="3.5 3.5" image="%image_open%"/>';

	// Icon and Title
	$header .= '<quad posn="0.4 -0.36 0.002" sizen="%title_background_width% 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="%posx_icon% %posy_icon% 0.003" sizen="2.5 2.5" style="'. $re_config['MUSIC_WIDGET'][0]['ICON_STYLE'][0] .'" substyle="'. $re_config['MUSIC_WIDGET'][0]['ICON_SUBSTYLE'][0] .'"/>';
	$header .= '<label posn="%posx_title% %posy_title% 0.004" sizen="10.2 0" halign="%halign%" textsize="1" text="%title%"/>';
	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';

	$footer  = '</frame>';

	$templates['MUSICINFO']->header = $header;
	$templates['MUSICINFO']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: Widget for MusicInfo					//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: RecordWidgets (Dedimania, Gerymania, Locals, Live)	//
	//--------------------------------------------------------------//
	// %manialinkid%
	// %actionid%
	// %posx%, %posy%
	// %widgetwidth%, %widgetheight%
	// %title_background_width%
	// %image_open_pos_x%, %image_open_pos_y%, %image_open%
	// %posx_icon%, %posy_icon%, %icon_style%, %icon_substyle%
	// %posx_title%, %posy_title%
	// %halign%, %title%
	$header  = '<manialink id="%manialinkid%">';
	$header .= '<frame posn="%posx% %posy% 0">';

	$header .= '<quad posn="0 0 0.001" sizen="%widgetwidth% %widgetheight%" action="%actionid%" style="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['BACKGROUND_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="%image_open_pos_x% %image_open_pos_y% 0.05" sizen="3.5 3.5" image="%image_open%"/>';

	// Icon and Title
	$header .= '<quad posn="0.4 -0.36 0.002" sizen="%title_background_width% 2" style="'. $re_config['WIDGET_RACE'][0]['TITLE_STYLE'][0] .'" substyle="'. $re_config['WIDGET_RACE'][0]['TITLE_SUBSTYLE'][0] .'"/>';
	$header .= '<quad posn="%posx_icon% %posy_icon% 0.003" sizen="2.5 2.5" style="%icon_style%" substyle="%icon_substyle%"/>';
	$header .= '<label posn="%posx_title% %posy_title% 0.004" sizen="10.2 0" halign="%halign%" textsize="1" text="%title%"/>';
	$header .= '<format textsize="1" textcolor="'. $re_config['WIDGET_RACE'][0]['COLORS'][0]['DEFAULT'][0] .'"/>';

	$footer  = '</frame>';
	$footer .= '</manialink>';

	$templates['RECORD_WIDGETS']->header = $header;
	$templates['RECORD_WIDGETS']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: RecordWidgets (Dedimania, Gerymania, Locals, Live)	//
	//--------------------------------------------------------------//



	//--------------------------------------------------------------//
	// BEGIN: Window						//
	//--------------------------------------------------------------//
	// %icon_style%, %icon_substyle%
	// %window_title%
	// %prev_next_buttons%
	$header  = '<manialink id="'. $re_config['ManialinkId'] .'00">';
	if ($re_config['WINDOW_STYLE'][0]['LIGHTBOX'][0]['ENABLED'][0] == true) {
		$header .= '<quad posn="-64 48 19.99" sizen="128 96" bgcolor="'. $re_config['WINDOW_STYLE'][0]['LIGHTBOX'][0]['BGCOLOR'][0] .'"/>';
	}
	$header .= '<frame posn="-40.1 30.45 20">';	// BEGIN: Window Frame
	$header .= '<quad posn="0.8 -0.8 0.01" sizen="78.4 53.7" bgcolor="'. $re_config['WINDOW_STYLE'][0]['WINDOW_BGCOLOR'][0] .'"/>';
	$header .= '<quad posn="-0.2 0.2 0.09" sizen="80.4 55.7" style="Bgs1InRace" substyle="BgCard3"/>';

	// Header Line
	$header .= '<quad posn="0.8 -1.3 0.02" sizen="78.4 3" bgcolor="'. $re_config['WINDOW_STYLE'][0]['HEADLINE_BGCOLOR'][0] .'"/>';
	$header .= '<quad posn="0.8 -4.3 0.03" sizen="78.4 0.1" bgcolor="FFF9"/>';
	$header .= '<quad posn="1.8 -1 0.10" sizen="3.2 3.2" style="%icon_style%" substyle="%icon_substyle%"/>';

	// Title
	$header .= '<label posn="5.5 -1.8 0.10" sizen="74 0" halign="left" textsize="2" scale="0.9" textcolor="'. $re_config['WINDOW_STYLE'][0]['HEADLINE_TEXTCOLOR'][0] .'" text="%window_title%"/>';

	// Close Button
	$header .= '<frame posn="77.4 1.3 0">';
	$header .= '<quad posn="0 0 0.10" sizen="4 4" style="Icons64x64_1" substyle="ArrowDown"/>';
	$header .= '<quad posn="1.1 -1.35 0.11" sizen="1.8 1.75" bgcolor="EEEF"/>';
	$header .= '<quad posn="0.65 -0.7 0.12" sizen="2.6 2.6" action="'. sprintf("%d%s", $re_config['ManialinkId'], '00') .'" style="Icons64x64_1" substyle="Close"/>';
	$header .= '</frame>';

	$header .= '%prev_next_buttons%';

	// Footer
	$footer  = '</frame>';				// END: Window Frame
	$footer .= '</manialink>';

	$templates['WINDOW']->header = $header;
	$templates['WINDOW']->footer = $footer;

	unset($header, $footer);
	//--------------------------------------------------------------//
	// END: Window							//
	//--------------------------------------------------------------//



	return $templates;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_calculateClock ($timezone) {
	global $re_config;


	// Calculate Timeformat with the given Timezone
	$zone_curr = new DateTimeZone(date_default_timezone_get());
	$date_curr = new DateTime('now', $zone_curr);
	$zone_want = new DateTimeZone($timezone);
	$date_want = new DateTime('now', $zone_want);
	if ( $zone_curr->getOffset($date_want) != $zone_want->getOffset($date_curr) ) {
		$date = new DateTime('now', $zone_curr);
		$date->setTimezone($zone_want);
		$timeformat = $date->format($re_config['CLOCK_WIDGET'][0]['TIMEFORMAT'][0]);
		$tz = $date->getTimezone()->getTransitions();
		if ( isset($tz[0]) ) {
			$timezone = $tz[0]['abbr'];
		}
		else {
			$timezone = 'UNKNOWN';
		}
	}
	else {
		$timeformat = date($re_config['CLOCK_WIDGET'][0]['TIMEFORMAT'][0], time());
		$timezone = date('T', time());
	}

	return array('timeformat' => $timeformat, 'timezone' => $timezone);
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_checkServerLoad () {
	global $aseco, $re_config;


	if ( ($re_config['NICEMODE'][0]['ENABLED'][0] == true) && ($re_config['NICEMODE'][0]['FORCE'][0] == false) ) {

		// Get Playercount
		$player_count = count($aseco->server->players->player_list);

		// Check Playercount and if to high, switch to nicemode
		if ( ($re_config['States']['NiceMode'] == false) && ($player_count >= $re_config['NICEMODE'][0]['LIMITS'][0]['UPPER_LIMIT'][0]) ) {

			// Turn nicemode on
			$re_config['States']['NiceMode'] = true;

			// Set new refresh interval
			$re_config['REFRESH_INTERVAL'][0] = $re_config['NICEMODE'][0]['REFRESH_INTERVAL'][0];
		}
		else if ( ($re_config['States']['NiceMode'] == true) && ($player_count <= $re_config['NICEMODE'][0]['LIMITS'][0]['LOWER_LIMIT'][0]) ) {

			// Turn nicemode off
			$re_config['States']['NiceMode'] = false;

			// Make sure that all preferences at all Players are loaded
			re_loadPlayerPreferences(false);

			// Restore default refresh interval
			$re_config['REFRESH_INTERVAL'][0] = $re_config['REFRESH_INTERVAL_DEFAULT'][0];
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_loadPlayerPreferences ($login = false) {
	global $aseco, $re_config;


	// Bail out if there are no Players
	if (count($aseco->server->players->player_list) == 0) {
		return;
	}

	if ($login != false) {

		// Get the Player object
		$player = $aseco->server->players->player_list[$login];

		// Set PlayerId (from Database), cache the Id here for later use
		$player->data['RecordsEyepieceDatabasePlayerId'] = $aseco->getPlayerId( $player->login );

		// Get Player preferences for Clock-Widget
		$timezone = false;
		$displaywidgets = false;
		$query = "SELECT `timezone`,`displaywidgets` FROM `players_extra` WHERE `playerID`='". $player->data['RecordsEyepieceDatabasePlayerId'] ."';";
		$res = mysql_query($query);
		if ( ($res) && (mysql_num_rows($res) > 0) ) {
			$row = mysql_fetch_object($res);
			$timezone	= ((($row->timezone != '') || ($row->timezone == 'NULL')) ? $row->timezone : false);
			$displaywidgets	= $row->displaywidgets;
		}
		mysql_free_result($res);

		if ($timezone != false) {
			$tmp = explode('|', $timezone);
			$player->data['RecordsEyepiecePlayerTimezone']->display = $tmp[0];
			$player->data['RecordsEyepiecePlayerTimezone']->realname = $tmp[1];
		}
		else {
			$player->data['RecordsEyepiecePlayerTimezone']->display = $re_config['CLOCK_WIDGET'][0]['DEFAULT_TIMEZONE'][0];
			$player->data['RecordsEyepiecePlayerTimezone']->realname = $re_config['CLOCK_WIDGET'][0]['DEFAULT_TIMEZONE'][0];
		}

		if ($displaywidgets != false) {
			$player->data['RecordsEyepieceWidgetPreference'] = ((strtoupper($displaywidgets) == 'TRUE') ? true : false);
		}
		else {
			$player->data['RecordsEyepieceWidgetPreference'] = false;
		}

	}
	else {

		// Get Player preferences for Clock-Widget for all Players
		$timezone = false;
		$displaywidgets = false;
		$query = "SELECT `playerID`,`timezone`,`displaywidgets` FROM `players_extra` WHERE `playerID` IN (";
		foreach ($aseco->server->players->player_list as &$player) {

			// Skip if already loaded
			if ( isset($player->data['RecordsEyepiecePlayerTimezone']->display) ) {
				continue;
			}

			// Set PlayerId (from Database), cache the Id here for later use
			$player->data['RecordsEyepieceDatabasePlayerId'] = $aseco->getPlayerId( $player->login );

			$query .= "'". $player->data['RecordsEyepieceDatabasePlayerId'] ."',";
		}
		// remove trailing ,
		$query = substr($query, 0, strlen($query)-1);
		$query .= ");";

		$res = mysql_query($query);
		if ( ($res) && (mysql_num_rows($res) > 0) ) {
			$row = mysql_fetch_object($res);

			foreach ($aseco->server->players->player_list as &$player) {
				if ($player->data['RecordsEyepieceDatabasePlayerId'] == $row->playerID) {
					$timezone	= ((($row->timezone != '') || ($row->timezone == 'NULL')) ? $row->timezone : false);
					$displaywidgets	= $row->displaywidgets;

					if ($timezone != false) {
						$tmp = explode('|', $timezone);
						$player->data['RecordsEyepiecePlayerTimezone']->display = $tmp[0];
						$player->data['RecordsEyepiecePlayerTimezone']->realname = $tmp[1];
					}
					else {
						$player->data['RecordsEyepiecePlayerTimezone']->display = $re_config['CLOCK_WIDGET'][0]['DEFAULT_TIMEZONE'][0];
						$player->data['RecordsEyepiecePlayerTimezone']->realname = $re_config['CLOCK_WIDGET'][0]['DEFAULT_TIMEZONE'][0];
					}

					if ($displaywidgets != false) {
						$player->data['RecordsEyepieceWidgetPreference'] = ((strtoupper($displaywidgets) == 'TRUE') ? true : false);
					}
					else {
						$player->data['RecordsEyepieceWidgetPreference'] = false;
					}
				}
			}
		}
		mysql_free_result($res);

	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getNextChallenge () {
	global $aseco, $re_config;


	// Set $filename to false to see where or if a Challenge is found
	$filename = false;

	// Is a Challenge in the Jukebox?
	if ($re_config['Challenge']['Jukebox'] != false) {
		$filename = $re_config['Challenge']['Jukebox']['FileName'];
	}

	// Was a Challenge in the Jukebox? If not, ask the Dedicated-Server which Challenge is next.
	if ($filename == false) {

		$aseco->client->query('GetNextChallengeIndex');
		$next_index = $aseco->client->getResponse();

		// Do GetChallengeList() and send it the next index, this way you avoid looping through data to find the right one later
		$aseco->client->query('GetChallengeList', 1, $next_index);
		$nextchallenge = $aseco->client->getResponse();

		$filename = $nextchallenge[0]['FileName'];
	}

	if ($filename != false) {

		// Parse the GBX Challenge file
		$challenge = new GBXChallengeFetcher($aseco->server->trackdir . $filename, false);

		$next = array();
		$next['name']		= re_handleSpecialChars($challenge->name);
		$next['author']		= re_handleSpecialChars($challenge->author);
		$next['uid']		= $challenge->uid;
		$next['env']		= $challenge->envir;
		$next['mood']		= $challenge->mood;
		if ($aseco->server->gameinfo->mode == 4) {
			// 'Stunts' GameMode
			$next['authortime']	= $challenge->ascore;			// AuthorScore
			$next['goldtime']	= $challenge->goldtm;
			$next['silvertime']	= $challenge->silvertm;
			$next['bronzetime']	= $challenge->bronzetm;
		}
		else {
			// All other GameModes
			$next['authortime']	= formatTime($challenge->authortm);	// AuthorTime
			$next['goldtime']	= formatTime($challenge->goldtm);
			$next['silvertime']	= formatTime($challenge->silvertm);
			$next['bronzetime']	= formatTime($challenge->bronzetm);
		}
		return $next;
	}
	else {
		return re_getEmptyChallengeInfo();
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getTracklist () {
	global $aseco, $re_config, $re_cache;


	$trackinfos = array();
	$aseco->client->resetError();
	$aseco->client->query('GetChallengeList', 5000, 0);
	$trackinfos = $aseco->client->getResponse();

	if ( $aseco->client->isError() ) {
		trigger_error('[plugin.records_eyepiece.php] Error at GetChallengeList(): ['. $aseco->client->getErrorCode() .'] '. $aseco->client->getErrorMessage(), E_USER_WARNING);
		return;
	}

	if ( !empty($trackinfos) ) {

		// Init environment/mood counter
		$re_cache['TracklistCounts']['Environment'] = array(
			'STADIUM'	=> 0,
			'BAY'		=> 0,
			'COAST'		=> 0,
			'DESERT'	=> 0,
			'ISLAND'	=> 0,
			'RALLY'		=> 0,
			'ALPINE'	=> 0
		);
		$re_cache['TracklistCounts']['Mood'] = array(
			'SUNRISE'	=> 0,
			'DAY'		=> 0,
			'SUNSET'	=> 0,
			'NIGHT'		=> 0
		);
		$re_cache['TracklistCounts']['Type'] = array(
			'PLATFORM'	=> 0,
			'PUZZLE'	=> 0,
			'RACE'		=> 0,
			'STUNTS'	=> 0
		);

		// Clean up before filling
		$re_cache['Tracklist'] = array();
		$re_cache['TrackAuthors'] = array();

		foreach ($trackinfos as &$tinfo) {

			// Parse the GBX Challenge file
			$gbx = new GBXChallengeFetcher($aseco->server->trackdir . $tinfo['FileName'], false, false);
			if (!$gbx->uid) {
				trigger_error('[plugin.records_eyepiece.php] Could not read Track ['. $aseco->server->trackdir . $tinfo['FileName'] .'] at getTracklist()', E_USER_WARNING);

				// Ignore if Track could not be parsed
				continue;
			}

			$track = array();
			$track['name']		= re_handleSpecialChars($gbx->name);
			$track['name_clean']	= stripColors($gbx->name, true);		// stripColors() from basic.inc.php
			$track['author']	= $gbx->author;
			$track['uid']		= $gbx->uid;
			$track['mood']		= $gbx->mood;					// Sunrise, Day, Sunset, Night
			$track['multilap']	= $gbx->multi;					// true, false
			$track['file']		= $tinfo['FileName'];

			if (strtoupper($gbx->envir) == 'SPEED') {
				// 'Speed' same as 'Desert'
				$track['env'] = 'Desert';
			}
			else if (strtoupper($gbx->envir) == 'SNOW') {
				// 'Snow' same as 'Alpine'
				$track['env'] = 'Alpine';
			}
			else {
				$track['env'] = $gbx->envir;
			}

			if ($aseco->server->gameinfo->mode == 4) {
				// 'Stunts' GameMode
				$track['authortime']		= $gbx->ascore;			// AuthorScore
				$track['goldtime']		= $gbx->goldtm;
				$track['silvertime']		= $gbx->silvertm;
				$track['bronzetime']		= $gbx->bronzetm;

				// Unformated for Tracklist-Filter
				$track['authortime_filter']	= $gbx->authortm;		// AuthorScore
				$track['goldtime_filter']	= $gbx->goldtm;
				$track['silvertime_filter']	= $gbx->silvertm;
				$track['bronzetime_filter']	= $gbx->bronzetm;
			}
			else {
				// All other GameModes
				$track['authortime']		= formatTime($gbx->authortm);	// AuthorTime
				$track['goldtime']		= formatTime($gbx->goldtm);
				$track['silvertime']		= formatTime($gbx->silvertm);
				$track['bronzetime']		= formatTime($gbx->bronzetm);

				// Unformated for Tracklist-Filter
				$track['authortime_filter']	= $gbx->authortm;		// AuthorTime
				$track['goldtime_filter']	= $gbx->goldtm;
				$track['silvertime_filter']	= $gbx->silvertm;
				$track['bronzetime_filter']	= $gbx->bronzetm;
			}

			// Add to the Tracklist
			$re_cache['Tracklist'][] = $track;

			// Add the TrackAuthor to the list
			$re_cache['TrackAuthors'][] = $track['author'];

			// Count this environment for Tracklistfilter
			$re_cache['TracklistCounts']['Environment'][strtoupper($track['env'])] ++;

			// Count this mood for Tracklistfilter
			$re_cache['TracklistCounts']['Mood'][strtoupper($track['mood'])] ++;
		}

		if (count($re_cache['Tracklist']) > 0) {
			if ($re_config['FEATURES'][0]['SORT_TRACKLIST'][0] == true) {

				// Now sort Tracklist by author and track
				$name = array();
				$author = array();
				foreach ($re_cache['Tracklist'] as $key => $row) {
					$name[$key]	= $row['name_clean'];
					$author[$key]	= $row['author'];
				}

				array_multisort($author, SORT_ASC, $name, SORT_ASC, $re_cache['Tracklist']);
			}

			// Now add an ID for each Track
			$i = 0;
			foreach ($re_cache['Tracklist'] as &$track) {
				$track['id'] = $i;
				$i ++;
			}
		}

		if (count($re_cache['TrackAuthors']) > 0) {
			// Make the TrackAuthors list unique and sort them
			$re_cache['TrackAuthors'] = array_unique($re_cache['TrackAuthors'], SORT_STRING);
			natcasesort($re_cache['TrackAuthors']);
			$re_cache['TrackAuthors'] = array_values($re_cache['TrackAuthors']);
		}
	}
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_getEmptyChallengeInfo () {


	// Create an empty Challenge Info, because at startup the player joins before a challenge is known
	$next = array();
	$next['name']		= '???';
	$next['authortime']	= '???';
	$next['author']		= '???';
	$next['env']		= '???';
	$next['mood']		= '???';
	$next['goldtime']	= '???';
	$next['silvertime']	= '???';
	$next['bronzetime']	= '???';
	return $next;
}

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

function re_handleSpecialChars ($string) {


	// Remove links, e.g. "$(L|H)[...]...$(L|H)"
	$string = preg_replace('/\${1}(L|H)\[.*?\](.*?)\$(L|H)/i', '$2', $string);
	$string = preg_replace('/\${1}(L|H)\[.*?\](.*?)/i', '$2', $string);

	// Remove $S (shadow)
	// Remove $H (manialink)
	// Remove $W (wide)
	// Remove $I (italic)
	// Remove $L (link)
	// Remove $O (bold)
	// Remove $N (narrow)
	$string = preg_replace('/\${1}[SHWILON]/i', '', $string);

	// Convert &
	// Convert "
	// Convert '
	// Convert >
	// Convert <
	$string = str_replace(
			array(
				'&',
				'"',
				"'",
				'>',
				'<'
			),
			array(
				'&amp;',
				'&quot;',
				'&apos;',
				'&gt;',
				'&lt;'
			),
			$string
	);
	$string = stripNewlines($string);	// stripNewlines() from basic.inc.php

	return validateUTF8String($string);	// validateUTF8String() from basic.inc.php
}

?>
